<?php

namespace app\controllers;

use app\models\Config;
use Yii;
use yii\filters\VerbFilter;
use yii\web\Controller;

/**
 * ConfigController implements the CRUD actions for Config model.
 */
class ApkController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        $requestroute = Yii::$app->requestedRoute;
        $editurl = '/' . $requestroute;
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],

        ];
    }

    public function downloadFile($fullpath)
    {

        if (!empty($fullpath)) {
            header("Content-type:application/pdf"); //for pdf file
            //header('Content-Type:text/plain; charset=ISO-8859-15');
            //if you want to read text file using text/plain header
            header('Content-Disposition: attachment; filename="' . basename($fullpath) . '"');
            header('Content-Length: ' . filesize($fullpath));
            readfile($fullpath);
            Yii::app()->end();
        }
    }

    public function actionDownload()
    {
        // $path = Yii::getPathOfAlias('webroot')."/apk/rda.apk";
        $path = Yii::getAlias('@webroot') . "/apk/rda.apk";
        $this->downloadFile($path);
    }

}
