<?php

namespace app\controllers;

use Yii;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use Picqer\Barcode\BarcodeGeneratorPNG;
use app\models\Booth;
use app\models\Barcode;
use app\models\BarcodeSearch;
use Mpdf\Mpdf;


class BarcodeGeneratorController extends Controller
{
    public function actionIndex()
    {
    
        $models = Barcode::find()->where(['status' => 1])->orderBy(['created_on' => SORT_DESC])->all();
        return $this->render('index', [
            'models' => $models,
        ]);
    }
    
    public function actionBarcode()
    {
        $searchModel = new BarcodeSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('barcode', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
    
    public function actionList()
    {
    
    $models = Barcode::find()->all();
    return $this->render('list', ['models' => $models]);
    }

    
    public function actionGenerate($id)
    { 
        Yii::info("Received Booth ID: $id", __METHOD__);
        
        /*$booth = Booth::findOne($id);
        if ($booth) {
            $generator = new BarcodeGeneratorPNG();
            $barcode = $generator->getBarcode($booth->ic_id, $generator::TYPE_CODE_128);
            $barcodeBase64 = base64_encode($barcode);
            
            $barcodeModel = new Barcode();
            
            $today = date("Y-m-d H:i:s");
            $user_id = Yii::$app->user->id;
            
            $barcodeModel->booth_id = $booth->id;
            $barcodeModel->barcode_image = $barcodeBase64;
            $barcodeModel->created_on = $today;
            $barcodeModel->created_by = $user_id;

            if ($barcodeModel->save()) {
                return $this->redirect(['index']);
            } else {
                Yii::error('Failed to save barcode: ' . print_r($barcodeModel->errors, true));
                throw new \yii\web\ServerErrorHttpException('Failed to save the generated barcode.');
            }
        }

        throw new NotFoundHttpException('The requested booth does not exist.');*/
        
        $booth = Booth::findOne($id);
          if (!$booth) {
              throw new NotFoundHttpException('The requested booth does not exist.');
          }
      
          
          if (!$booth->ic || !$booth->ic->code) {
              throw new NotFoundHttpException('The booth does not have an associated IC or the IC does not have a code.');
          }
          
          
          $existingBarcode = Barcode::findOne(['booth_id' => $booth->id, 'status' => 1]);
          if ($existingBarcode) {
              Yii::info("Barcode already exists for Booth ID: $id with status 1", __METHOD__);
              Yii::$app->session->setFlash('error', 'A barcode already exists for this booth.');
              return $this->redirect(['index']);
          }
      
          $barcodeContent = $booth->ic->code . '000000';
          
          $generator = new BarcodeGeneratorPNG();
          $barcode = $generator->getBarcode($barcodeContent, $generator::TYPE_CODE_128);
          $barcodeBase64 = base64_encode($barcode);
      
          
          $barcodeModel = new Barcode();
          $barcodeModel->booth_id = $booth->id;
          $barcodeModel->ic_id = $booth->ic_id;
          $barcodeModel->barcode = $barcodeContent;
          $barcodeModel->barcode_image = $barcodeBase64;
          $barcodeModel->created_on = date("Y-m-d H:i:s");
          $barcodeModel->created_by = Yii::$app->user->id;
          $barcodeModel->status = 1;
      
         
          if ($barcodeModel->save()) {
              Yii::info("Barcode generated and saved for Booth ID: $id", __METHOD__);
               return $this->render('generate', [
                  'barcodeModel' => $barcodeModel,
              ]);
          } else {
              Yii::error('Failed to save barcode: ' . print_r($barcodeModel->errors, true));
              throw new \yii\web\ServerErrorHttpException('Failed to save the generated barcode.');
          }
        
        
        
        
    }
    
    
    public function actionPdf()
    {
        $models = Barcode::find()->where(['status' => 1])->all();
    
    // Create MPDF object
    $mpdf = new \Mpdf\Mpdf([
        'setAutoTopMargin' => 'pad',
    ]);
    
    // Set footer
    $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->identity->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
    
    // Render HTML content using 'pdf' view
    $content = $this->renderPartial('pdf', [
        'models' => $models,
    ]);
    
    // Write HTML content to PDF
    $mpdf->WriteHTML($content);
    
    // Output PDF as a download
    $mpdf->Output('Barcode List.pdf', 'D');
    exit();

    }
         
}


