<?php

namespace app\controllers;

use Yii;
use app\models\FareSpecialDate;
use app\models\FareSpecialDateSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\helpers\Url;
use yii\web\Response;
use app\models\FareSpecial;
use yii\filters\AccessControl;

/**
 * FareSpecialDateController implements the CRUD actions for FareSpecialDate model.
 */
class FareSpecialDateController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        $requestroute = Yii::$app->requestedRoute;
        $editurl = '/' . $requestroute;
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'actions' => ['index', 'quick', 'view', 'create', 'update','delete','save','get-defaults'],
                        'roles' => [$editurl],
                    ],
                ],
            ],
        ];
    }

    /**
     * Lists all FareSpecialDate models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new FareSpecialDateSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single FareSpecialDate model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        $ic =  Yii::$app->db->createCommand('SELECT * FROM tbl_ic')->queryAll();
        return $this->render('view', [
            'model' => $this->findModel($id),
            'ic'=>$ic
        ]);
    }
    public function actionSave()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;
        $ic =  Yii::$app->db->createCommand('SELECT * FROM tbl_ic')->queryAll();
        $fares=  $_POST["fares"];
        $special_date_id=  $_POST["special_date_id"];

      //  return  $special_date_id;

        for($i = 0; $i < sizeof($ic); $i++){
           
            for($j = 0; $j < $i; $j++){
                 $f_amount = $fares["val" . $ic[$i]['id'] . $ic[$j]['id']];
              
                 $route_id = Yii::$app->db->createCommand('SELECT id FROM tbl_route WHERE source=' . $ic[$i]['id'] . ' AND destination=' . $ic[$j]['id'] . '')->queryOne();
                 $route_id_2 = Yii::$app->db->createCommand('SELECT id FROM tbl_route WHERE source=' . $ic[$j]['id'] . ' AND destination=' . $ic[$i]['id'] . '')->queryOne();
             
                    //find the related fare is exists in the db
                    $exist_fare = Yii::$app->db->createCommand('SELECT * FROM tbl_fare_special WHERE route_id='. $route_id["id"].' AND special_date_id='.$special_date_id.' ')->queryOne();
                    $exist_fare_2 = Yii::$app->db->createCommand('SELECT * FROM tbl_fare_special WHERE route_id='. $route_id_2["id"].' AND special_date_id='.$special_date_id.' ')->queryOne();
                    
                    //if exists check the fare is not equal
                    if (!($exist_fare["final_amount"] == $f_amount) && !($exist_fare_2["final_amount"] == $f_amount)) {
                        //set the exist data tuple status as 0 ,deactivate
                        if(isset($exist_fare["id"])){
                            Yii::$app->db->createCommand('UPDATE tbl_fare_special SET status=0 WHERE route_id='. $route_id["id"].' AND special_date_id='.$special_date_id.' AND status=1')->execute();
                    
                        }
                        if(isset($exist_fare_2["id"])){
                            Yii::$app->db->createCommand('UPDATE tbl_fare_special SET status=0 WHERE route_id='. $route_id_2["id"].' AND special_date_id='.$special_date_id.' AND status=1')->execute();
                    
                        }
                      
                        $fare_special = new FareSpecial();
                        $fare_special->final_amount = $f_amount;
                        $fare_special->route_id = $route_id['id'];
                        $fare_special->special_date_id = $special_date_id;
                        $fare_special->status = 1;
                         
                        

                        // save the new data tuple as status 1;activate
                        $fare_special->save();


                        $fare_special_2 = new FareSpecial();
                        $fare_special_2->final_amount = $f_amount;
                        $fare_special_2->route_id = $route_id_2['id'];
                        $fare_special_2->special_date_id = $special_date_id;
                        $fare_special_2->status = 1;
                         
                        

                        // save the new data tuple as status 1;activate
                        $fare_special_2->save();
                        
                       

                    }
                }
            }
            $master_version = Yii::$app->db->createCommand('SELECT * FROM tbl_version WHERE tbl_name="tbl_fare_special"')->queryOne();
                        $new_version = $master_version['tbl_version']+1;
                        $increament_master_fare_version = Yii::$app->db->createCommand('UPDATE tbl_version SET tbl_version='.$new_version.' WHERE tbl_name="tbl_fare_special"')->execute();
                        
        
        return true;
    }
    /**
     * Creates a new FareSpecialDate model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new FareSpecialDate();

        if ($model->load(Yii::$app->request->post()) ) {
           

            $date =$model->date; 
            //Convert the date string into a unix timestamp.
            $unixTimestamp = strtotime($date);             
            //Get the day of the week using PHP's date function.
            $dayOfWeek = date("l", $unixTimestamp);             
          

            $model->day =  strtoupper($dayOfWeek);
            
            if( $model->date >= date('Y-m-d')){
                if(  $model->start_time <  $model->end_time){
                    if($model->save()){
                        return $this->redirect(['view', 'id' => $model->id]);
                    }
                }else{
                    Yii::$app->getSession()->setFlash('danger', 'Please consider your start time and end time');
                }
               
            }else{
                Yii::$app->getSession()->setFlash('danger', 'Please consider your date');
            }
           
            
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing FareSpecialDate model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing FareSpecialDate model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        Yii::$app->db->createCommand('DELETE FROM `tbl_fare_special` WHERE `tbl_fare_special`.`special_date_id` ='.$id.'')->execute();
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the FareSpecialDate model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return FareSpecialDate the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = FareSpecialDate::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionGetDefaults()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;
        $ic =  Yii::$app->db->createCommand('SELECT * FROM tbl_ic')->queryAll();
        $day=  $_POST["day"];
        $vehicle_category_id=  $_POST["vehicle_category_id"];
        $defaults_fares =[];
        for($i = 0; $i < sizeof($ic); $i++){

            for($j = 0; $j < $i; $j++){
                $route1 =  Yii::$app->db->createCommand('SELECT * FROM tbl_route WHERE source='. $ic[$i]["id"].' AND destination='.$ic[$j]["id"].'')->queryOne();
               
                if($route1["id"]){
                    $vv="";
                    $exact_fare_default =  Yii::$app->db->createCommand('SELECT * FROM tbl_fare WHERE tbl_fare.status=1 AND route_id='. $route1["id"].' AND time_slot_id=1 AND vehicle_category_id='.$vehicle_category_id.' AND tbl_fare.day="'.$day.'"')->queryOne();                            
                    if(isset($exact_fare_default["final_amount"])){
                      
                    
                        $vv =$exact_fare_default["final_amount"];
                      
                    }
                    
                   
                    $dd = ['name'=>'data_'.$ic[$i]["id"].'_'.$ic[$j]["id"],'value' =>$vv];
                
                    array_push($defaults_fares,$dd);
                    
                } 
            }
        }
        return ["ic"=>$ic,"defaults_fares"=>$defaults_fares];
    }
}
