<?php

namespace app\controllers;

use Yii;
use app\models\MasterSession;
use app\models\MasterSessionSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use app\models\Booth;
use app\models\MasterShift;
use DateTime;

/**
 * MasterSessionController implements the CRUD actions for MasterSession model.
 */
class MasterSessionController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all MasterSession models.
     * @return mixed
     */
    public function actionIndex()
    {
        $booths = Booth::find()->all();
      

        return $this->render('index', [
            'booths' => $booths,
           
        ]);
    }

    /**
     * Displays a single MasterSession model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($booth_id)
    {
        $master_shift = MasterShift::find()->all();
        $booth = Booth::find()->where(['id'=>$booth_id])->one();
    
       $sessions_array=array();
       foreach( $master_shift as $shift){
            
            $master_sessions = MasterSession::find()->where(['booth_id'=>$booth_id,'master_shift_id'=>$shift->id])->all();
            
            array_push($sessions_array,['master_shift'=> $shift,'sessions'=>$master_sessions]);
        }

        $session_model = new MasterSession();

      //  print_r(($sessions_array));die;
     
      if ($session_model->load(Yii::$app->request->post())) {
        $model = new MasterSession();
       
        $model->start_time = $session_model->start_time;
        $model->end_time = $session_model->end_time;
        $model->master_shift_id = $session_model->master_shift_id;
        $model->booth_id = $session_model->booth_id;

        $diff = $session_model->start_time - $session_model->end_time;
        // $time1 = new DateTime($session_model->start_time);
        // $time2 = new DateTime($session_model->end_time);
     
        // $interval = $time1->diff($time2);
        // $ss = $interval->format('%s');

        // print_r($ss);die;
        $master_shift_info = Yii::$app->db->createCommand('SELECT * FROM tbl_master_shift  WHERE id="' . $session_model->master_shift_id . '"  ')->queryOne();
        // $shift_start = date("H:i:s",strtotime($master_shift_info['start_time']));
        // $shift_end = date("H:i:s",strtotime($master_shift_info['end_time']));
        
        if( $diff < 0 ){
            if(($session_model->start_time < $session_model->end_time) && ($master_shift_info['start_time'] <= $session_model->start_time && $master_shift_info['end_time'] >= $session_model->end_time )){
           
                if( $model->save()){
                    Yii::$app->getSession()->setFlash('success', 'Session created');
                    return $this->redirect(['view','booth_id'=>$booth->id]);
                }        
               
            }else{
                Yii::$app->getSession()->setFlash('danger', 'Please consider your inputs');
    
            }
        }else{
            if(($session_model->start_time > $session_model->end_time) && ($master_shift_info['start_time'] <= $session_model->start_time && $master_shift_info['end_time'] >= $session_model->end_time )){
           
                if( $model->save()){
                    Yii::$app->getSession()->setFlash('success', 'Session created');
                    return $this->redirect(['view','booth_id'=>$booth->id]);
                }        
               
            }else{
                Yii::$app->getSession()->setFlash('danger', 'Please consider your inputs');
    
            }
        }
        
      
        
    }

        return $this->render('view', [
         //  'master_shift' => $master_shift,
           'session_model'=>$session_model,
           'sessions_array'=>$sessions_array,
           'booth'=>$booth
        ]);
    }

    /**
     * Creates a new MasterSession model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new MasterSession();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing MasterSession model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing MasterSession model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the MasterSession model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return MasterSession the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = MasterSession::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionQuick()
    {
        $id = ($_POST['id']);
        $this->redirect(['view', 'booth_id' => $id]);
    }
    public function actionDeleteSession() {


        $session_id = ($_POST['session_id']);
       
      
        $result = Yii::$app->db->createCommand('DELETE FROM tbl_master_session WHERE id=' . $session_id . '')
                ->execute();
         if($result ){
            Yii::$app->getSession()->setFlash('success', 'Session deleted');
            return true;
         }else{
            Yii::$app->getSession()->setFlash('danger', 'Session not deleted');
         }     
        
        
       
    }
}
