<?php

namespace app\controllers;

use Yii;
use app\models\NfcCard;
use app\models\NfcCardSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use app\models\NfcAllocation;
use app\models\NfcAllocationSearch;
use yii\web\Response;
use yii\filters\AccessControl;

/**
 * NfcCardController implements the CRUD actions for NfcCard model.
 */
class NfcAllocationController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        $requestroute = Yii::$app->requestedRoute;
        $editurl = '/' . $requestroute;
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'actions' => ['index', 'quick', 'view','update','delete','unassigned','create' ],
                        'roles' => [$editurl],
                    ],
                ],
            ],
        ];
    }

    /**
     * Lists all NfcCard models.
     * @return mixed
     */
    public function actionIndex()
    {
    $searchModel = new NfcAllocationSearch();
    $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
    
    $dataProvider->query->andWhere(['tbl_nfc_allocation.status' => 1]);

    return $this->render('index', [
        'searchModel' => $searchModel,
        'dataProvider' => $dataProvider,
    ]);
    }

    public function actionView($id)
    {
       $model = $this->findModel($id);
        
        $searchModel = new NfcAllocationSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        $dataProvider->query->andWhere(['tbl_nfc_allocation.status' => 0]);
        $dataProvider->query->andWhere(['tbl_nfc_allocation.nfc_card_id' => $model->nfc_card_id]);
        
        //print_r($dataProvider);die;
    
        return $this->render('view', [
            'model' => $this->findModel($id),
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    protected function findModel($id)
    {
        if (($model = NfcAllocation::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }


    
}
