<?php

namespace app\controllers;

use Yii;
use yii\helpers\ArrayHelper;
use app\models\Region;
use app\models\RegionSearch;
use app\models\Ic;
use app\models\IcSearch;
use app\models\RegionAdmin;
use app\models\RegionManager;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\ContentNegotiator;
use yii\web\Response;
use yii\web\UploadedFile;
use DateTime;
use DatePeriod;
use DateInterval;
use app\models\Route;
use yii\filters\AccessControl;
use webvimark\modules\UserManagement\models\User;

/**
 * RegionController implements the CRUD actions for Region model.
 */
class RegionController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        $requestroute = Yii::$app->requestedRoute;
        $editurl = '/' . $requestroute;
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'actions' => ['index', 'quick', 'view', 'create', 'update','delete','remove-ra','remove-rm'],
                        'roles' => [$editurl],
                    ],
                ],
            ],
        ];
    }

    /**
     * Lists all Region models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new RegionSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    


    /**
     * Displays a single Region model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {

        $modele = $this->findModel($id);
        $searchIcModel = new IcSearch();
        $IcModel = new Ic();
        $model1=new Region();
        
        $buttenEnable = 1;
        $regionAdminButtenEnable = 0;
        $regionIcEnable = 0;
        if (User::hasRole(Yii::$app->user->isSuperAdmin)) {
            $buttenEnable = 1;
            $regionAdminButtenEnable = 1;
            $regionIcEnable = 1;
        } else if (User::hasRole('95')) {
            $buttenEnable = 0;
          
        } else if (User::hasRole('65')) {
            $buttenEnable = 0;
            
        } else if (User::hasRole('90')) {
            $buttenEnable = 0;
            $regionAdminButtenEnable = 1;
            
        }else if (User::hasRole('91')) {
            $buttenEnable = 0;
            
        }

        $dataIcProvider = $searchIcModel->searchIc(Yii::$app->request->queryParams);

        $countOfIcs = Ic::find()
        ->where(['region_id' => $id])
        ->count();

    
        $reUsers = new User();
        $searchModel1 = new RegionSearch();
        $dataProvider1 = $searchModel1->search(Yii::$app->request->queryParams);

        $regionAdminModel = new RegionAdmin();

        //$regionAdminList=ArrayHelper::map(Yii::$app->db->createCommand('SELECT user.id as id,user.username as username FROM user WHERE user.status =1 AND user.id NOT IN (SELECT user_id FROM tbl_region_admin WHERE tbl_region_admin.status=1 AND tbl_region_admin.region_id='.$id.') AND user.designation_id=27')->queryAll(), 'id', 'username');
        
        $regionAdminList=ArrayHelper::map(Yii::$app->db->createCommand('SELECT user.id as id,user.username as username FROM user INNER JOIN auth_assignment AA ON AA.user_id = user.id
            INNER JOIN auth_item AI ON AI.name = AA.item_name WHERE user.status =1 AND user.id NOT IN (SELECT user_id FROM tbl_region_admin WHERE tbl_region_admin.status=1 AND tbl_region_admin.region_id='.$id.') AND AI.name = 90')->queryAll(), 'id', 'username');

        // $countOfRegionAdmin = RegionAdmin::find()->where(['region_id' => $id])->count();
        $data_region_admin = RegionAdmin::find()->where(['region_id'=>$id,'status'=>1])->all();

        
        $regionManagerModel = new RegionManager();

        //$regionManagerList=ArrayHelper::map(Yii::$app->db->createCommand('SELECT user.id as id,user.username as username FROM user WHERE user.status =1 AND user.id NOT IN (SELECT user_id FROM tbl_region_manager WHERE tbl_region_manager.status=1 AND tbl_region_manager.region_id='.$id.') AND user.designation_id=28')->queryAll(), 'id', 'username');
        
        $regionManagerList=ArrayHelper::map(Yii::$app->db->createCommand('SELECT user.id as id,user.username as username FROM user INNER JOIN auth_assignment AA ON AA.user_id = user.id
            INNER JOIN auth_item AI ON AI.name = AA.item_name WHERE user.status =1 AND user.id NOT IN (SELECT user_id FROM tbl_region_manager WHERE tbl_region_manager.status=1 AND tbl_region_manager.region_id='.$id.') AND AI.name = 91')->queryAll(), 'id', 'username');
     
        $data_region_manager = RegionManager::find()->where(['region_id'=>$id,'status'=>1])->all();

        if ($IcModel->load(Yii::$app->request->post()) && $IcModel->save()) {
            $ic = Yii::$app->db->createCommand('SELECT * FROM tbl_ic')->queryAll();
            for ($i = 0; $i < sizeof($ic); $i++) {
    
                for ($j = 0; $j < $i; $j++) {
                    $route_id = Yii::$app->db->createCommand('SELECT id FROM tbl_route WHERE source=' . $ic[$i]['id'] . ' AND destination=' . $ic[$j]['id'] . '')->queryOne();
                    if(!($route_id->id)){
                        
                    $route = new Route();
                    $route->source=$ic[$i]['id'];
                    $route->destination=$ic[$j]['id'];
                    $route->direction = 1;
                    $route->distance=100;
                    $route->max_time = "02:50:00";
                    $route->save();
                    }
                }
            }
            return $this->redirect(['view', 'id' => $IcModel->region_id]);
        }

        //add region admin 
        if ($regionAdminModel->load(Yii::$app->request->post()) ) {

           
            foreach ($regionAdminModel['user_id'] as $user_id) {

                $model = new RegionAdmin();

                $model->user_id = $user_id;
                $model->region_id = $id;
                $model->status = 1;
                $model->added_on = date("Y-m-d H:i:s");
                $model->added_by = Yii::$app->user->id;             
                $model->save();

             
            }
            Yii::$app->getSession()->setFlash('success', 'Region Admin Assigned');
            return $this->redirect(['view', 'id' => $id]);

        }

       

        //add region manager 
        if ($regionManagerModel->load(Yii::$app->request->post()) ) {

           
            foreach ($regionManagerModel['user_id'] as $user_id) {

                $model = new RegionManager();

                $model->user_id = $user_id;
                $model->region_id = $id;
                $model->status = 1;
                $model->added_on = date("Y-m-d H:i:s");
                $model->added_by = Yii::$app->user->id;             
                $model->save();

             
            }
            Yii::$app->getSession()->setFlash('success', 'Region Manager Assigned');
            return $this->redirect(['view', 'id' => $id]);

        }

       


        
        return $this->render('view', [
            'model' => $this->findModel($id),
            'searchIcModel'=>$searchIcModel,
            'dataIcProvider'=>$dataIcProvider,
            'IcModel'=>$IcModel,
            'model1'=>$model1,
            'countOfIcs'=>$countOfIcs,
            'reUser'=>$reUsers,
            'searchModel1' => $searchModel1,
            'dataProvider1' => $dataProvider1,
            'regionAdminModel'=> $regionAdminModel,
            // 'countOfRegionAdmin'=>$countOfRegionAdmin
            'regionAdminList' => $regionAdminList,
            'data_region_admin' => $data_region_admin,
            'regionManagerModel'=> $regionManagerModel,
            'regionManagerList' => $regionManagerList,
            'data_region_manager' => $data_region_manager,
            'buttenEnable'=>$buttenEnable,
            'regionAdminButtenEnable'=>$regionAdminButtenEnable,
            'regionIcEnable'=>$regionIcEnable,
        ]);
    }

    /**
     * Creates a new Region model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {


        $model = new Region();

      
         $model2 = new Region();

               
        if (Yii::$app->request->isPost) {
            $model2->file = UploadedFile::getInstance($model, 'file');
           $exten = $model2->file->extension;
         
            if ($model2->file) {
                
                if ($model->load(Yii::$app->request->post())) {
                    $model2->file->name = $model->name;                    
                    $model->photo = "";                     
                    $createTimeStamp = date('YmdHis');                                  
                    $model2->file->saveAs('../region_logos/'.$model->name. '_'.$createTimeStamp.'.'. $exten);
                    $model->photo = '../region_logos/'.$model->name. '_'.$createTimeStamp.'.'.$exten;                  
                    $model->save();
                    Yii::$app->getSession()->setFlash('success','Success-region created');
                    return $this->redirect(['view', 'id' => $model->id]);
                }
            }else{
                
                if ($model->load(Yii::$app->request->post())) {
                    //$model2->file->name = $model->name;
                    $model->photo = "";
                    $createTimeStamp = date('YmdHis');
                    //$model2->file->saveAs('../organization_logos/default_logo.png');
                    $model->photo = '../region_logos/default_logo.png';
                    $model->save();
                    Yii::$app->getSession()->setFlash('success', 'Success-region created');
                    return $this->redirect(['view', 'id' => $model->id]);
                }
            }
        }

        return $this->render('create', [
            'model' => $model,
            'model2'=>$model2
        ]);
    }

    /**
     * Updates an existing Region model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);


        if (Yii::$app->request->isPost) {
            $model->file = UploadedFile::getInstance($model, 'file');

            if (!$model->file) {

                if ($model->load(Yii::$app->request->post()) && $model->save()) {
                    Yii::$app->getSession()->setFlash('success','Success-Region updated');
                    return $this->redirect(['view', 'id' => $model->id]);
                }


            }
            $createTimeStamp = date('YmdHis');
            $model->file->saveAs('../region_logos/' . $model->name . '_' . $createTimeStamp . '.' . $model->file->extension);

                //save databases
            $model->photo = '../region_logos/' . $model->name . '_' . $createTimeStamp . '.' . $model->file->extension;

            if ($model->load(Yii::$app->request->post()) && $model->save()) {
               Yii::$app->getSession()->setFlash('success','Success');
                return $this->redirect(['view', 'id' => $model->id]);
            }

        }
          
        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Region model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        try {
            $this->findModel($id)->delete();
            Yii::$app->getSession()->setFlash('success', 'Success - deleted');
            return $this->redirect(['index']);
        } catch (\Exception $e) {
            Yii::$app->getSession()->setFlash('danger', 'You are not allowed to delete this item.Item is used in another place ');
            return $this->redirect(['index']);
        } catch (\Throwable $e) {
            Yii::$app->getSession()->setFlash('danger', 'You are not allowed to delete this item.Item is used in another place ');
            return $this->redirect(['index']);
        }
    }

    /**
     * Finds the Region model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Region the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (User::hasRole(Yii::$app->user->isSuperAdmin)) {

            if (($model = Region::findOne($id)) !== null) {
                return $model;
            }
    
            throw new NotFoundHttpException('The requested page does not exist.');
            
        }

        if (User::hasRole('90')) {
            $regions = RegionAdmin::find()
                ->select('region_id')
                ->where([
                    'user_id' => \Yii::$app->user->identity->id,
                    'region_id' => $id,
                    'status' => 1
                ])
                ->column();  
    
            
            if (!empty($regions)) {
                $model = Region::findOne(['id' => $id]);
                if ($model !== null) {
                    return $model;
                }
            }
    
            throw new NotFoundHttpException('The requested page does not exist for your assigned regions.');
        }

        if (User::hasRole('91')) {
            $regions = RegionManager::find()
                ->select('region_id')
                ->where([
                    'user_id' => \Yii::$app->user->identity->id,
                    'region_id' => $id,
                    'status' => 1
                ])
                ->column();  
    
            if (!empty($regions)) {
                $model = Region::findOne(['id' => $id]);
                if ($model !== null) {
                    return $model;
                }
            }
    
            throw new NotFoundHttpException('The requested page does not exist for your assigned regions.');
        }
    }
    public function actionQuick()
    {
        $id = ($_POST['id']);
        $this->redirect(['view', 'id' => $id]);
    }
    
    public function actionRemoveRa()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;

    $region_admin_row_id = Yii::$app->request->post('region_admin_row_id');
    $region_id = Yii::$app->request->post('region_id');
    $today = date("Y-m-d H:i:s");
    $user_id = Yii::$app->user->id;

    // Use transaction for data consistency
    $transaction = Yii::$app->db->beginTransaction();

    try {
        // Update the region admin status
        $res = Yii::$app->db->createCommand()->update('tbl_region_admin', [
            'status' => 0,
            'removed_on' => $today,
            'removed_by' => $user_id
        ], 'id=:id', [':id' => $region_admin_row_id])->execute();

        if ($res) {
            $transaction->commit();
            Yii::$app->session->setFlash('success', 'Region Admin removed');
            return ['status' => 'success', 'message' => 'Region Admin removed successfully.'];
        } else {
            $transaction->rollBack();
            return ['status' => 'error', 'message' => 'Failed to remove Region Admin.'];
        }
    } catch (\Exception $e) {
        $transaction->rollBack();
        return ['status' => 'error', 'message' => $e->getMessage()];
    }
       
    }

    public function actionRemoveRm()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;

    $region_manager_row_id = Yii::$app->request->post('region_manager_row_id');
    $region_id = Yii::$app->request->post('region_id');
    $today = date("Y-m-d H:i:s");
    $user_id = Yii::$app->user->id;

    // Use transaction for data consistency
    $transaction = Yii::$app->db->beginTransaction();

    try {
        // Update the region manager status
        $res = Yii::$app->db->createCommand()->update('tbl_region_manager', [
            'status' => 0,
            'removed_on' => $today,
            'removed_by' => $user_id
        ], 'id=:id', [':id' => $region_manager_row_id])->execute();

        if ($res) {
            $transaction->commit();
            Yii::$app->session->setFlash('success', 'Region Manager removed');
            return ['status' => 'success', 'message' => 'Region Manager removed successfully.'];
        } else {
            $transaction->rollBack();
            return ['status' => 'error', 'message' => 'Failed to remove Region Manager.'];
        }
    } catch (\Exception $e) {
        $transaction->rollBack();
        return ['status' => 'error', 'message' => $e->getMessage()];
    }
       
    }
}
