<?php

namespace app\controllers;

use app\models\AnalysisDailyRevenue;
use app\models\AnalysisDailyTraffic;
use app\models\AnalysisHourlyRevenue;
use app\models\AnalysisHourlyTraffic;
use app\models\AnalysisMonthlyRevenue;
use app\models\AnalysisMonthlyTraffic;
use app\models\AnalysisTimePeriodTraffic;
use app\models\AnalysisYearlyRevenue;
use app\models\AnalysisYearlyTraffic;
use app\models\BoothType;
use app\models\FareCollectionAllIcSummary;
use app\models\FareCollectionAllocationWise;
use app\models\FareCollectionBoothWise;
use app\models\FareCollectionPosWise;
use app\models\FareCollectionTellerWise;
use app\models\HourlySectionTraffic;
use app\models\Ic;
use app\models\IncidentCategoryChanged;
use app\models\IncidentLostTicket;
use app\models\IncidentMissedIssuedTicket;
use app\models\Route;
use app\models\VehicleCategory;
use app\models\YearReportStats;
use DateTime;
use Yii;
use yii\data\Pagination;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\Json;
use yii\web\Controller;

/**
 * RouteController implements the CRUD actions for Route model.
 */
class ReportHourlyTrafficController extends Controller
{
    // private $db = new yii\db\Connection(Yii::$app->db);
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        $requestroute = Yii::$app->requestedRoute;
        $editurl = '/' . $requestroute;
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'actions' => ['index', 'quick', 'view', 'create', 'update', 'delete', 'fare-collection-booth-wise',
                            'fare-collection-booth-wise-excel', 'fare-collection-booth-wise-pdf', 'fare-collection-teller-wise',
                            'fare-collection-teller-wise-excel', 'fare-collection-teller-wise-pdf', 'fare-collection-pos-wise',
                            'fare-collection-pos-wise-excel', 'fare-collection-pos-wise-pdf', 'fare-collection-all-ic-summary',
                            'fare-collection-all-ic-summary-excel', 'fare-collection-all-ic-summary-pdf', 'fare-collection-allocation-wise',
                            'fare-collection-allocation-wise-excel', 'fare-collection-allocation-wise-pdf', 'fare-collection-allocation-wise-view',
                            'analysis-hourly-traffic', 'analysis-hourly-traffic-excel', 'analysis-hourly-traffic-pdf', 'analysis-time-period-traffic',
                            'analysis-time-period-traffic-pdf', 'analysis-time-period-traffic-excel', 'analysis-hourly-sectional-traffic',
                            'analysis-hourly-sectional-traffic-excel', 'analysis-hourly-sectional-traffic-pdf', 'analysis-time-period-revenue'
                            , 'analysis-time-period-revenue-pdf', 'analysis-time-period-revenue-excel', 'analysis-hourly-revenue', 'analysis-hourly-revenue-pdf'
                            , 'analysis-hourly-revenue-excel', 'analysis-daily-traffic', 'analysis-daily-traffic-pdf', 'analysis-daily-traffic-excel',
                            'analysis-daily-revenue', 'analysis-daily-revenue-pdf', 'analysis-daily-revenue-excel', 'analysis-monthly-traffic',
                            'analysis-monthly-traffic-pdf', 'analysis-monthly-traffic-excel', 'analysis-monthly-revenue', 'analysis-monthly-revenue-pdf',
                            'analysis-monthly-revenue-excel', 'analysis-yearly-traffic', 'analysis-yearly-traffic-pdf', 'analysis-yearly-traffic-excel',
                            'analysis-yearly-revenue', 'analysis-yearly-revenue-pdf', 'analysis-yearly-revenue-excel', 'incident-lost-ticket',
                            'incident-lost-ticket-pdf', 'incident-lost-ticket-excel', 'incident-expired-ticket', 'incident-expired-ticket-pdf',
                            'incident-expired-ticket-excel', 'incident-book-receipt-pdf', 'incident-book-receipt', 'incident-book-receipt-excel',
                            'incident-category-changed', 'incident-category-changed-pdf', 'incident-category-changed-excel', 'incident-reprint-ticket',
                            'incident-reprint-ticket-pdf', 'incident-reprint-ticket-excel', 'incident-manual-ticket', 'incident-manual-ticket-pdf',
                            'incident-manual-ticket-excel', 'incident-missed-issued-ticket', 'incident-missed-issued-ticket-pdf', 'incident-missed-issued-ticket-excel',
                            'incident-blacklisted-card', 'incident-blacklisted-card-pdf', 'incident-blacklisted-card-excel', 'incident-incomplete-ticket',
                            'incident-incomplete-ticket-pdf', 'incident-incomplete-ticket-excel', 'incident-escape-ticket', 'incident-escape-ticket-pdf',
                            'incident-escape-ticket-excel', 'yearly-report', 'analysis-year-report-excel', 'analysis-year-report-pdf',
                            'average-daily-traffic-report', 'average-daily-traffic-report-excel', 'average-daily-traffic-report-pdf',
                        ],
                        'roles' => [$editurl],
                    ],
                ],
            ],
        ];
    }

    /**
     * Lists all Route models.
     * @return mixed
     */
    public function actionIndex()
    {

        return $this->render('index', [

        ]);
    }

    public function actionFareCollectionBoothWise()
    {

        $model = new FareCollectionBoothWise;

        if (Yii::$app->request->post() || Yii::$app->request->get()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);

            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                setcookie("fareBoothWise-IC", $model->ic, time() + 86400);
                setcookie("fareBoothWise-Booth", $model->booth, time() + 86400);
                setcookie("fareBoothWise-Type", $model->reportType, time() + 86400);
                setcookie("fareBoothWise-StartD", $model->startDate, time() + 86400);
                setcookie("fareBoothWise-EndD", $model->endDate, time() + 86400);
            } else {
                $model->ic = $_COOKIE["fareBoothWise-IC"];
                $model->booth = $_COOKIE["fareBoothWise-Booth"];
                $model->reportType = $_COOKIE["fareBoothWise-Type"];
                $model->startDate = $_COOKIE["fareBoothWise-StartD"];
                $model->endDate = $_COOKIE["fareBoothWise-EndD"];
            }

            $isExit = 0;
            $exitOrEntrance = $db->createCommand("SELECT `booth_type` FROM `tbl_booth` WHERE `id` = $model->booth")->queryScalar();

            if ($exitOrEntrance == BoothType::exit) {
                $isExit = 1;
            }

            if ($model->reportType == 'summary') {
                if ($isExit) {
                    $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();
                }
                return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseSummaryResult', [
                    'results' => $results,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);

            } else if ($model->reportType == 'detailed') {

                $page = Yii::$app->request->get('page', 1);
                $limit = Yii::$app->request->get('per-page', 10);
                $from = ($page - 1) * $limit;

                //prepare SQL query
                if ($isExit) {
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                } else {
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                }

                //Fire it!
                $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

                $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

                return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseDetailedResult', [
                    'results' => $result,
                    'pages' => $pages,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);

            } else if ($model->reportType == 'all') {

                //summary report=========================
                if ($isExit) {
                    $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();
                } else {
                    $sResults = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();
                }
                //detailed report========================
                $page = Yii::$app->request->get('page', 1);
                $limit = Yii::$app->request->get('per-page', 10);
                $from = ($page - 1) * $limit;

                if ($isExit) {
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                } else {
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                }

                $dResults = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

                $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

                return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseAllResult', [
                    'dResults' => $dResults,
                    'sResults' => $sResults,
                    'pages' => $pages,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);
            }
        } else {
            return $this->render('fareCollectionBoothWise/fareCollectionBoothWise', ['model' => $model]);
        }

    }

    public function actionFareCollectionBoothWiseExcel()
    {
        $model = new FareCollectionBoothWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["fareBoothWise-IC"];
        $model->booth = $_COOKIE["fareBoothWise-Booth"];
        $model->reportType = $_COOKIE["fareBoothWise-Type"];
        $model->startDate = $_COOKIE["fareBoothWise-StartD"];
        $model->endDate = $_COOKIE["fareBoothWise-EndD"];

        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT `booth_type` FROM `tbl_booth` WHERE `id` = $model->booth")->queryScalar();

        if ($exitOrEntrance == BoothType::exit) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            } else {
                $results = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            }

            return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseSummaryExcel', [
                'results' => $results,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $results = $db->createCommand("SELECT  ET.*,VC.name
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $results = $db->createCommand("SELECT  ET.*,VC.name
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseDetailedExcel', [
                'results' => $results,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        } else if ($model->reportType == 'all') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $sResults = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_all_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseAllExcel', [
                'sResults' => $sResults,
                'dResults' => $dResults,
                'model' => $model,
                'isExit' => $isExit,
            ]);
        }
    }

    public function actionFareCollectionBoothWisePdf()
    {
        $model = new FareCollectionBoothWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["fareBoothWise-IC"];
        $model->booth = $_COOKIE["fareBoothWise-Booth"];
        $model->reportType = $_COOKIE["fareBoothWise-Type"];
        $model->startDate = $_COOKIE["fareBoothWise-StartD"];
        $model->endDate = $_COOKIE["fareBoothWise-EndD"];

        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT `booth_type` FROM `tbl_booth` WHERE `id` = $model->booth")->queryScalar();

        if ($exitOrEntrance == BoothType::exit) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            } else {
                $results = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionBoothWise/fareCollectionBoothWiseSummaryPdf', array('results' => $results, 'model' => $model,
                'isExit' => $isExit)));
            $mpdf->Output('Fare Collection Booth Wise Summery Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $results = $db->createCommand("SELECT ET.*,VC.name
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $results = $db->createCommand("SELECT ET.*,VC.name
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionBoothWise/fareCollectionBoothWiseDetailedPdf', array('results' => $results, 'model' => $model,
                'isExit' => $isExit)));
            $mpdf->Output('Fare Collection Booth Wise Detailed Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'all') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $sResults = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_all_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionBoothWise/fareCollectionBoothWiseAllPdf', array('sResults' => $sResults, 'dResults' => $dResults, 'model' => $model,
                'isExit' => $isExit)));
            $mpdf->Output('Fare Collection Booth Wise Summary & Detailed Pdf.pdf', 'D');
            exit();
        }
    }

    public function actionFareCollectionTellerWise()
    {
        $model = new FareCollectionTellerWise;

        if (Yii::$app->request->post() || Yii::$app->request->get()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);

            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                setcookie("fareTellerWise-IC", $model->ic, time() + 86400);
                setcookie("fareTellerWise-Teller", $model->teller, time() + 86400);
                setcookie("fareTellerWise-Type", $model->reportType, time() + 86400);
                setcookie("fareTellerWise-StartD", $model->startDate, time() + 86400);
                setcookie("fareTellerWise-EndD", $model->endDate, time() + 86400);
            } else {
                $model->ic = $_COOKIE["fareTellerWise-IC"];
                $model->teller = $_COOKIE["fareTellerWise-Teller"];
                $model->reportType = $_COOKIE["fareTellerWise-Type"];
                $model->startDate = $_COOKIE["fareTellerWise-StartD"];
                $model->endDate = $_COOKIE["fareTellerWise-EndD"];
            }

            if ($model->reportType == 'summary') {

                $enResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseSummaryResult', [
                    'model' => $model,
                    'enResults' => $enResult,
                    'exResults' => $exResults,

                ]);

            } else if ($model->reportType == 'detailed') {

                //entrance
                $page_en = Yii::$app->request->get('page', 1);
                $limit_en = Yii::$app->request->get('per-page', 10);
                $from_en = ($page_en - 1) * $limit_en;

                $sql_en = "SELECT  ET.*,VC.name
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";

                $result_en = $db->createCommand($sql_en . ' LIMIT ' . $from_en . ',' . $limit_en)->queryAll();
                $count_en = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_en . ') a')->queryScalar();

                $pages_en = new Pagination(['totalCount' => $count_en, 'pageSize' => $limit_en]);

                //exit
                $page_ex = Yii::$app->request->get('page', 1);
                $limit_ex = Yii::$app->request->get('per-page', 10);
                $from_ex = ($page_ex - 1) * $limit_ex;

                $sql_ex = "SELECT  ET.*,VC.name
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";

                $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                $pages_ex = new Pagination(['totalCount' => $count_ex, 'pageSize' => $limit_ex]);

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseDetailedResult', [
                    'results_en' => $result_en,
                    'results_ex' => $result_ex,
                    'pages_en' => $pages_en,
                    'pages_ex' => $pages_ex,
                    'model' => $model,
                ]);

            } else if ($model->reportType == 'all') {
                //entrance summary
                $enResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                //exit summary
                $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                //entrance detailed
                $page_en = Yii::$app->request->get('page', 1);
                $limit_en = Yii::$app->request->get('per-page', 10);
                $from_en = ($page_en - 1) * $limit_en;

                $sql_en = "SELECT  ET.*,VC.name
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";

                $result_en = $db->createCommand($sql_en . ' LIMIT ' . $from_en . ',' . $limit_en)->queryAll();
                $count_en = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_en . ') a')->queryScalar();

                $pages_en = new Pagination(['totalCount' => $count_en, 'pageSize' => $limit_en]);

                //exit detailed
                $page_ex = Yii::$app->request->get('page', 1);
                $limit_ex = Yii::$app->request->get('per-page', 10);
                $from_ex = ($page_ex - 1) * $limit_ex;

                $sql_ex = "SELECT ET.*,VC.name
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";

                $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                $pages_ex = new Pagination(['totalCount' => $count_ex, 'pageSize' => $limit_ex]);

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseAllResult', [
                    'results_en' => $result_en,
                    'results_ex' => $result_ex,
                    'enResults' => $enResults,
                    'exResults' => $exResults,
                    'pages_en' => $pages_en,
                    'pages_ex' => $pages_ex,
                    'model' => $model,
                ]);

            }
        } else {
            return $this->render('fareCollectionTellerWise/fareCollectionTellerWise', ['model' => $model]);
        }
    }
    public function actionFareCollectionTellerWiseExcel()
    {

        $model = new FareCollectionTellerWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["fareTellerWise-IC"];
        $model->teller = $_COOKIE["fareTellerWise-Teller"];
        $model->reportType = $_COOKIE["fareTellerWise-Type"];
        $model->startDate = $_COOKIE["fareTellerWise-StartD"];
        $model->endDate = $_COOKIE["fareTellerWise-EndD"];

        if ($model->reportType == 'summary') {

            $enSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                 FROM tbl_vehicle_category VC
                 LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                 GROUP BY VC.id")->queryAll();

            $exSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                 FROM tbl_vehicle_category VC
                 LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                 GROUP BY VC.id")->queryAll();

            return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseSummaryExcel', [
                'enSResults' => $enSResults,
                'exSResults' => $exSResults,
                'model' => $model,
            ]);

        } else if ($model->reportType == 'detailed') {

            $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseDetailedExcel', [
                'enDResults' => $enDResults,
                'exDResults' => $exDResults,
                'model' => $model,
            ]);

        } else if ($model->reportType == 'all') {

            $enSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                GROUP BY VC.id")->queryAll();

            $exSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                GROUP BY VC.id")->queryAll();

            $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseAllExcel', [
                'enSResults' => $enSResults,
                'exSResults' => $exSResults,
                'enDResults' => $enDResults,
                'exDResults' => $exDResults,
                'model' => $model,
            ]);
        }

    }
    public function actionFareCollectionTellerWisePdf()
    {
        $model = new FareCollectionTellerWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["fareTellerWise-IC"];
        $model->teller = $_COOKIE["fareTellerWise-Teller"];
        $model->reportType = $_COOKIE["fareTellerWise-Type"];
        $model->startDate = $_COOKIE["fareTellerWise-StartD"];
        $model->endDate = $_COOKIE["fareTellerWise-EndD"];

        if ($model->reportType == 'summary') {

            $enResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                 FROM tbl_vehicle_category VC
                 LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                 GROUP BY VC.id")->queryAll();

            $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                 FROM tbl_vehicle_category VC
                 LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                 GROUP BY VC.id")->queryAll();

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionTellerWise/fareCollectionTellerWiseSummaryPdf', array('enResults' => $enResults, 'exResults' => $exResults, 'model' => $model)));
            $mpdf->Output('Fare Collection Teller Wise Summary Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'detailed') {

            $enResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionTellerWise/fareCollectionTellerWiseDetailedPdf', array('enResults' => $enResults, 'exResults' => $exResults, 'model' => $model)));
            $mpdf->Output('Fare Collection Teller Wise Detailed Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'all') {

            $enSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                GROUP BY VC.id")->queryAll();

            $exSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                GROUP BY VC.id")->queryAll();

            $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionTellerWise/fareCollectionTellerWiseAllPdf', array('enSResults' => $enSResults, 'exSResults' => $exSResults, 'enDResults' => $enDResults, 'exDResults' => $exDResults, 'model' => $model)));
            $mpdf->Output('Fare Collection Teller Wise All Pdf.pdf', 'D');
            exit();
        }
    }

    public function actionFareCollectionPosWise()
    {

        $model = new FareCollectionPosWise;

        if (Yii::$app->request->post() || Yii::$app->request->get()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);

            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                setcookie("farePosWise-IC", $model->ic, time() + 86400);
                setcookie("farePosWise-Pos", $model->pos, time() + 86400);
                setcookie("farePosWise-Type", $model->reportType, time() + 86400);
                setcookie("farePosWise-StartD", $model->startDate, time() + 86400);
                setcookie("farePosWise-EndD", $model->endDate, time() + 86400);
            } else {
                $model->ic = $_COOKIE["farePosWise-IC"];
                $model->pos = $_COOKIE["farePosWise-Pos"];
                $model->reportType = $_COOKIE["farePosWise-Type"];
                $model->startDate = $_COOKIE["farePosWise-StartD"];
                $model->endDate = $_COOKIE["farePosWise-EndD"];
            }

            $isExit = 0;
            $exitOrEntrance = $db->createCommand("SELECT BT.id
                FROM tbl_booth_devices BD
                INNER JOIN tbl_booth B ON B.id = BD.booth_id
                INNER JOIN tbl_booth_type BT ON BT.id = B.booth_type
                WHERE BD.device_id = $model->pos AND BD.ic_id = $model->ic AND BD.status = 1")->queryScalar();

            if ($exitOrEntrance == BoothType::exit) {
                $isExit = 1;
            }

            if ($model->reportType == 'summary') {

                if ($isExit) {
                    $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();

                } else {
                    $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();

                }

                return $this->render('fareCollectionPosWise/fareCollectionPosWiseSummaryResult', [
                    'results' => $results,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);

            } else if ($model->reportType == 'detailed') {

                $page = Yii::$app->request->get('page', 1);
                $limit = Yii::$app->request->get('per-page', 10);
                $from = ($page - 1) * $limit;

                if ($isExit) {
                    $sql = "SELECT  ET.*,VC.name
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                } else {
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                }

                $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

                $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

                return $this->render('fareCollectionPosWise/fareCollectionPosWiseDetailedResult', [
                    'results' => $result,
                    'pages' => $pages,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);

            } else if ($model->reportType == 'all') {

                $page = Yii::$app->request->get('page', 1);
                $limit = Yii::$app->request->get('per-page', 10);
                $from = ($page - 1) * $limit;

                if ($isExit) {
                    $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();

                    $sql = "SELECT  ET.*,VC.name
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                } else {
                    $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();

                    $sql = "SELECT  ET.*,VC.name
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                }

                $dResults = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

                $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

                return $this->render('fareCollectionPosWise/fareCollectionPosWiseAllResult', [
                    'sResults' => $sResults,
                    'dResults' => $dResults,
                    'pages' => $pages,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);
            }
        } else {
            return $this->render('fareCollectionPosWise/fareCollectionPosWise', ['model' => $model]);
        }

    }
    public function actionFareCollectionPosWiseExcel()
    {

        $model = new FareCollectionPosWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["farePosWise-IC"];
        $model->pos = $_COOKIE["farePosWise-Pos"];
        $model->reportType = $_COOKIE["farePosWise-Type"];
        $model->startDate = $_COOKIE["farePosWise-StartD"];
        $model->endDate = $_COOKIE["farePosWise-EndD"];
        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT BT.id
            FROM tbl_booth_devices BD
            INNER JOIN tbl_booth B ON B.id = BD.booth_id
            INNER JOIN tbl_booth_type BT ON BT.id = B.booth_type
            WHERE BD.device_id = $model->pos AND BD.ic_id = $model->ic AND BD.status = 1")->queryScalar();

        if ($exitOrEntrance == BoothType::exit) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

            }

            return $this->render('fareCollectionPosWise/fareCollectionPosWiseSummaryExcel', [
                'sResults' => $sResults,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            } else {
                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_all_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            }

            return $this->render('fareCollectionPosWise/fareCollectionPosWiseDetailedExcel', [
                'dResults' => $dResults,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        } else if ($model->reportType == 'all') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_all_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            }

            return $this->render('fareCollectionPosWise/fareCollectionPosWiseAllExcel', [
                'dResults' => $dResults,
                'sResults' => $sResults,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        }
    }

    public function actionFareCollectionPosWisePdf()
    {
        $model = new FareCollectionPosWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["farePosWise-IC"];
        $model->pos = $_COOKIE["farePosWise-Pos"];
        $model->reportType = $_COOKIE["farePosWise-Type"];
        $model->startDate = $_COOKIE["farePosWise-StartD"];
        $model->endDate = $_COOKIE["farePosWise-EndD"];
        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT BT.id
            FROM tbl_booth_devices BD
            INNER JOIN tbl_booth B ON B.id = BD.booth_id
            INNER JOIN tbl_booth_type BT ON BT.id = B.booth_type
            WHERE BD.device_id = $model->pos AND BD.ic_id = $model->ic AND BD.status = 1")->queryScalar();

        if ($exitOrEntrance == BoothType::exit) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionPosWise/fareCollectionPosWiseSummaryPdf', [
                'sResults' => $sResults,
                'model' => $model,
                'isExit' => $isExit,
            ]));
            $mpdf->Output('Fare Collection POS Wise Summary Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            } else {
                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_all_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionPosWise/fareCollectionPosWiseDetailedPdf', [
                'dResults' => $dResults,
                'model' => $model,
                'isExit' => $isExit,
            ]));
            $mpdf->Output('Fare Collection POS Wise Detailed Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'all') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_all_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionPosWise/fareCollectionPosWiseAllPdf', [
                'dResults' => $dResults,
                'sResults' => $sResults,
                'model' => $model,
                'isExit' => $isExit,
            ]));
            $mpdf->Output('Fare Collection POS Wise All Pdf.pdf', 'D');
            exit();

        }
    }

    public function actionFareCollectionAllIcSummary()
    {
        $model = new FareCollectionAllIcSummary;

        if (Yii::$app->request->post()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);

            $model->load(Yii::$app->request->post());
            setcookie("fareCollectionAllIcSummary-Type", $model->ticketType, time() + 86400);
            setcookie("fareCollectionAllIcSummary-StartD", $model->startDate, time() + 86400);
            setcookie("fareCollectionAllIcSummary-EndD", $model->endDate, time() + 86400);

            if ($model->ticketType == 'entrance') {

                $vehicleTypes = VehicleCategory::find()->all();
                $sql_main = "CALL Rpt_AllICEntranceSummary('" . $model->startDate . "', '" . $model->endDate . "')";
                $results = $db->createCommand($sql_main)->queryAll();
                return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);

            } else if ($model->ticketType == 'exit(traffic)' || $model->ticketType == 'exit(revenue)') {
               
                $vehicleTypes = VehicleCategory::find()->all();
                $sql_main = "CALL Rpt_AllICExitSummary('" . $model->startDate . "', '" . $model->endDate . "')";
                $results = $db->createCommand($sql_main)->queryAll();
                return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);

            }
        } else {
            return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model]);
        }
    }

    public function actionFareCollectionAllIcSummaryExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $vehicleTypes = json::decode($_POST['vCategor']);

        if ($model['ticketType'] == 'entrance') {

            return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummaryEntranceExcel', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);

        } else if ($model['ticketType'] == 'exit(traffic)' || $model['ticketType'] == 'exit(revenue)') {

            return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummaryExitExcel', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);
        }
    }
    public function actionFareCollectionAllIcSummaryPdf()
    {

        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $vehicleTypes = json::decode($_POST['vCategor']);

        if ($model['ticketType'] == 'entrance') {

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionAllIcSummary/fareCollectionAllIcSummaryEntrancePdf', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]));
            $mpdf->Output('Fare Collection All Ic Summary(Entrance).pdf', 'D');
            exit();

        } else if ($model['ticketType'] == 'exit(traffic)' || $model['ticketType'] == 'exit(revenue)') {

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionAllIcSummary/fareCollectionAllIcSummaryExitPdf', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]));
            $mpdf->Output('Fare Collection All Ic Summary(Exit).pdf', 'D');
            exit();
        }
    }

    public function actionFareCollectionAllocationWise()
    {
        $model = new FareCollectionAllocationWise;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post() || Yii::$app->request->get()) {

            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                setcookie("fareAllocationWise-IC", $model->ic, time() + 86400);
                setcookie("fareAllocationWise-StartD", $model->startDate, time() + 86400);
                setcookie("fareAllocationWise-EndD", $model->endDate, time() + 86400);
            } else {
                $model->ic = $_COOKIE["fareAllocationWise-IC"];
                $model->startDate = $_COOKIE["fareAllocationWise-StartD"];
                $model->endDate = $_COOKIE["fareAllocationWise-EndD"];
            }

            $sdate = date('Y-m-d', strtotime($model->startDate));
            $edate = date('Y-m-d', strtotime($model->endDate));

            $page = Yii::$app->request->get('page', 1);
            $limit = Yii::$app->request->get('per-page', 10);
            $from = ($page - 1) * $limit;

            $sql = "SELECT SESU.user_id,SES.booth_id,BD.device_id,DATE_FORMAT(concat(SCH.date,' ',SES.start_time), '%Y-%m-%d %H:%i') as sDate,DATE_FORMAT(concat(SCH.date,' ',SES.end_time), '%Y-%m-%d %H:%i') as eDate,SHF.id shiftId
                FROM tbl_schedule SCH
                INNER JOIN tbl_shift SHF ON SHF.schedule_id = SCH.id AND SHF.ic_id = $model->ic
                INNER JOIN tbl_session SES ON SES.shift_id = SHF.id
                INNER JOIN tbl_session_users SESU ON SESU.session_id = SES.id
                INNER JOIN tbl_booth_devices BD ON BD.booth_id = SES.booth_id AND BD.status = 1
                WHERE SCH.date >= '" . $sdate . "' AND SCH.date <= '" . $edate . "' AND DATE_FORMAT(concat(SCH.date,' ',SES.start_time), '%Y-%m-%d %H:%i') > '" . $model->startDate . "' AND DATE_FORMAT(concat(SCH.date,' ',SES.start_time), '%Y-%m-%d %H:%i') < '" . $model->endDate . "'";

            $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
            $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

            $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

            return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWise', [
                'results' => $result,
                'pages' => $pages,
                'model' => $model,
            ]);
        } else {
            return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWise', ['model' => $model]);
        }
    }
    public function actionFareCollectionAllocationWiseView($shiftId, $uId, $boothId, $deviecId, $ticketType, $ic, $sDate, $eDate, $isExit)
    {
        $isExit = $isExit == 'Exit' ? 1 : 0;
        $db = new yii\db\Connection(Yii::$app->db);

        setcookie("fareAllocationWiseView-shiftId", $shiftId, time() + 86400);
        setcookie("fareAllocationWiseView-uId", $uId, time() + 86400);
        setcookie("fareAllocationWiseView-boothId", $boothId, time() + 86400);
        setcookie("fareAllocationWiseView-deviecId", $deviecId, time() + 86400);
        setcookie("fareAllocationWiseView-ticketType", $ticketType, time() + 86400);
        setcookie("fareAllocationWiseView-ic", $ic, time() + 86400);
        setcookie("fareAllocationWiseView-sDate", $sDate, time() + 86400);
        setcookie("fareAllocationWiseView-eDate", $eDate, time() + 86400);
        setcookie("fareAllocationWiseView-isExit", $isExit, time() + 86400);

        if ($ticketType == 'Entrance') {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();

            $sql = "SELECT  ET.*,VC.name
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
        } else {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();

            $sql = "SELECT  ET.*,VC.name
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
        }

        $page = Yii::$app->request->get('page', 1);
        $limit = Yii::$app->request->get('per-page', 10);
        $from = ($page - 1) * $limit;

        $dResult = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
        $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

        $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

        return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWiseResult', [
            'dResults' => $dResult,
            'sResults' => $sResult,
            'pages' => $pages,
            'shiftId' => $shiftId,
            'uId' => $uId,
            'boothId' => $boothId,
            'deviecId' => $deviecId,
            'ticketType' => $ticketType,
            'ic' => $ic,
            'sDate' => $sDate,
            'eDate' => $eDate,
            'isExit' => $isExit,
        ]);
    }
    public function actionFareCollectionAllocationWiseExcel()
    {
        $db = new yii\db\Connection(Yii::$app->db);

        $shiftId = $_COOKIE["fareAllocationWiseView-shiftId"];
        $uId = $_COOKIE["fareAllocationWiseView-uId"];
        $boothId = $_COOKIE["fareAllocationWiseView-boothId"];
        $deviecId = $_COOKIE["fareAllocationWiseView-deviecId"];
        $ticketType = $_COOKIE["fareAllocationWiseView-ticketType"];
        $ic = $_COOKIE["fareAllocationWiseView-ic"];
        $sDate = $_COOKIE["fareAllocationWiseView-sDate"];
        $eDate = $_COOKIE["fareAllocationWiseView-eDate"];
        $isExit = $_COOKIE["fareAllocationWiseView-isExit"];

        if ($ticketType == 'Entrance') {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

        } else {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

        }

        return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWiseExcel', [
            'dResults' => $dResult,
            'sResults' => $sResult,
            'pages' => $pages,
            'shiftId' => $shiftId,
            'uId' => $uId,
            'boothId' => $boothId,
            'deviecId' => $deviecId,
            'ticketType' => $ticketType,
            'ic' => $ic,
            'sDate' => $sDate,
            'eDate' => $eDate,
            'isExit' => $isExit,
        ]);
    }
    public function actionFareCollectionAllocationWisePdf()
    {
        $db = new yii\db\Connection(Yii::$app->db);

        $shiftId = $_COOKIE["fareAllocationWiseView-shiftId"];
        $uId = $_COOKIE["fareAllocationWiseView-uId"];
        $boothId = $_COOKIE["fareAllocationWiseView-boothId"];
        $deviecId = $_COOKIE["fareAllocationWiseView-deviecId"];
        $ticketType = $_COOKIE["fareAllocationWiseView-ticketType"];
        $ic = $_COOKIE["fareAllocationWiseView-ic"];
        $sDate = $_COOKIE["fareAllocationWiseView-sDate"];
        $eDate = $_COOKIE["fareAllocationWiseView-eDate"];
        $isExit = $_COOKIE["fareAllocationWiseView-isExit"];

        if ($ticketType == 'Entrance') {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

        } else {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_all_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

        }

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('fareCollectionAllocationWise/fareCollectionAllocationWisePdf', [
            'dResults' => $dResult,
            'sResults' => $sResult,
            'pages' => $pages,
            'shiftId' => $shiftId,
            'uId' => $uId,
            'boothId' => $boothId,
            'deviecId' => $deviecId,
            'ticketType' => $ticketType,
            'ic' => $ic,
            'sDate' => $sDate,
            'eDate' => $eDate,
            'isExit' => $isExit,
        ]));
        $mpdf->Output('Fare Collection Allocation.pdf', 'D');
        exit();
    }
    public function actionAnalysisHourlyTraffic()
    {
        $model = new AnalysisHourlyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        $temp = [];
        $time_intervals = $db->createCommand("SELECT * FROM `time_intervals_for_report`")->queryAll();
        //echo json_encode($time_intervals);
        //die;
        $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();
        $i = 0;

        foreach ($time_intervals as $interval) {

            $sub_array_direction_1['time'] = $interval['start_time'] . '-' . $interval['end_time'];
            $sub_array_direction_1['direction'] = 1;

            $sub_array_direction_2['time'] = '';
            $sub_array_direction_2['direction'] = 2;

            foreach ($vehicle_categories as $category) {
                $sub_array_direction_1[$category['id']] = 0;
                $sub_array_direction_2[$category['id']] = 0;
            }

            $temp[$i . '-1'] = $sub_array_direction_1;
            $temp[$i . '-2'] = $sub_array_direction_2;
            $i++;
        }

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $results = [];
            if ($model->ticketType == 'exit') {
               

                $results = $db->createCommand("SELECT hour( ET.exit_time ) as hr, R.direction,ET.vehicle_category as vc,count(ET.vehicle_category) as count FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                    WHERE date(ET.exit_time) = '$model->date' AND ET.exit_ic = $model->ic GROUP BY hour (ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
            } else {
                $qq = $db->createCommand("SELECT * FROM `rpt_hourly_directional_traffic_entrance`")->queryAll();
                echo json_encode($qq);
                die;
                $results = $db->createCommand("SELECT hour( ET.entrance_time ) as hr, B.direction_id as direction,ET.vehicle_category as vc,count(ET.vehicle_category) as count
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                WHERE date(ET.entrance_time) = '$model->date' AND ET.entrance_ic = $model->ic
                GROUP BY hour (ET.entrance_time ),ET.vehicle_category,B.direction_id")->queryAll();
            }

            foreach ($results as $result) {
                $temp[$result['hr'] . '-' . $result['direction']][$result['vc']] = $result['count'];
            }

            return $this->render('//reports/analysisHourlyTraffic/analysisHourlyTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('//reports/analysisHourlyTraffic/analysisHourlyTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisHourlyTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisHourlyTraffic/analysisHourlyTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisHourlyTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisHourlyTraffic/analysisHourlyTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Hourly Traffic Report.pdf', 'D');
        exit();

    }
    public function actionAnalysisTimePeriodTraffic()
    {
        $model = new AnalysisTimePeriodTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            // print_r($model);die;
            $ics = $db->createCommand("SELECT * FROM tbl_ic I WHERE I.status = 1")->queryAll();
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();
            $i = 0;
            $results = [];

            foreach ($ics as $ic) {

                $sub_array_direction_1['ic'] = $ic['name'];
                $sub_array_direction_1['direction'] = 1;

                $sub_array_direction_2['ic'] = '';
                $sub_array_direction_2['direction'] = 2;

                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                $temp[$ic['name'] . '-1'] = $sub_array_direction_1;
                $temp[$ic['name'] . '-2'] = $sub_array_direction_2;
                $i++;
            }

            if ($model->ticketType == 'exit') {

                if ($model->startDate <= "2020-01-01 00:00") {
                    $results = $db->createCommand("SELECT K.ic_name,K.d_direction,EX.vehicle_category,count(*) as count
                    FROM (SELECT IC.name as ic_name,IC.id as ic_id,D.id as d_direction FROM tbl_ic IC CROSS JOIN tbl_direction D WHERE D.id != 3) K
                    LEFT JOIN (
                        SELECT *
                        FROM (SELECT *FROM tbl_all_exit_ticket
                                UNION
                                SELECT *FROM tbl_exit_ticket_2019_11
                                UNION
                                SELECT *FROM tbl_exit_ticket_2019_12
                                )ET
                        WHERE ET.exit_time >= '$model->startDate'
                        AND ET.exit_time <= '$model->endDate'
                        AND time(ET.exit_time) >= '$model->sTime'
                        AND time(ET.exit_time) <= '$model->eTime') as EX
                        ON EX.exit_ic = K.ic_id
                    INNER JOIN tbl_route R ON R.direction = K.d_direction AND R.source = EX.entrance_ic AND R.destination = EX.exit_ic
                    GROUP BY K.ic_id,K.d_direction,EX.vehicle_category")->queryAll();

                } else {
                    $results = $db->createCommand("SELECT K.ic_name,K.d_direction,EX.vehicle_category,count(*) as count
                    FROM (SELECT IC.name as ic_name,IC.id as ic_id,D.id as d_direction FROM tbl_ic IC CROSS JOIN tbl_direction D WHERE D.id != 3) K
                    LEFT JOIN (SELECT * FROM tbl_all_exit_ticket ET WHERE ET.exit_time >= '$model->startDate' AND ET.exit_time <= '$model->endDate' AND time(ET.exit_time) >= '$model->sTime' AND time(ET.exit_time) <= '$model->eTime') as EX ON EX.exit_ic = K.ic_id
                    INNER JOIN tbl_route R ON R.direction = K.d_direction AND R.source = EX.entrance_ic AND R.destination = EX.exit_ic
                    GROUP BY K.ic_id,K.d_direction,EX.vehicle_category")->queryAll();
                }
            } else {
                /*   $results = $db->createCommand("SELECT K.ic_name,K.d_direction,EX.vehicle_category,count(*) as count
                FROM (SELECT IC.name as ic_name,IC.id as ic_id,D.id as d_direction FROM tbl_ic IC CROSS JOIN tbl_direction D WHERE D.id != 3) K
                LEFT JOIN (SELECT * FROM tbl_entrance_ticket ET WHERE ET.entrance_time >= '$model->startDate' AND ET.entrance_time <= '$model->endDate' AND time(ET.entrance_time) >= '$model->sTime' AND time(ET.entrance_time) <= '$model->eTime') as EX ON EX.entrance_ic = K.ic_id
                INNER JOIN
                tbl_booth B ON B.id = EX.booth_id AND B.direction_id = K.d_direction
                GROUP BY K.ic_id,K.d_direction,EX.vehicle_category")->queryAll(); */

                $date2 = new DateTime($model->endDate);
                $date2->modify("+1 day");
                $related_date2 = $date2->format("Y-m-d H:i:s");

                if ($model->startDate <= "2020-01-01 00:00") {
                    //2019 DATA

                    $results = $db->createCommand("SELECT K.ic_name,K.d_direction,EX.vehicle_category,count(*) as count
                        FROM (
                            SELECT IC.name as ic_name,IC.id as ic_id,D.id as d_direction
                            FROM tbl_ic IC
                            CROSS JOIN tbl_direction D
                            WHERE D.id != 3
                            ) K
                        LEFT JOIN (
                            SELECT *
                            FROM (

                                SELECT ENT1.entrance_time,ENT1.serial_no,ENT1.vehicle_category,ENT1.entrance_ic FROM tbl_all_entrance_ticket ENT1
                                UNION
                                SELECT ENT2.entrance_time,ENT2.serial_no,ENT2.vehicle_category,ENT2.entrance_ic  FROM tbl_entrance_ticket_2019_11 ENT2
                                UNION
                                SELECT ENT3.entrance_time,ENT3.serial_no,ENT3.vehicle_category,ENT3.entrance_ic  FROM tbl_entrance_ticket_2019_12 ENT3

                            ) as ET
                            WHERE ET.entrance_time >= '$model->startDate'
                            AND ET.entrance_time <= '$model->endDate'
                            AND time(ET.entrance_time) >= '$model->sTime'
                            AND time(ET.entrance_time) <= '$model->eTime') as EX
                            ON EX.entrance_ic = K.ic_id
                        INNER JOIN (
                            SELECT TET.entrance_barcode,TET.exit_time,TET.exit_ic
                            FROM (
                                SELECT ET1.entrance_barcode,ET1.exit_time,ET1.exit_ic FROM tbl_all_exit_ticket ET1
                                UNION
                                SELECT ET2.entrance_barcode,ET2.exit_time,ET2.exit_ic FROM tbl_exit_ticket_2019_11 ET2
                                UNION
                                SELECT ET3.entrance_barcode,ET3.exit_time,ET3.exit_ic FROM tbl_exit_ticket_2019_12 ET3
                            )as TET
                            WHERE DATE(TET.exit_time) >= '$model->startDate'
                            AND DATE(TET.exit_time) <= '$related_date2'  ) as EE
                            ON EE.entrance_barcode = EX.serial_no
                        INNER JOIN tbl_route R ON R.direction = K.d_direction AND R.source = EX.entrance_ic AND R.destination =EE.exit_ic
                        GROUP BY K.ic_id,K.d_direction,EX.vehicle_category")->queryAll();
                } else {
                    //2020 Data
                    $results = $db->createCommand("SELECT K.ic_name,K.d_direction,EX.vehicle_category,count(*) as count
                    FROM (
                        SELECT IC.name as ic_name,IC.id as ic_id,D.id as d_direction
                        FROM tbl_ic IC
                        CROSS JOIN tbl_direction D
                        WHERE D.id != 3
                        ) K
                    LEFT JOIN (
                        SELECT ET.entrance_time,ET.serial_no,ET.vehicle_category,ET.entrance_ic
                        FROM  tbl_all_entrance_ticket ET
                        WHERE ET.entrance_time >= '$model->startDate'
                        AND ET.entrance_time <= '$model->endDate'
                        AND time(ET.entrance_time) >= '$model->sTime'
                        AND time(ET.entrance_time) <= '$model->eTime') as EX
                        ON EX.entrance_ic = K.ic_id
                    INNER JOIN (
                        SELECT TET.entrance_barcode,TET.exit_time,TET.exit_ic
                        FROM tbl_all_exit_ticket TET
                        WHERE DATE(TET.exit_time) >= '$model->startDate'
                        AND DATE(TET.exit_time) <= '$related_date2'  ) as EE
                        ON EE.entrance_barcode = EX.serial_no
                    INNER JOIN tbl_route R ON R.direction = K.d_direction AND R.source = EX.entrance_ic AND R.destination =EE.exit_ic
                    GROUP BY K.ic_id,K.d_direction,EX.vehicle_category")->queryAll();

                }

            }
            // print_r($results);die;
            foreach ($results as $result) {
                $temp[$result['ic_name'] . '-' . $result['d_direction']][$result['vehicle_category']] = $result['count'];
            }

            return $this->render('analysisTimePeriodTraffic/analysisTimePeriodTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisTimePeriodTraffic/analysisTimePeriodTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisTimePeriodTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisTimePeriodTraffic/analysisTimePeriodTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisTimePeriodTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisTimePeriodTraffic/analysisTimePeriodTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Time Period Traffic Report.pdf', 'D');
        exit();

    }
    public function actionAnalysisHourlySectionalTraffic()
    {
        $model = new HourlySectionTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $temp = [];
            $time_intervals = $db->createCommand("SELECT * FROM `time_intervals_for_report`")->queryAll();
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();
            $i = 0;

            foreach ($time_intervals as $interval) {

                $sub_array_direction_1['time'] = $interval['start_time'] . '-' . $interval['end_time'];
                $sub_array_direction_1['direction'] = 1;

                $sub_array_direction_2['time'] = '';
                $sub_array_direction_2['direction'] = 2;

                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                $temp[$i . '-1'] = $sub_array_direction_1;
                $temp[$i . '-2'] = $sub_array_direction_2;
                $i++;
            }

            $results = $db->createCommand("SELECT hour( ET.exit_time ) as hr,ET.vehicle_category as vc,count(ET.vehicle_category) as count, R.direction FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination = ET.exit_ic
                WHERE ET.exit_time >= '$model->startDate' AND ET.exit_time <= '$model->endDate' AND ((ET.exit_ic = $model->fIc OR ET.exit_ic = $model->sIc) OR (ET.entrance_ic = $model->fIc OR ET.entrance_ic = $model->sIc)) GROUP BY hour (ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();

            foreach ($results as $result) {
                $temp[$result['hr'] . '-' . $result['direction']][$result['vc']] = $result['count'];
            }

            return $this->render('analysisHourlySectionalTraffic/analysisHourlySectionalTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisHourlySectionalTraffic/analysisHourlySectionalTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisHourlySectionalTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisHourlySectionalTraffic/analysisHourlySectionalTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisHourlySectionalTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisHourlySectionalTraffic/analysisHourlySectionalTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Hourly Sectional Traffic Report.pdf', 'D');
        exit();

    }
    public function actionAnalysisTimePeriodRevenue()
    {
        $model = new AnalysisTimePeriodTraffic;
        $model->ticketType = 'exit';
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $ics = $db->createCommand("SELECT * FROM tbl_ic I WHERE I.status = 1")->queryAll();
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();
            $i = 0;
            $results = [];

            foreach ($ics as $ic) {

                $sub_array_direction_1['ic'] = $ic['name'];
                $sub_array_direction_1['direction'] = 1;

                $sub_array_direction_2['ic'] = '';
                $sub_array_direction_2['direction'] = 2;

                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                $temp[$ic['name'] . '-1'] = $sub_array_direction_1;
                $temp[$ic['name'] . '-2'] = $sub_array_direction_2;
                $i++;
            }

            // $db->createCommand("call timePeriodRevenue('$model->startDate','$model->endDate','$model->sTime','$model->eTime')")->query();
            $results = $db->createCommand("SELECT K.ic_name,K.d_direction,EX.vehicle_category,SUM(EX.amount) as count
                    FROM (SELECT IC.name as ic_name,IC.id as ic_id,D.id as d_direction FROM tbl_ic IC CROSS JOIN tbl_direction D WHERE D.id != 3) K
                    LEFT JOIN (SELECT * FROM tbl_all_exit_ticket ET WHERE ET.exit_time >= '$model->startDate' AND ET.exit_time <= '$model->endDate' AND time(ET.exit_time) >= '$model->sTime' AND time(ET.exit_time) <= '$model->eTime') as EX ON EX.exit_ic = K.ic_id
                    INNER JOIN tbl_route R ON R.direction = K.d_direction AND R.source = EX.entrance_ic AND R.destination = EX.exit_ic
                    GROUP BY K.ic_id,K.d_direction,EX.vehicle_category")->queryAll();

            foreach ($results as $result) {
                $temp[$result['ic_name'] . '-' . $result['d_direction']][$result['vehicle_category']] = $result['count'];
            }

            return $this->render('analysisTimePeriodRevenue/analysisTimePeriodRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisTimePeriodRevenue/analysisTimePeriodRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisTimePeriodRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisTimePeriodRevenue/analysisTimePeriodRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisTimePeriodRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisTimePeriodRevenue/analysisTimePeriodRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Time Period Traffic Report.pdf', 'D');
        exit();

    }
    public function actionAnalysisHourlyRevenue()
    {
        $model = new AnalysisHourlyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        $temp = [];
        $time_intervals = $db->createCommand("SELECT * FROM `time_intervals_for_report`")->queryAll();
        $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();
        $i = 0;

        foreach ($time_intervals as $interval) {

            $sub_array_direction_1['time'] = $interval['start_time'] . '-' . $interval['end_time'];
            $sub_array_direction_1['direction'] = 1;

            $sub_array_direction_2['time'] = '';
            $sub_array_direction_2['direction'] = 2;

            foreach ($vehicle_categories as $category) {
                $sub_array_direction_1[$category['id']] = 0;
                $sub_array_direction_2[$category['id']] = 0;
            }

            $temp[$i . '-1'] = $sub_array_direction_1;
            $temp[$i . '-2'] = $sub_array_direction_2;
            $i++;
        }

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $results = [];
            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT hour( ET.exit_time ) as hr, R.direction,ET.vehicle_category as vc,SUM(ET.amount) as amount
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                    WHERE date(ET.exit_time) = '$model->date'
                    GROUP BY hour (ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
            } else {
                $results = $db->createCommand("SELECT hour( ET.exit_time ) as hr, R.direction,ET.vehicle_category as vc,SUM(ET.amount) as amount
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                    WHERE date(ET.exit_time) = '$model->date' AND ET.exit_ic = $model->ic
                    GROUP BY hour (ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
            }

            foreach ($results as $result) {
                $temp[$result['hr'] . '-' . $result['direction']][$result['vc']] = $result['amount'];
            }

            return $this->render('analysisHourlyRevenue/analysisHourlyRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisHourlyRevenue/analysisHourlyRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisHourlyRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisHourlyRevenue/analysisHourlyRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisHourlyRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisHourlyRevenue/analysisHourlyRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Hourly Revenue Report.pdf', 'D');
        exit();

    }
    public function actionAnalysisDailyTraffic()
    {
        $model = new AnalysisDailyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();

            if ($model->ticketType == 'exit') {
                //entrance new
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptDailyTrafficDirectionalExitAny('" . $model->year . "', '" . $model->month . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL RptDailyTrafficDirectionalExit('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();
                    //  print_r($temp);die;

                }
            } else {

                //entrance new
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptDailyTrafficDirectionalEntranceAny('" . $model->year . "', '" . $model->month . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL RptDailyTrafficDirectionalEntrance('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();
                    //  print_r($temp);die;

                }

            }

            // foreach($results as $result){
            //     $temp[$result['day'].'-'.$result['direction']][$result['vc']] = $result['count'];
            // }

            return $this->render('analysisDailyTraffic/analysisDailyTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisDailyTraffic/analysisDailyTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisDailyTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisDailyTraffic/analysisDailyTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisDailyTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf(['format' => 'A4']);
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisDailyTraffic/analysisDailyTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Daily Traffic Report.pdf', 'D');
        exit();
    }
    public function actionAnalysisDailyRevenue()
    {
        $model = new AnalysisDailyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $results = [];
            $dates = [];
            $temp = [];
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();

            $month = $model->month;
            $year = $model->year;
            $year_month = $model->year . '-' . $model->month;

            for ($d = 1; $d <= 31; $d++) {
                $time = mktime(12, 0, 0, $month, $d, $year);
                if (date('m', $time) == $month) {
                    $dates[] = date('Y-m-d', $time);
                }

            }

            foreach ($dates as $date) {

                $sub_array_direction_1['date'] = $date;
                $sub_array_direction_1['direction'] = 1;

                $sub_array_direction_2['date'] = '';
                $sub_array_direction_2['direction'] = 2;

                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                $temp[$date . '-1'] = $sub_array_direction_1;
                $temp[$date . '-2'] = $sub_array_direction_2;

            }

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT date( ET.exit_time ) as day, R.direction,ET.vehicle_category as vc,SUM(ET.amount) as amount
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                    WHERE date(ET.exit_time) LIKE '%{$year_month}%'
                    GROUP BY date(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
            } else {
                $results = $db->createCommand("SELECT date( ET.exit_time ) as day, R.direction,ET.vehicle_category as vc,SUM(ET.amount) as amount
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination = ET.exit_ic
                    WHERE date(ET.exit_time) LIKE '%{$year_month}%' AND ET.exit_ic = $model->ic
                    GROUP BY date(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
            }

            foreach ($results as $result) {
                $temp[$result['day'] . '-' . $result['direction']][$result['vc']] = $result['amount'];
            }

            return $this->render('analysisDailyRevenue/analysisDailyRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisDailyRevenue/analysisDailyRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisDailyRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisDailyRevenue/analysisDailyRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisDailyRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisDailyRevenue/analysisDailyRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Daily Revenue Report.pdf', 'D');
        exit();
    }
    public function actionAnalysisMonthlyTraffic()
    {
        $model = new AnalysisMonthlyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $results = [];
            $dates = [];
            $temp = [];
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();
            $months = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
            $i = 1;

            foreach ($months as $month) {

                $sub_array_direction_1['date'] = $month;
                $sub_array_direction_1['direction'] = 1;

                $sub_array_direction_2['date'] = '';
                $sub_array_direction_2['direction'] = 2;

                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                $temp[$i . '-1'] = $sub_array_direction_1;
                $temp[$i . '-2'] = $sub_array_direction_2;
                ++$i;
            }

            if ($model->ticketType == 'exit') {
                if ($model->ic == 'Any') {
                    $results = $db->createCommand("SELECT month( ET.exit_time ) as month, R.direction,ET.vehicle_category as vc,count(ET.id) as count
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                        WHERE date(ET.exit_time) LIKE '%{$model->year}%'
                        GROUP BY month(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT month( ET.exit_time ) as month, R.direction,ET.vehicle_category as vc,count(ET.id) as count
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                        WHERE date(ET.exit_time) LIKE '%{$model->year}%' AND ET.exit_ic = $model->ic
                        GROUP BY month(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
                }
            } else {
                if ($model->ic == 'Any') {
                    $results = $db->createCommand("SELECT month( ET.entrance_time ) as month, B.direction_id direction,ET.vehicle_category as vc,count(ET.id) as count
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_booth B ON B.id = ET.booth_id
                        WHERE date(ET.entrance_time) LIKE '%{$model->year}%'
                        GROUP BY month(ET.entrance_time ),ET.vehicle_category,B.direction_id")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT month( ET.entrance_time ) as month, B.direction_id direction,ET.vehicle_category as vc,count(ET.id) as count
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_booth B ON B.id = ET.booth_id
                        WHERE date(ET.entrance_time) LIKE '%{$model->year}%' AND ET.entrance_ic = $model->ic
                        GROUP BY month(ET.entrance_time ),ET.vehicle_category,B.direction_id")->queryAll();
                }
            }

            foreach ($results as $result) {
                $temp[$result['month'] . '-' . $result['direction']][$result['vc']] = $result['count'];
            }

            return $this->render('analysisMonthlyTraffic/analysisMonthlyTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisMonthlyTraffic/analysisMonthlyTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisMonthlyTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisMonthlyTraffic/analysisMonthlyTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisMonthlyTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisMonthlyTraffic/analysisMonthlyTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Monthly Traffic Report.pdf', 'D');
        exit();
    }
    public function actionAnalysisMonthlyRevenue()
    {
        $model = new AnalysisMonthlyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $results = [];
            $dates = [];
            $temp = [];
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();
            $months = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
            $i = 1;

            foreach ($months as $month) {

                $sub_array_direction_1['date'] = $month;
                $sub_array_direction_1['direction'] = 1;

                $sub_array_direction_2['date'] = '';
                $sub_array_direction_2['direction'] = 2;

                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                $temp[$i . '-1'] = $sub_array_direction_1;
                $temp[$i . '-2'] = $sub_array_direction_2;
                ++$i;
            }

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT month( ET.exit_time ) as month, R.direction,ET.vehicle_category as vc,SUM(ET.amount) as amount
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                    WHERE date(ET.exit_time) LIKE '%{$model->year}%'
                    GROUP BY month(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
            } else {
                $results = $db->createCommand("SELECT month( ET.exit_time ) as month, R.direction,ET.vehicle_category as vc,SUM(ET.amount) as amount
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                    WHERE date(ET.exit_time) LIKE '%{$model->year}%' AND ET.exit_ic = $model->ic
                    GROUP BY month(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
            }

            foreach ($results as $result) {
                $temp[$result['month'] . '-' . $result['direction']][$result['vc']] = $result['amount'];
            }

            return $this->render('analysisMonthlyRevenue/analysisMonthlyRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisMonthlyRevenue/analysisMonthlyRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisMonthlyRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisMonthlyRevenue/analysisMonthlyRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisMonthlyRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisMonthlyRevenue/analysisMonthlyRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Monthly Revenue Report.pdf', 'D');
        exit();
    }
    public function actionAnalysisYearlyTraffic()
    {
        $model = new AnalysisYearlyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $results = [];
            $years = [];
            $temp = [];
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();

            for ($i = $model->year_from; $i <= $model->year_to; $i++) {
                $years[] = $i;
            }

            foreach ($years as $year) {

                $sub_array_direction_1['date'] = $year;
                $sub_array_direction_1['direction'] = 1;

                $sub_array_direction_2['date'] = '';
                $sub_array_direction_2['direction'] = 2;

                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                $temp[$year . '-1'] = $sub_array_direction_1;
                $temp[$year . '-2'] = $sub_array_direction_2;

            }

            if ($model->ticketType == 'exit') {
                if ($model->ic == 'Any') {
                    $results = $db->createCommand("SELECT year( ET.exit_time ) as year, R.direction,ET.vehicle_category as vc,count(ET.id) as count
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                        WHERE year(ET.exit_time) >= '$model->year_from' AND year(ET.exit_time) <= '$model->year_to'
                        GROUP BY year(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT year( ET.exit_time ) as year, R.direction,ET.vehicle_category as vc,count(ET.id) as count
                        FROM tbl_all_exit_ticket ET
                        INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                        WHERE year(ET.exit_time) >= '$model->year_from' AND year(ET.exit_time) <= '$model->year_to' AND ET.exit_ic = $model->ic
                        GROUP BY year(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
                }
            } else {
                if ($model->ic == 'Any') {
                    $results = $db->createCommand("SELECT year( ET.entrance_time ) as year, B.direction_id direction,ET.vehicle_category as vc,count(ET.id) as count
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_booth B ON B.id = ET.booth_id
                        WHERE year(ET.entrance_time) >= '$model->year_from' AND year(ET.entrance_time) <= '$model->year_to'
                        GROUP BY year(ET.entrance_time ),ET.vehicle_category,B.direction_id")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT year( ET.entrance_time ) as year, B.direction_id direction,ET.vehicle_category as vc,count(ET.id) as count
                        FROM tbl_all_entrance_ticket ET
                        INNER JOIN tbl_booth B ON B.id = ET.booth_id
                        WHERE year(ET.entrance_time) >= '$model->year_from' AND year(ET.entrance_time) <= '$model->year_to' AND ET.entrance_ic = $model->ic
                        GROUP BY year(ET.entrance_time ),ET.vehicle_category,B.direction_id")->queryAll();
                }
            }

            foreach ($results as $result) {
                $temp[$result['year'] . '-' . $result['direction']][$result['vc']] = $result['count'];
            }

            return $this->render('analysisYearlyTraffic/analysisYearlyTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisYearlyTraffic/analysisYearlyTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisYearlyTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisYearlyTraffic/analysisYearlyTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisYearlyTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisYearlyTraffic/analysisYearlyTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Yearly Traffic Report.pdf', 'D');
        exit();
    }
    public function actionAnalysisYearlyRevenue()
    {
        $model = new AnalysisYearlyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $results = [];
            $years = [];
            $temp = [];
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();

            for ($i = $model->year_from; $i <= $model->year_to; $i++) {
                $years[] = $i;
            }

            foreach ($years as $year) {

                $sub_array_direction_1['date'] = $year;
                $sub_array_direction_1['direction'] = 1;

                $sub_array_direction_2['date'] = '';
                $sub_array_direction_2['direction'] = 2;

                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                $temp[$year . '-1'] = $sub_array_direction_1;
                $temp[$year . '-2'] = $sub_array_direction_2;

            }

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT year( ET.exit_time ) as year, R.direction,ET.vehicle_category as vc,SUM(ET.id) as amount
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                    WHERE year(ET.exit_time) >= '$model->year_from' AND year(ET.exit_time) <= '$model->year_to'
                    GROUP BY year(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
            } else {
                $results = $db->createCommand("SELECT year( ET.exit_time ) as year, R.direction,ET.vehicle_category as vc,SUM(ET.id) as amount
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination =  ET.exit_ic
                    WHERE year(ET.exit_time) >= '$model->year_from' AND year(ET.exit_time) <= '$model->year_to' AND ET.exit_ic = $model->ic
                    GROUP BY year(ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();
            }

            foreach ($results as $result) {
                $temp[$result['year'] . '-' . $result['direction']][$result['vc']] = $result['amount'];
            }

            return $this->render('analysisYearlyRevenue/analysisYearlyRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisYearlyRevenue/analysisYearlyRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisYearlyRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisYearlyRevenue/analysisYearlyRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisYearlyRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisYearlyRevenue/analysisYearlyRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Yearly Revenue Report.pdf', 'D');
        exit();
    }
    public function actionIncidentLostTicket()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3")->queryAll();
            } else {
                $results = $db->createCommand("SELECT ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3 AND ET.exit_ic = $model->ic")->queryAll();
            }

            return $this->render('incidentLostTicket/incidentLostTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentLostTicket/incidentLostTicket', ['model' => $model]);
        }
    }
    public function actionIncidentLostTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentLostTicket/incidentLostTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentLostTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentLostTicket/incidentLostTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Lost Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentExpiredTicket()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT ET.exit_serial,ET.entrance_time,ET.exit_time,R.max_time,V.name vc,ET.amount,U.username,IC.name ic,B.name booth,D.name dname
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination = ET.exit_ic
                INNER JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                INNER JOIN user U ON U.id = ET.teller_id
                INNER JOIN tbl_devices D ON D.id = ET.device_id
                WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 4")->queryAll();
            } else {
                $results = $db->createCommand("SELECT ET.exit_serial,ET.entrance_time,ET.exit_time,R.max_time,V.name vc,ET.amount,U.username,IC.name ic,B.name booth,D.name dname
                FROM tbl_all_exit_ticket ET
                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination = ET.exit_ic
                INNER JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                INNER JOIN user U ON U.id = ET.teller_id
                INNER JOIN tbl_devices D ON D.id = ET.device_id
                WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 4 AND ET.exit_ic = $model->ic")->queryAll();
            }

            return $this->render('incidentExpiredTicket/incidentExpiredTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentExpiredTicket/incidentExpiredTicket', ['model' => $model]);
        }
    }
    public function actionIncidentExpiredTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentExpiredTicket/incidentExpiredTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentExpiredTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentExpiredTicket/incidentExpiredTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Expired Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentBookReceipt()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT ET.exit_serial,IFNULL(ET.entrance_serial,'-') entrance_serial,IFNULL(ET.entrance_time,'-') entrance_time,IC2.name ic_entrance,IC.name ic_exit,V.name vc,ET.amount,B.name booth,U.username
                FROM tbl_all_exit_ticket ET
                LEFT JOIN tbl_ic IC ON IC.id = ET.exit_ic
                LEFT JOIN tbl_ic IC2 ON IC2.id = ET.entrance_ic
                LEFT JOIN tbl_booth B ON B.id = ET.booth_id
                LEFT JOIN user U ON U.id = ET.teller_id
                LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 7")->queryAll();
            } else {
                $results = $db->createCommand("SELECT ET.exit_serial,IFNULL(ET.entrance_serial,'-') entrance_serial,IFNULL(ET.entrance_time,'-') entrance_time,IC2.name ic_entrance,IC.name ic_exit,V.name vc,ET.amount,B.name booth,U.username
                FROM tbl_all_exit_ticket ET
                LEFT JOIN tbl_ic IC ON IC.id = ET.exit_ic
                LEFT JOIN tbl_ic IC2 ON IC2.id = ET.entrance_ic
                LEFT JOIN tbl_booth B ON B.id = ET.booth_id
                LEFT JOIN user U ON U.id = ET.teller_id
                LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 7 AND ET.exit_ic = $model->ic")->queryAll();
            }

            return $this->render('incidentBookReceipt/incidentBookReceipt', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentBookReceipt/incidentBookReceipt', ['model' => $model]);
        }
    }
    public function actionIncidentBookReceiptExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentBookReceipt/incidentBookReceiptExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentBookReceiptPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentBookReceipt/incidentBookReceiptPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Book Receipt Report.pdf', 'D');
        exit();
    }
    public function actionIncidentCategoryChanged()
    {
        $model = new IncidentCategoryChanged;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                if ($model->teller == 'Any') {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 9 ")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 9 AND ET.teller_id = $model->teller")->queryAll();
                }
            } else {
                if ($model->teller == 'Any') {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 9 AND ET.exit_ic = $model->ic")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 9 AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic")->queryAll();
                }
            }

            return $this->render('incidentCategoryChanged/incidentCategoryChanged', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentCategoryChanged/incidentCategoryChanged', ['model' => $model]);
        }
    }
    public function actionIncidentCategoryChangedExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentCategoryChanged/incidentCategoryChangedExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentCategoryChangedPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentCategoryChanged/incidentCategoryChangedPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Category Changed Report.pdf', 'D');
        exit();
    }
    public function actionIncidentReprintTicket()
    {
        $model = new IncidentCategoryChanged;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                if ($model->teller == 'Any') {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username,COUNT(ET.id) as count
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 2
                    GROUP BY ET.exit_serial,ET.exit_time")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username,COUNT(ET.id) as count
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 2 AND ET.teller_id = $model->telle
                    GROUP BY ET.exit_serial,ET.exit_timer")->queryAll();
                }
            } else {
                if ($model->teller == 'Any') {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username,COUNT(ET.id) as count
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 2 AND ET.exit_ic = $model->ic
                    GROUP BY ET.exit_serial,ET.exit_time")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username,COUNT(ET.id) as count
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 2 AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic
                    GROUP BY ET.exit_serial,ET.exit_time")->queryAll();
                }
            }

            return $this->render('incidentReprintTicket/incidentReprintTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentReprintTicket/incidentReprintTicket', ['model' => $model]);
        }
    }
    public function actionIncidentReprintTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentReprintTicket/incidentReprintTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentReprintTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentReprintTicket/incidentReprintTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Reprint Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentManualTicket()
    {
        $model = new IncidentCategoryChanged;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                if ($model->teller == 'Any') {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 10 ")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 10 AND ET.teller_id = $model->teller")->queryAll();
                }
            } else {
                if ($model->teller == 'Any') {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 10 AND ET.exit_ic = $model->ic")->queryAll();
                } else {
                    $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 10 AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic")->queryAll();
                }
            }

            return $this->render('incidentManualTicket/incidentManualTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentManualTicket/incidentManualTicket', ['model' => $model]);
        }
    }
    public function actionIncidentManualTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentManualTicket/incidentManualTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentManualTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentManualTicket/incidentManualTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Manual Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentMissedIssuedTicket()
    {
        $model = new IncidentMissedIssuedTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ticket_type == 'entrance') {
                $sql = "SELECT ET.serial_no,ET.entrance_time,IC.name ic,B.name booth,V.name vc,U.username
                    FROM tbl_all_entrance_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.ticket_type_status_id = 12";
                if ($model->ic == 'Any') {
                    if ($model->teller == 'Any') {

                    } else {
                        $sql .= " AND ET.teller_id = $model->teller";
                    }
                } else {
                    if ($model->teller == 'Any') {
                        $sql .= " AND ET.entrance_ic = $model->ic";
                    } else {
                        $sql .= " AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller";
                    }
                }
            } else {
                $sql = "SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM tbl_all_exit_ticket ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 12";
                if ($model->ic == 'Any') {
                    if ($model->teller == 'Any') {

                    } else {
                        $sql .= " AND ET.teller_id = $model->teller";
                    }
                } else {
                    if ($model->teller == 'Any') {
                        $sql .= " AND ET.exit_ic = $model->ic";
                    } else {
                        $sql .= " AND ET.exit_ic = $model->ic AND ET.teller_id = $model->teller";
                    }
                }
            }

            $results = $db->createCommand($sql)->queryAll();

            return $this->render('incidentMissedIssuedTicket/incidentMissedIssuedTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentMissedIssuedTicket/incidentMissedIssuedTicket', ['model' => $model]);
        }
    }
    public function actionIncidentMissedIssuedTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentMissedIssuedTicket/incidentMissedIssuedTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentMissedIssuedTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentMissedIssuedTicket/incidentMissedIssuedTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Missed Issued Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentBlacklistedCard()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,ET.entrance_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_nfc_card N ON N.uid = ET.uid AND N.status = 0
                INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                INNER JOIN user U ON U.id = ET.teller_id
                INNER JOIN tbl_devices D ON D.id = ET.device_id
                INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.uid IS NOT NULL

                UNION

                SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,Ex.exit_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                FROM tbl_all_exit_ticket Ex
                INNER JOIN tbl_nfc_card N ON N.uid = Ex.uid AND N.status = 0
                INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                INNER JOIN tbl_booth B ON B.id = Ex.booth_id
                INNER JOIN user U ON U.id = Ex.teller_id
                INNER JOIN tbl_devices D ON D.id = Ex.device_id
                INNER JOIN tbl_ic IC ON IC.id = Ex.exit_ic
                WHERE Ex.exit_time >= '$model->start_date' AND Ex.exit_time <= '$model->end_date' AND Ex.uid IS NOT NULL")->queryAll();
            } else {
                $results = $db->createCommand("SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,ET.entrance_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                FROM tbl_all_entrance_ticket ET
                INNER JOIN tbl_nfc_card N ON N.uid = ET.uid AND N.status = 0
                INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                INNER JOIN user U ON U.id = ET.teller_id
                INNER JOIN tbl_devices D ON D.id = ET.device_id
                INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.uid IS NOT NULL AND ET.entrance_ic =  $model->ic

                UNION

                SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,Ex.exit_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                FROM tbl_all_exit_ticket Ex
                INNER JOIN tbl_nfc_card N ON N.uid = Ex.uid AND N.status = 0
                INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                INNER JOIN tbl_booth B ON B.id = Ex.booth_id
                INNER JOIN user U ON U.id = Ex.teller_id
                INNER JOIN tbl_devices D ON D.id = Ex.device_id
                INNER JOIN tbl_ic IC ON IC.id = Ex.exit_ic
                WHERE Ex.exit_time >= '$model->start_date' AND Ex.exit_time <= '$model->end_date' AND Ex.uid IS NOT NULL AND Ex.exit_ic =  $model->ic")->queryAll();
            }

            return $this->render('incidentBlacklistedCard/incidentBlacklistedCard', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentBlacklistedCard/incidentBlacklistedCard', ['model' => $model]);
        }
    }
    public function actionIncidentBlacklistedCardExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentBlacklistedCard/incidentBlacklistedCardExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentBlacklistedCardPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentBlacklistedCard/incidentBlacklistedCardPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Blacklisted Card Report.pdf', 'D');
        exit();
    }
    public function actionIncidentIncompleteTicket()
    {
        $model = new IncidentMissedIssuedTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ticket_type == 'entrance') {
                if ($model->ic == 'Any') {
                    if ($model->teller == 'Any') {
                        $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                        FROM tbl_all_entrance_ticket EN1
                        INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                        INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                        INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                        INNER JOIN user U ON U.id = EN1.teller_id
                        WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_all_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                        FROM tbl_all_entrance_ticket EN
                        WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date'))")->queryAll();
                    } else {
                        $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                        FROM tbl_all_entrance_ticket EN1
                        INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                        INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                        INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                        INNER JOIN user U ON U.id = EN1.teller_id
                        WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.teller_id = $model->teller AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_all_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                        FROM tbl_all_entrance_ticket EN
                        WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.teller_id = $model->teller))")->queryAll();

                    }
                } else {
                    if ($model->teller == 'Any') {
                        $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                        FROM tbl_all_entrance_ticket EN1
                        INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                        INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                        INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                        INNER JOIN user U ON U.id = EN1.teller_id
                        WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_all_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                        FROM tbl_all_entrance_ticket EN
                        WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic))")->queryAll();

                    } else {
                        $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                        FROM tbl_all_entrance_ticket EN1
                        INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                        INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                        INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                        INNER JOIN user U ON U.id = EN1.teller_id
                        WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.teller_id = $model->teller AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_all_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                        FROM tbl_all_entrance_ticket EN
                        WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.teller_id = $model->teller))")->queryAll();

                    }
                }
            } else {
                if ($model->ic == 'Any') {
                    if ($model->teller == 'Any') {
                        $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                            FROM tbl_all_exit_ticket ET
                            INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            INNER JOIN tbl_booth B ON B.id = ET.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            INNER JOIN user U ON U.id = ET.teller_id
                            WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3")->queryAll();
                    } else {
                        $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                            FROM tbl_all_exit_ticket ET
                            INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            INNER JOIN tbl_booth B ON B.id = ET.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            INNER JOIN user U ON U.id = ET.teller_id
                            WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3 AND ET.teller_id = $model->teller")->queryAll();

                    }
                } else {
                    if ($model->teller == 'Any') {
                        $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                            FROM tbl_all_exit_ticket ET
                            INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            INNER JOIN tbl_booth B ON B.id = ET.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            INNER JOIN user U ON U.id = ET.teller_id
                            WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3 AND ET.exit_ic = $model->ic")->queryAll();

                    } else {
                        $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                            FROM tbl_all_exit_ticket ET
                            INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            INNER JOIN tbl_booth B ON B.id = ET.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            INNER JOIN user U ON U.id = ET.teller_id
                            WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3 AND ET.exit_ic = $model->ic AND ET.teller_id = $model->teller")->queryAll();

                    }
                }
            }

            return $this->render('incidentIncompleteTicket/incidentIncompleteTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentIncompleteTicket/incidentIncompleteTicket', ['model' => $model]);
        }
    }
    public function actionIncidentIncompleteTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentIncompleteTicket/incidentIncompleteTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentIncompleteTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentIncompleteTicket/incidentIncompleteTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Incomplete Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentEscapeTicket()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT E.entrance_serial,E.entrance_time,E.exit_serial,E.exit_time,VC.name vc,B.name booth,E.amount,U.username teller,IC.name ic
                    FROM tbl_escape_tickets E
                    LEFT JOIN tbl_vehicle_category VC ON VC.id = E.vehicle_category
                    LEFT JOIN tbl_booth B ON B.id = E.booth_id
                    LEFT JOIN user U ON U.id = E.teller_id
                    LEFT JOIN tbl_ic IC ON IC.id = E.exit_ic
                    WHERE E.exit_time >= '$model->start_date' AND E.exit_time <= '$model->end_date'")->queryAll();
            } else {
                $results = $db->createCommand("SELECT E.entrance_serial,E.entrance_time,E.exit_serial,E.exit_time,VC.name vc,B.name booth,E.amount,U.username teller,IC.name ic
                    FROM tbl_escape_tickets E
                    LEFT JOIN tbl_vehicle_category VC ON VC.id = E.vehicle_category
                    LEFT JOIN tbl_booth B ON B.id = E.booth_id
                    LEFT JOIN user U ON U.id = E.teller_id
                    LEFT JOIN tbl_ic IC ON IC.id = E.exit_ic
                    WHERE E.exit_time >= '$model->start_date' AND E.exit_time <= '$model->end_date' AND E.exit_ic = $model->ic")->queryAll();
            }

            return $this->render('incidentEscapeTicket/incidentEscapeTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentEscapeTicket/incidentEscapeTicket', ['model' => $model]);
        }
    }
    public function actionIncidentEscapeTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentEscapeTicket/incidentEscapeTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentEscapeTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentEscapeTicket/incidentEscapeTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Escape Ticket Report.pdf', 'D');
        exit();
    }

    public function actionYearlyReport()
    {

        $model = new YearReportStats();

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            $results = $db->createCommand("SELECT t.name as tname,  d.name  as dname,  yr.vehicle_category as ca , SUM(yr.count) as count
            FROM tbl_year_report_stats yr
            INNER JOIN tbl_route ic on yr.source= ic.source and yr.destination = ic.destination
            inner join tbl_ic t on yr.source= t.id
            inner join tbl_ic d on yr.destination= d.id
            WHERE year ='$model->year'
            GROUP by yr.vehicle_category , t.name, d.name")->queryAll();

            foreach ($results as $result) {
                $temp[$result['tname'] . '-' . $result['dname']][$result['ca']] = $result['count'];

                $temp[$result['tname'] . '-' . $result['dname']]['name'] = $result['tname'];
                $temp[$result['tname'] . '-' . $result['dname']]['kname'] = $result['dname'];
                ++$i;

            }

            return $this->render('analysisYearlyReport/yearlyReport', ['model' => $model, 'results' => $temp, 'months' => $months]);
        } else {
            return $this->render('analysisYearlyReport/yearlyReport', ['model' => $model]);
        }
    }

    public function actionAnalysisYearReportExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisYearlyReport/analysisYearReportExcel', [
            'results' => $results,
            'model' => $model,

        ]);
    }

    public function actionAnalysisYearReportPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisYearlyReport/analysisYearReportPDF', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Yearly  Report.pdf', 'D');
        exit();
    }
    //ADT REPORT
    public function actionAverageDailyTrafficReport()
    {

        $db = new yii\db\Connection(Yii::$app->db);
        $model = new YearReportStats();

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            $ff = $db->createCommand("SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')) ")->execute();
            $months = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
            $ics = Ic::find()->orderBy([new \yii\db\Expression('FIELD(id,27,26,28,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,30,21,29,22,23,24,25)')])->all();

            return $this->render('averageDailyTrafficReport/averageDailyTrafficReport', [
                'model' => $model,
                'results' => $ics,
                'months' => $months,

            ]);
        } else {
            return $this->render('averageDailyTrafficReport/averageDailyTrafficReport', ['model' => $model]);
        }
    }

    public function actionAverageDailyTrafficReportExcel()
    {
        //  print_r("rrr");
        //  die;
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        return $this->render('averageDailyTrafficReport/averageDailyTrafficReportExcel', [
            'results' => $results,
            'model' => $model,
            'months' => $months,
            'routes' => $routes,
        ]);
    }

    public function actionAverageDailyTrafficReportPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('averageDailyTrafficReport/averageDailyTrafficReportPDF', [
            'results' => $results,
            'model' => $model,
            'months' => $months,
            'routes' => $routes,

        ]));
        $mpdf->Output('ADT.pdf', 'D');
        exit();
    }

}
