<?php

namespace app\controllers;

use app\models\AnalysisDailyRevenue;
use app\models\AnalysisDailyTraffic;
use app\models\AnalysisHourlyRevenue;
use app\models\AnalysisHourlyTraffic;
use app\models\AnalysisMonthlyRevenue;
use app\models\AnalysisMonthlyTraffic;
use app\models\AnalysisTimePeriodTraffic;
use app\models\AnalysisYearlyRevenue;
use app\models\AnalysisYearlyTraffic;
use app\models\BoothType;
use app\models\FareCollectionAllIcSummary;
use app\models\FareCollectionAllocationWise;
use app\models\FareCollectionBoothWise;
use app\models\FareCollectionPosWise;
use app\models\FareCollectionTellerWise;
use app\models\HourlySectionTraffic;
use app\models\Ic;
use app\models\IncidentCategoryChanged;
use app\models\IncidentLostTicket;
use app\models\IncidentMissedIssuedTicket;
use app\models\Route;
use app\models\VehicleCategory;
use app\models\YearReportStats;
use Yii;
use yii\data\Pagination;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\Json;
use yii\web\Controller;

/**
 * RouteController implements the CRUD actions for Route model.
 */
class ReportsController extends Controller
{
    // private $db = new yii\db\Connection(Yii::$app->db);
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        $requestroute = Yii::$app->requestedRoute;
        $editurl = '/' . $requestroute;
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'actions' => ['index', 'quick', 'view', 'create', 'update', 'delete', 'fare-collection-booth-wise',
                            'fare-collection-booth-wise-excel', 'fare-collection-booth-wise-pdf', 'fare-collection-teller-wise',
                            'fare-collection-teller-wise-excel', 'fare-collection-teller-wise-pdf', 'fare-collection-pos-wise',
                            'fare-collection-pos-wise-excel', 'fare-collection-pos-wise-pdf', 'fare-collection-all-ic-summary',
                            'fare-collection-all-ic-summary-excel', 'fare-collection-all-ic-summary-pdf', 'fare-collection-allocation-wise',
                            'fare-collection-allocation-wise-excel', 'fare-collection-allocation-wise-pdf', 'fare-collection-allocation-wise-view',
                            'analysis-hourly-traffic', 'analysis-hourly-traffic-excel', 'analysis-hourly-traffic-pdf', 'analysis-time-period-traffic',
                            'analysis-time-period-traffic-pdf', 'analysis-time-period-traffic-excel', 'analysis-hourly-sectional-traffic',
                            'analysis-hourly-sectional-traffic-excel', 'analysis-hourly-sectional-traffic-pdf', 'analysis-time-period-revenue'
                            , 'analysis-time-period-revenue-pdf', 'analysis-time-period-revenue-excel', 'analysis-hourly-revenue', 'analysis-hourly-revenue-pdf'
                            , 'analysis-hourly-revenue-excel', 'analysis-daily-traffic', 'analysis-daily-traffic-pdf', 'analysis-daily-traffic-excel',
                            'analysis-daily-revenue', 'analysis-daily-revenue-pdf', 'analysis-daily-revenue-excel', 'analysis-monthly-traffic',
                            'analysis-monthly-traffic-pdf', 'analysis-monthly-traffic-excel', 'analysis-monthly-revenue', 'analysis-monthly-revenue-pdf',
                            'analysis-monthly-revenue-excel', 'analysis-yearly-traffic', 'analysis-yearly-traffic-pdf', 'analysis-yearly-traffic-excel',
                            'analysis-yearly-revenue', 'analysis-yearly-revenue-pdf', 'analysis-yearly-revenue-excel', 'incident-lost-ticket',
                            'incident-lost-ticket-pdf', 'incident-lost-ticket-excel', 'incident-expired-ticket', 'incident-expired-ticket-pdf',
                            'incident-expired-ticket-excel', 'incident-book-receipt-pdf', 'incident-book-receipt', 'incident-book-receipt-excel',
                            'incident-category-changed', 'incident-category-changed-pdf', 'incident-category-changed-excel', 'incident-reprint-ticket',
                            'incident-reprint-ticket-pdf', 'incident-reprint-ticket-excel', 'incident-manual-ticket', 'incident-manual-ticket-pdf',
                            'incident-manual-ticket-excel', 'incident-missed-issued-ticket', 'incident-missed-issued-ticket-pdf', 'incident-missed-issued-ticket-excel',
                            'incident-blacklisted-card', 'incident-blacklisted-card-pdf', 'incident-blacklisted-card-excel', 'incident-incomplete-ticket',
                            'incident-incomplete-ticket-pdf', 'incident-incomplete-ticket-excel', 'incident-escape-ticket', 'incident-escape-ticket-pdf',
                            'incident-escape-ticket-excel', 'yearly-report', 'analysis-year-report-excel', 'analysis-year-report-pdf',
                            'average-daily-traffic-report', 'average-daily-traffic-report-excel', 'average-daily-traffic-report-pdf',
                            'average-daily-traffic-report2', 'average-daily-traffic-report-excel2', 'average-daily-traffic-report-pdf2',
                            'average-daily-traffic-report3', 'average-daily-traffic-report-excel3', 'average-daily-traffic-report-pdf3',
                            'analysis-time-period-traffic15',
                            'analysis-time-period-traffic15-pdf', 'analysis-time-period-traffic15-excel', 'analysis-session-cash', 'analysis-session-cash-pdf', 'analysis-session-cash-excel',
                        ],
                        'roles' => [$editurl],
                    ],
                ],
            ],
        ];
    }

    /**
     * Lists all Route models.
     * @return mixed
     */
    public function actionIndex()
    {

        return $this->render('index', [

        ]);
    }

    public function actionFareCollectionBoothWise()
    {

        $model = new FareCollectionBoothWise;

        if (Yii::$app->request->post() || Yii::$app->request->get()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);
                $db_archive = new yii\db\Connection(Yii::$app->db_archive);

            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                setcookie("fareBoothWise-IC", $model->ic, time() + 86400);
                setcookie("fareBoothWise-Booth", $model->booth, time() + 86400);
                setcookie("fareBoothWise-Type", $model->reportType, time() + 86400);
                setcookie("fareBoothWise-StartD", $model->startDate, time() + 86400);
                setcookie("fareBoothWise-EndD", $model->endDate, time() + 86400);
            } else {
                $model->ic = $_COOKIE["fareBoothWise-IC"];
                $model->booth = $_COOKIE["fareBoothWise-Booth"];
                $model->reportType = $_COOKIE["fareBoothWise-Type"];
                $model->startDate = $_COOKIE["fareBoothWise-StartD"];
                $model->endDate = $_COOKIE["fareBoothWise-EndD"];
            }

            $isExit = 0;
            $exitOrEntrance = $db->createCommand("SELECT `booth_type` FROM `tbl_booth` WHERE `id` = $model->booth")->queryScalar();

            if ($exitOrEntrance == BoothType::EXIT) {
                $isExit = 1;
            }

            if ($model->reportType == 'summary') {
                if ($isExit) {
                    $results = $db_archive->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();
                } else {
                    $results = $db_archive->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();
                }
                return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseSummaryResult', [
                    'results' => $results,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);

            } else if ($model->reportType == 'detailed') {

                $page = Yii::$app->request->get('page', 1);
                $limit = Yii::$app->request->get('per-page', 10);
                $from = ($page - 1) * $limit;

                //prepare SQL query
                if ($isExit) {
                  
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                } else {
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                }

                //Fire it!
                $result = $db_archive->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                
                $count = $db_archive->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

                $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
               //  print_r('fareCollectionBoothWiseDetailedResult');
               // print_r($result);die;

                return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseDetailedResult', [
                    'results' => $result,
                    'pages' => $pages,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);

            } else if ($model->reportType == 'all') {

                //summary report=========================
                if ($isExit) {
                    $sResults = $db_archive->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();
                } else {
                    $sResults = $db_archive->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();
                }
                //detailed report========================
                $page = Yii::$app->request->get('page', 1);
                $limit = Yii::$app->request->get('per-page', 10);
                $from = ($page - 1) * $limit;

                if ($isExit) {
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                } else {
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                }

                $dResults = $db_archive->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                $count = $db_archive->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

                $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

                return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseAllResult', [
                    'dResults' => $dResults,
                    'sResults' => $sResults,
                    'pages' => $pages,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);
            }
        } else {
            return $this->render('fareCollectionBoothWise/fareCollectionBoothWise', ['model' => $model]);
        }

    }

    public function actionFareCollectionBoothWiseExcel()
    {
        $model = new FareCollectionBoothWise;
        $db = new yii\db\Connection(Yii::$app->db);
    $db_archive = new yii\db\Connection(Yii::$app->db_archive);
        $model->ic = $_COOKIE["fareBoothWise-IC"];
        $model->booth = $_COOKIE["fareBoothWise-Booth"];
        $model->reportType = $_COOKIE["fareBoothWise-Type"];
        $model->startDate = $_COOKIE["fareBoothWise-StartD"];
        $model->endDate = $_COOKIE["fareBoothWise-EndD"];

        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT `booth_type` FROM `tbl_booth` WHERE `id` = $model->booth")->queryScalar();

        if ($exitOrEntrance == BoothType::EXIT) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                $results = $db_archive->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            } else {
                $results = $db_archive->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            }

            return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseSummaryExcel', [
                'results' => $results,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $results = $db_archive->createCommand("SELECT  ET.*,VC.name
                        FROM tbl_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $results = $db_archive->createCommand("SELECT  ET.*,VC.name
                        FROM tbl_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseDetailedExcel', [
                'results' => $results,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        } else if ($model->reportType == 'all') {

            if ($isExit) {
                $sResults = $db_archive->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                $dResults = $db_archive->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $sResults = $db_archive->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                $dResults = $db_archive->createCommand("SELECT ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseAllExcel', [
                'sResults' => $sResults,
                'dResults' => $dResults,
                'model' => $model,
                'isExit' => $isExit,
            ]);
        }
    }

    public function actionFareCollectionBoothWisePdf()
    {
        $model = new FareCollectionBoothWise;
        $db = new yii\db\Connection(Yii::$app->db);
 $db_archive = new yii\db\Connection(Yii::$app->db_archive);
        $model->ic = $_COOKIE["fareBoothWise-IC"];
        $model->booth = $_COOKIE["fareBoothWise-Booth"];
        $model->reportType = $_COOKIE["fareBoothWise-Type"];
        $model->startDate = $_COOKIE["fareBoothWise-StartD"];
        $model->endDate = $_COOKIE["fareBoothWise-EndD"];

        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT `booth_type` FROM `tbl_booth` WHERE `id` = $model->booth")->queryScalar();

        if ($exitOrEntrance == BoothType::EXIT) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                $results = $db_archive->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            } else {
                $results = $db_archive->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionBoothWise/fareCollectionBoothWiseSummaryPdf', array('results' => $results, 'model' => $model,
                'isExit' => $isExit)));
            $mpdf->Output('Fare Collection Booth Wise Summery Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $results = $db_archive->createCommand("SELECT ET.*,VC.name
                        FROM tbl_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $results = $db_archive->createCommand("SELECT ET.*,VC.name
                        FROM tbl_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionBoothWise/fareCollectionBoothWiseDetailedPdf', array('results' => $results, 'model' => $model,
                'isExit' => $isExit)));
            $mpdf->Output('Fare Collection Booth Wise Detailed Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'all') {

            if ($isExit) {
                $sResults = $db_archive->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                $dResults = $db_archive->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $sResults = $db_archive->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                $dResults = $db_archive->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionBoothWise/fareCollectionBoothWiseAllPdf', array('sResults' => $sResults, 'dResults' => $dResults, 'model' => $model,
                'isExit' => $isExit)));
            $mpdf->Output('Fare Collection Booth Wise Summary & Detailed Pdf.pdf', 'D');
            exit();
        }
    }

    public function actionFareCollectionTellerWise()
    {
        $model = new FareCollectionTellerWise;

        if (Yii::$app->request->post() || Yii::$app->request->get()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);

            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                setcookie("fareTellerWise-IC", $model->ic, time() + 86400);
                setcookie("fareTellerWise-Teller", $model->teller, time() + 86400);
                setcookie("fareTellerWise-Type", $model->reportType, time() + 86400);
                setcookie("fareTellerWise-StartD", $model->startDate, time() + 86400);
                setcookie("fareTellerWise-EndD", $model->endDate, time() + 86400);
            } else {
                $model->ic = $_COOKIE["fareTellerWise-IC"];
                $model->teller = $_COOKIE["fareTellerWise-Teller"];
                $model->reportType = $_COOKIE["fareTellerWise-Type"];
                $model->startDate = $_COOKIE["fareTellerWise-StartD"];
                $model->endDate = $_COOKIE["fareTellerWise-EndD"];
            }

            if ($model->reportType == 'summary') {

                $enResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseSummaryResult', [
                    'model' => $model,
                    'enResults' => $enResult,
                    'exResults' => $exResults,

                ]);

            } else if ($model->reportType == 'detailed') {

                //entrance
                $page_en = Yii::$app->request->get('page', 1);
                $limit_en = Yii::$app->request->get('per-page', 10);
                $from_en = ($page_en - 1) * $limit_en;

                $sql_en = "SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";

                $result_en = $db->createCommand($sql_en . ' LIMIT ' . $from_en . ',' . $limit_en)->queryAll();
                $count_en = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_en . ') a')->queryScalar();

                $pages_en = new Pagination(['totalCount' => $count_en, 'pageSize' => $limit_en]);

                //exit
                $page_ex = Yii::$app->request->get('page', 1);
                $limit_ex = Yii::$app->request->get('per-page', 10);
                $from_ex = ($page_ex - 1) * $limit_ex;

                $sql_ex = "SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";

                $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                $pages_ex = new Pagination(['totalCount' => $count_ex, 'pageSize' => $limit_ex]);

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseDetailedResult', [
                    'results_en' => $result_en,
                    'results_ex' => $result_ex,
                    'pages_en' => $pages_en,
                    'pages_ex' => $pages_ex,
                    'model' => $model,
                ]);

            } else if ($model->reportType == 'all') {
                //entrance summary
                $enResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                //exit summary
                $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
                //entrance detailed
                $page_en = Yii::$app->request->get('page', 1);
                $limit_en = Yii::$app->request->get('per-page', 10);
                $from_en = ($page_en - 1) * $limit_en;

                $sql_en = "SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";

                $result_en = $db->createCommand($sql_en . ' LIMIT ' . $from_en . ',' . $limit_en)->queryAll();
                $count_en = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_en . ') a')->queryScalar();

                $pages_en = new Pagination(['totalCount' => $count_en, 'pageSize' => $limit_en]);

                //exit detailed
                $page_ex = Yii::$app->request->get('page', 1);
                $limit_ex = Yii::$app->request->get('per-page', 10);
                $from_ex = ($page_ex - 1) * $limit_ex;

                $sql_ex = "SELECT ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";

                $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                $pages_ex = new Pagination(['totalCount' => $count_ex, 'pageSize' => $limit_ex]);

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseAllResult', [
                    'results_en' => $result_en,
                    'results_ex' => $result_ex,
                    'enResults' => $enResults,
                    'exResults' => $exResults,
                    'pages_en' => $pages_en,
                    'pages_ex' => $pages_ex,
                    'model' => $model,
                ]);

            }
        } else {
            return $this->render('fareCollectionTellerWise/fareCollectionTellerWise', ['model' => $model]);
        }
    }
    public function actionFareCollectionTellerWiseExcel()
    {

        $model = new FareCollectionTellerWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["fareTellerWise-IC"];
        $model->teller = $_COOKIE["fareTellerWise-Teller"];
        $model->reportType = $_COOKIE["fareTellerWise-Type"];
        $model->startDate = $_COOKIE["fareTellerWise-StartD"];
        $model->endDate = $_COOKIE["fareTellerWise-EndD"];

        if ($model->reportType == 'summary') {

            $enSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                 FROM tbl_vehicle_category VC
                 LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                 GROUP BY VC.id")->queryAll();

            $exSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                 FROM tbl_vehicle_category VC
                 LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                 GROUP BY VC.id")->queryAll();

            return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseSummaryExcel', [
                'enSResults' => $enSResults,
                'exSResults' => $exSResults,
                'model' => $model,
            ]);

        } else if ($model->reportType == 'detailed') {

            $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseDetailedExcel', [
                'enDResults' => $enDResults,
                'exDResults' => $exDResults,
                'model' => $model,
            ]);

        } else if ($model->reportType == 'all') {

            $enSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                GROUP BY VC.id")->queryAll();

            $exSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                GROUP BY VC.id")->queryAll();

            $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseAllExcel', [
                'enSResults' => $enSResults,
                'exSResults' => $exSResults,
                'enDResults' => $enDResults,
                'exDResults' => $exDResults,
                'model' => $model,
            ]);
        }

    }
    public function actionFareCollectionTellerWisePdf()
    {
        $model = new FareCollectionTellerWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["fareTellerWise-IC"];
        $model->teller = $_COOKIE["fareTellerWise-Teller"];
        $model->reportType = $_COOKIE["fareTellerWise-Type"];
        $model->startDate = $_COOKIE["fareTellerWise-StartD"];
        $model->endDate = $_COOKIE["fareTellerWise-EndD"];

        if ($model->reportType == 'summary') {

            $enResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                 FROM tbl_vehicle_category VC
                 LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                 GROUP BY VC.id")->queryAll();

            $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                 FROM tbl_vehicle_category VC
                 LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                 GROUP BY VC.id")->queryAll();

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionTellerWise/fareCollectionTellerWiseSummaryPdf', array('enResults' => $enResults, 'exResults' => $exResults, 'model' => $model)));
            $mpdf->Output('Fare Collection Teller Wise Summary Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'detailed') {

            $enResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionTellerWise/fareCollectionTellerWiseDetailedPdf', array('enResults' => $enResults, 'exResults' => $exResults, 'model' => $model)));
            $mpdf->Output('Fare Collection Teller Wise Detailed Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'all') {

            $enSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                GROUP BY VC.id")->queryAll();

            $exSResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                GROUP BY VC.id")->queryAll();

            $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionTellerWise/fareCollectionTellerWiseAllPdf', array('enSResults' => $enSResults, 'exSResults' => $exSResults, 'enDResults' => $enDResults, 'exDResults' => $exDResults, 'model' => $model)));
            $mpdf->Output('Fare Collection Teller Wise All Pdf.pdf', 'D');
            exit();
        }
    }

    public function actionFareCollectionPosWise()
    {

        $model = new FareCollectionPosWise;

        if (Yii::$app->request->post() || Yii::$app->request->get()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);

            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                setcookie("farePosWise-IC", $model->ic, time() + 86400);
                setcookie("farePosWise-Pos", $model->pos, time() + 86400);
                setcookie("farePosWise-Type", $model->reportType, time() + 86400);
                setcookie("farePosWise-StartD", $model->startDate, time() + 86400);
                setcookie("farePosWise-EndD", $model->endDate, time() + 86400);
            } else {
                $model->ic = $_COOKIE["farePosWise-IC"];
                $model->pos = $_COOKIE["farePosWise-Pos"];
                $model->reportType = $_COOKIE["farePosWise-Type"];
                $model->startDate = $_COOKIE["farePosWise-StartD"];
                $model->endDate = $_COOKIE["farePosWise-EndD"];
            }

            $isExit = 0;
            $exitOrEntrance = $db->createCommand("SELECT BT.id
                FROM tbl_booth_devices BD
                INNER JOIN tbl_booth B ON B.id = BD.booth_id
                INNER JOIN tbl_booth_type BT ON BT.id = B.booth_type
                WHERE BD.device_id = $model->pos AND BD.ic_id = $model->ic AND BD.status = 1")->queryScalar();

            if ($exitOrEntrance == BoothType::exit) {
                $isExit = 1;
            }

            if ($model->reportType == 'summary') {

                if ($isExit) {
                    $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();

                } else {
                    $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();

                }

                return $this->render('fareCollectionPosWise/fareCollectionPosWiseSummaryResult', [
                    'results' => $results,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);

            } else if ($model->reportType == 'detailed') {

                $page = Yii::$app->request->get('page', 1);
                $limit = Yii::$app->request->get('per-page', 10);
                $from = ($page - 1) * $limit;

                if ($isExit) {
                    $sql = "SELECT  ET.*,VC.name
                        FROM tbl_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                } else {
                    $sql = "SELECT ET.*,VC.name
                        FROM tbl_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                }

                $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

                $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

                return $this->render('fareCollectionPosWise/fareCollectionPosWiseDetailedResult', [
                    'results' => $result,
                    'pages' => $pages,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);

            } else if ($model->reportType == 'all') {

                $page = Yii::$app->request->get('page', 1);
                $limit = Yii::$app->request->get('per-page', 10);
                $from = ($page - 1) * $limit;

                if ($isExit) {
                    $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();

                    $sql = "SELECT  ET.*,VC.name
                        FROM tbl_exit_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                } else {
                    $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                        FROM tbl_vehicle_category VC
                        LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        GROUP BY VC.id")->queryAll();

                    $sql = "SELECT  ET.*,VC.name
                        FROM tbl_entrance_ticket ET
                        INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                }

                $dResults = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

                $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

                return $this->render('fareCollectionPosWise/fareCollectionPosWiseAllResult', [
                    'sResults' => $sResults,
                    'dResults' => $dResults,
                    'pages' => $pages,
                    'model' => $model,
                    'isExit' => $isExit,
                ]);
            }
        } else {
            return $this->render('fareCollectionPosWise/fareCollectionPosWise', ['model' => $model]);
        }

    }
    public function actionFareCollectionPosWiseExcel()
    {

        $model = new FareCollectionPosWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["farePosWise-IC"];
        $model->pos = $_COOKIE["farePosWise-Pos"];
        $model->reportType = $_COOKIE["farePosWise-Type"];
        $model->startDate = $_COOKIE["farePosWise-StartD"];
        $model->endDate = $_COOKIE["farePosWise-EndD"];
        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT BT.id
            FROM tbl_booth_devices BD
            INNER JOIN tbl_booth B ON B.id = BD.booth_id
            INNER JOIN tbl_booth_type BT ON BT.id = B.booth_type
            WHERE BD.device_id = $model->pos AND BD.ic_id = $model->ic AND BD.status = 1")->queryScalar();

        if ($exitOrEntrance == BoothType::exit) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

            }

            return $this->render('fareCollectionPosWise/fareCollectionPosWiseSummaryExcel', [
                'sResults' => $sResults,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            } else {
                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            }

            return $this->render('fareCollectionPosWise/fareCollectionPosWiseDetailedExcel', [
                'dResults' => $dResults,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        } else if ($model->reportType == 'all') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            }

            return $this->render('fareCollectionPosWise/fareCollectionPosWiseAllExcel', [
                'dResults' => $dResults,
                'sResults' => $sResults,
                'model' => $model,
                'isExit' => $isExit,
            ]);

        }
    }

    public function actionFareCollectionPosWisePdf()
    {
        $model = new FareCollectionPosWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["farePosWise-IC"];
        $model->pos = $_COOKIE["farePosWise-Pos"];
        $model->reportType = $_COOKIE["farePosWise-Type"];
        $model->startDate = $_COOKIE["farePosWise-StartD"];
        $model->endDate = $_COOKIE["farePosWise-EndD"];
        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT BT.id
            FROM tbl_booth_devices BD
            INNER JOIN tbl_booth B ON B.id = BD.booth_id
            INNER JOIN tbl_booth_type BT ON BT.id = B.booth_type
            WHERE BD.device_id = $model->pos AND BD.ic_id = $model->ic AND BD.status = 1")->queryScalar();

        if ($exitOrEntrance == BoothType::exit) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionPosWise/fareCollectionPosWiseSummaryPdf', [
                'sResults' => $sResults,
                'model' => $model,
                'isExit' => $isExit,
            ]));
            $mpdf->Output('Fare Collection POS Wise Summary Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            } else {
                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionPosWise/fareCollectionPosWiseDetailedPdf', [
                'dResults' => $dResults,
                'model' => $model,
                'isExit' => $isExit,
            ]));
            $mpdf->Output('Fare Collection POS Wise Detailed Pdf.pdf', 'D');
            exit();

        } else if ($model->reportType == 'all') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionPosWise/fareCollectionPosWiseAllPdf', [
                'dResults' => $dResults,
                'sResults' => $sResults,
                'model' => $model,
                'isExit' => $isExit,
            ]));
            $mpdf->Output('Fare Collection POS Wise All Pdf.pdf', 'D');
            exit();

        }
    }

    public function actionFareCollectionAllIcSummary()
    {
        $model = new FareCollectionAllIcSummary;

        if (Yii::$app->request->post()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);

            $model->load(Yii::$app->request->post());
            setcookie("fareCollectionAllIcSummary-Type", $model->ticketType, time() + 86400);
            setcookie("fareCollectionAllIcSummary-StartD", $model->startDate, time() + 86400);
            setcookie("fareCollectionAllIcSummary-EndD", $model->endDate, time() + 86400);

            if ($model->ticketType == 'entrance') {

                $vehicleTypes = VehicleCategory::find()->all();
                $sql_main = "CALL Rpt_AllICEntranceSummary('" . $model->startDate . "', '" . $model->endDate . "')";
                $results = $db->createCommand($sql_main)->queryAll();
                return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);

            } else if ($model->ticketType == 'exit(traffic)') {

                $vehicleTypes = VehicleCategory::find()->all();
                $sql_main = "CALL Rpt_AllICExitSummary('" . $model->startDate . "', '" . $model->endDate . "')";
                $results = $db->createCommand($sql_main)->queryAll();
                return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);

            } else if ($model->ticketType == 'exit(revenue)') {

                $vehicleTypes = VehicleCategory::find()->all();
                $sql_main = "CALL Rpt_AllICExitSummaryAmount('" . $model->startDate . "', '" . $model->endDate . "')";
                $results = $db->createCommand($sql_main)->queryAll();
                return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);

            }

        } else {
            return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model]);
        }
    }

    public function actionFareCollectionAllIcSummaryExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $vehicleTypes = json::decode($_POST['vCategor']);

        if ($model['ticketType'] == 'entrance') {

            return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummaryEntranceExcel', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);

        } else if ($model['ticketType'] == 'exit(traffic)' || $model['ticketType'] == 'exit(revenue)') {

            return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummaryExitExcel', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);
        }
    }
    public function actionFareCollectionAllIcSummaryPdf()
    {

        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $vehicleTypes = json::decode($_POST['vCategor']);

        if ($model['ticketType'] == 'entrance') {

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionAllIcSummary/fareCollectionAllIcSummaryEntrancePdf', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]));
            $mpdf->Output('Fare Collection All Ic Summary(Entrance).pdf', 'D');
            exit();

        } else if ($model['ticketType'] == 'exit(traffic)' || $model['ticketType'] == 'exit(revenue)') {

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionAllIcSummary/fareCollectionAllIcSummaryExitPdf', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]));
            $mpdf->Output('Fare Collection All Ic Summary(Exit).pdf', 'D');
            exit();
        }
    }

    public function actionFareCollectionAllocationWise()
    {
        $model = new FareCollectionAllocationWise;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post() || Yii::$app->request->get()) {

            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                setcookie("fareAllocationWise-IC", $model->ic, time() + 86400);
                setcookie("fareAllocationWise-StartD", $model->startDate, time() + 86400);
                setcookie("fareAllocationWise-EndD", $model->endDate, time() + 86400);
            } else {
                $model->ic = $_COOKIE["fareAllocationWise-IC"];
                $model->startDate = $_COOKIE["fareAllocationWise-StartD"];
                $model->endDate = $_COOKIE["fareAllocationWise-EndD"];
            }

            $sdate = date('Y-m-d', strtotime($model->startDate));
            $edate = date('Y-m-d', strtotime($model->endDate));

            $page = Yii::$app->request->get('page', 1);
            $limit = Yii::$app->request->get('per-page', 10);
            $from = ($page - 1) * $limit;

            $sql = "SELECT SESU.user_id,SES.booth_id,BD.device_id,DATE_FORMAT(concat(SCH.date,' ',SES.start_time), '%Y-%m-%d %H:%i') as sDate,DATE_FORMAT(concat(SCH.date,' ',SES.end_time), '%Y-%m-%d %H:%i') as eDate,SHF.id shiftId
                FROM tbl_schedule SCH
                INNER JOIN tbl_shift SHF ON SHF.schedule_id = SCH.id AND SHF.ic_id = $model->ic
                INNER JOIN tbl_session SES ON SES.shift_id = SHF.id
                INNER JOIN tbl_session_users SESU ON SESU.session_id = SES.id
                INNER JOIN tbl_booth_devices BD ON BD.booth_id = SES.booth_id AND BD.status = 1
                WHERE SCH.date >= '" . $sdate . "' AND SCH.date <= '" . $edate . "' AND DATE_FORMAT(concat(SCH.date,' ',SES.start_time), '%Y-%m-%d %H:%i') > '" . $model->startDate . "' AND DATE_FORMAT(concat(SCH.date,' ',SES.start_time), '%Y-%m-%d %H:%i') < '" . $model->endDate . "'";

            $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
            $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

            $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

            return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWise', [
                'results' => $result,
                'pages' => $pages,
                'model' => $model,
            ]);
        } else {
            return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWise', ['model' => $model]);
        }
    }
    public function actionFareCollectionAllocationWiseView($shiftId, $uId, $boothId, $deviecId, $ticketType, $ic, $sDate, $eDate, $isExit)
    {
        $isExit = $isExit == 'Exit' ? 1 : 0;
        $db = new yii\db\Connection(Yii::$app->db);

        setcookie("fareAllocationWiseView-shiftId", $shiftId, time() + 86400);
        setcookie("fareAllocationWiseView-uId", $uId, time() + 86400);
        setcookie("fareAllocationWiseView-boothId", $boothId, time() + 86400);
        setcookie("fareAllocationWiseView-deviecId", $deviecId, time() + 86400);
        setcookie("fareAllocationWiseView-ticketType", $ticketType, time() + 86400);
        setcookie("fareAllocationWiseView-ic", $ic, time() + 86400);
        setcookie("fareAllocationWiseView-sDate", $sDate, time() + 86400);
        setcookie("fareAllocationWiseView-eDate", $eDate, time() + 86400);
        setcookie("fareAllocationWiseView-isExit", $isExit, time() + 86400);

        if ($ticketType == 'Entrance') {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();

            $sql = "SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
        } else {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();

            $sql = "SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
        }

        $page = Yii::$app->request->get('page', 1);
        $limit = Yii::$app->request->get('per-page', 10);
        $from = ($page - 1) * $limit;

        $dResult = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
        $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

        $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

        return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWiseResult', [
            'dResults' => $dResult,
            'sResults' => $sResult,
            'pages' => $pages,
            'shiftId' => $shiftId,
            'uId' => $uId,
            'boothId' => $boothId,
            'deviecId' => $deviecId,
            'ticketType' => $ticketType,
            'ic' => $ic,
            'sDate' => $sDate,
            'eDate' => $eDate,
            'isExit' => $isExit,
        ]);
    }
    public function actionFareCollectionAllocationWiseExcel()
    {
        $db = new yii\db\Connection(Yii::$app->db);

        $shiftId = $_COOKIE["fareAllocationWiseView-shiftId"];
        $uId = $_COOKIE["fareAllocationWiseView-uId"];
        $boothId = $_COOKIE["fareAllocationWiseView-boothId"];
        $deviecId = $_COOKIE["fareAllocationWiseView-deviecId"];
        $ticketType = $_COOKIE["fareAllocationWiseView-ticketType"];
        $ic = $_COOKIE["fareAllocationWiseView-ic"];
        $sDate = $_COOKIE["fareAllocationWiseView-sDate"];
        $eDate = $_COOKIE["fareAllocationWiseView-eDate"];
        $isExit = $_COOKIE["fareAllocationWiseView-isExit"];

        if ($ticketType == 'Entrance') {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

        } else {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

        }

        return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWiseExcel', [
            'dResults' => $dResult,
            'sResults' => $sResult,
            'pages' => $pages,
            'shiftId' => $shiftId,
            'uId' => $uId,
            'boothId' => $boothId,
            'deviecId' => $deviecId,
            'ticketType' => $ticketType,
            'ic' => $ic,
            'sDate' => $sDate,
            'eDate' => $eDate,
            'isExit' => $isExit,
        ]);
    }
    public function actionFareCollectionAllocationWisePdf()
    {
        $db = new yii\db\Connection(Yii::$app->db);

        $shiftId = $_COOKIE["fareAllocationWiseView-shiftId"];
        $uId = $_COOKIE["fareAllocationWiseView-uId"];
        $boothId = $_COOKIE["fareAllocationWiseView-boothId"];
        $deviecId = $_COOKIE["fareAllocationWiseView-deviecId"];
        $ticketType = $_COOKIE["fareAllocationWiseView-ticketType"];
        $ic = $_COOKIE["fareAllocationWiseView-ic"];
        $sDate = $_COOKIE["fareAllocationWiseView-sDate"];
        $eDate = $_COOKIE["fareAllocationWiseView-eDate"];
        $isExit = $_COOKIE["fareAllocationWiseView-isExit"];

        if ($ticketType == 'Entrance') {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

        } else {
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

        }

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('fareCollectionAllocationWise/fareCollectionAllocationWisePdf', [
            'dResults' => $dResult,
            'sResults' => $sResult,
            'pages' => $pages,
            'shiftId' => $shiftId,
            'uId' => $uId,
            'boothId' => $boothId,
            'deviecId' => $deviecId,
            'ticketType' => $ticketType,
            'ic' => $ic,
            'sDate' => $sDate,
            'eDate' => $eDate,
            'isExit' => $isExit,
        ]));
        $mpdf->Output('Fare Collection Allocation.pdf', 'D');
        exit();
    }
    public function actionAnalysisHourlyTraffic()
    {
        $model = new AnalysisHourlyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $results = [];

            if ($model->ticketType == 'exit') {
                $sql_main = "CALL Rpt_HourlyTrafficDirectionalExit('" . $model->ic . "', '" . $model->date . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            } else {
                $sql_main = "CALL Rpt_HourlyTrafficDirectionalEntrance('" . $model->ic . "', '" . $model->date . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            }

            return $this->render('analysisHourlyTraffic/analysisHourlyTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisHourlyTraffic/analysisHourlyTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisHourlyTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisHourlyTraffic/analysisHourlyTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisHourlyTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisHourlyTraffic/analysisHourlyTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Hourly Traffic Report.pdf', 'D');
        exit();

    }

    public function actionAnalysisTimePeriodTraffic()
    {
        $model = new AnalysisTimePeriodTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
                    
            if ($model->ticketType == 'exit') {
                $sql_main = "CALL Rpt_TimePeriodDirectionalExit('" . $model->startDate . "', '" . $model->endDate . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            } else {
                $sql_main = "CALL Rpt_TimePeriodDirectionalEntrance('" . $model->startDate . "', '" . $model->endDate . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            }
         //   print_r($temp);die;
            return $this->render('analysisTimePeriodTraffic/analysisTimePeriodTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisTimePeriodTraffic/analysisTimePeriodTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisTimePeriodTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisTimePeriodTraffic/analysisTimePeriodTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisTimePeriodTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisTimePeriodTraffic/analysisTimePeriodTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Time Period Traffic Report.pdf', 'D');
        exit();

    }

    public function actionAnalysisTimePeriodTraffic15()
    {
        $model = new AnalysisTimePeriodTraffic;

        $db = new yii\db\Connection(Yii::$app->db);
        $db_rpt = new yii\db\Connection(Yii::$app->db_rpt);

        $guid = Yii::$app->Guid->getGUID();
        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $partions = $db_rpt->createCommand("SELECT name FROM `tbl_exit_partion_details` WHERE DATE(related_date) BETWEEN DATE('$model->startDate') AND DATE('$model->endDate') GROUP BY name")->queryAll();
            if ($model->ticketType == 'exit') {

                foreach ($partions as $p) {
                    $p_name = $p["name"];

                    // $sql_main = "CALL Insert_TimePeriodDirectionalExit_15('" . $model->startDate . "', '" . $model->endDate . "', '" . $guid . "', '" . $p_name . "' )";

                    $sql_main = "INSERT INTO rpt_hourly_traffic_directional_exit_revenue(guid,exit_ic,direction,cat1_count,cat2_count,cat3_count,cat4_count,catS_count,catPS_count,catPMS_count,catAmbulance_count,catNotAssigned_count, cat1_amount,cat2_amount,cat3_amount,cat4_amount,catS_amount,catPS_amount,catPMS_amount,catAmbulance_amount,catNotAssigned_amount)
                    SELECT
                    '" . $guid . "',
                        tb.exit_ic,
                        tb.direction,
                        IFNULL(SUM(case when tb.vehicle_category = 1 THEN tb.count END),0) Cat01,
                        IFNULL(SUM(case when tb.vehicle_category = 2 THEN tb.count END),0) Cat02,
                        IFNULL(SUM(case when tb.vehicle_category = 3 THEN tb.count END),0) Cat03,
                        IFNULL(SUM(case when tb.vehicle_category = 4 THEN tb.count END),0) Cat04,
                        IFNULL(SUM(case when tb.vehicle_category = 20 THEN tb.count END),0) CatS,
                        IFNULL(SUM(case when tb.vehicle_category = 21 THEN tb.count END),0) CatPS,
                        IFNULL(SUM(case when tb.vehicle_category = 22 THEN tb.count END),0) CatPMS,
                        IFNULL(SUM(case when tb.vehicle_category = 30 THEN tb.count END),0) CatAmbulance,
                        IFNULL(SUM(case when tb.vehicle_category = 99 THEN tb.count END),0) CatNotAssigned,
                        IFNULL(SUM(case when tb.vehicle_category = 1 THEN tb.amount END),0) Cat01Amount,
                        IFNULL(SUM(case when tb.vehicle_category = 2 THEN tb.amount END),0) Cat02Amount,
                        IFNULL(SUM(case when tb.vehicle_category = 3 THEN tb.amount END),0) Cat03Amount,
                        IFNULL(SUM(case when tb.vehicle_category = 4 THEN tb.amount END),0) Cat04Amount,
                        IFNULL(SUM(case when tb.vehicle_category = 20 THEN tb.amount END),0) CatSAmount,
                        IFNULL(SUM(case when tb.vehicle_category = 21 THEN tb.amount END),0) CatPSAmount,
                        IFNULL(SUM(case when tb.vehicle_category = 22 THEN tb.amount END),0) CatPMSAmount,
                        IFNULL(SUM(case when tb.vehicle_category = 30 THEN tb.amount END),0) CatAmbulanceAmount,
                        IFNULL(SUM(case when tb.vehicle_category = 99 THEN tb.amount END),0) CatNotAssignedAmount

                    FROM
                    (

                    SELECT d.name AS direction, t.exit_ic,t.vehicle_category ,COUNT(t.vehicle_category) AS count, SUM(t.amount) AS amount FROM
                    (
                    SELECT date(exit_time) AS day, exit_ic,vehicle_category,entrance_ic ,amount FROM ($p_name)
                        where
                         ticket_type_status_id NOT IN (2,12) and
                        exit_time >= '" . $model->startDate . "' and exit_time < '" . $model->endDate . "'
                    ) t
                    INNER JOIN tbl_route r ON r.source = t.entrance_ic AND r.destination = t.exit_ic
                    INNER JOIN tbl_direction d ON r.direction = d.id
                    GROUP BY d.name, t.exit_ic,t.vehicle_category

                    ) tb
                    GROUP BY tb.direction,tb.exit_ic";

                    $temp = $db_rpt->createCommand($sql_main)->execute();

                }

                $sql_main = "CALL Rpt_TimePeriodDirectionalExit_15('" . $guid . "')";
                $temp = $db_rpt->createCommand($sql_main)->queryAll();
                $db_rpt->createCommand("DELETE FROM `rpt_hourly_traffic_directional_exit_revenue` WHERE `guid`='$guid'")->execute();

            } else {
                foreach ($partions as $p) {
                    $p_name = $p["name"];
                    // $sql_main = "CALL Rpt_TimePeriodDirectionalExit_15('" . $model->startDate . "', '" . $model->endDate . "', '" . $p_name . "')";
                    $sql_main = "INSERT INTO rpt_hourly_directional_traffic_entrance(guid,ic_id,direction,cat1_count,cat2_count,cat3_count,cat4_count,catS_count,catPS_count,catPMS_count,catAmbulance_count,catNotAssigned_count)
                    SELECT
                    '" . $guid . "',
                        tb.entrance_ic,
                        tb.direction,
                        IFNULL(SUM(case when tb.vehicle_category = 1 THEN tb.count END),0) Cat01,
                        IFNULL(SUM(case when tb.vehicle_category = 2 THEN tb.count END),0) Cat02,
                        IFNULL(SUM(case when tb.vehicle_category = 3 THEN tb.count END),0) Cat03,
                        IFNULL(SUM(case when tb.vehicle_category = 4 THEN tb.count END),0) Cat04,
                        IFNULL(SUM(case when tb.vehicle_category = 20 THEN tb.count END),0) CatS,
                        IFNULL(SUM(case when tb.vehicle_category = 21 THEN tb.count END),0) CatPS,
                        IFNULL(SUM(case when tb.vehicle_category = 22 THEN tb.count END),0) CatPMS,
                        IFNULL(SUM(case when tb.vehicle_category = 30 THEN tb.count END),0) CatAmbulance,
                        IFNULL(SUM(case when tb.vehicle_category = 99 THEN tb.count END),0) CatNotAssigned
                        FROM (
                            SELECT
                            '" . $guid . "',

                            tbl.entrance_ic,
                            tbl.vehicle_category,
                            tbl.direction,
                            tbl.count
                             FROM
                                (SELECT
                                '" . $guid . "',

                                t.entrance_ic,
                                t.vehicle_category,
                                d.name AS direction,
                                COUNT(t.vehicle_category) AS count FROM
                                (
                                SELECT * FROM ($p_name) where entrance_time >= '" . $model->startDate . "' and entrance_time < '" . $model->endDate . "'
                                ) t
                                INNER JOIN tbl_route r ON r.source = t.entrance_ic AND r.destination = t.exit_ic
                                INNER JOIN tbl_direction d ON r.direction = d.id
                                GROUP BY t.entrance_ic,t.vehicle_category,d.name ) tbl

                             ) tb GROUP BY
                        tb.entrance_ic,
                        tb.vehicle_category,
                        tb.direction";

                    $temp = $db_rpt->createCommand($sql_main)->execute();
                }

                $sql_main = "CALL Rpt_TimePeriodDirectionalEntrance_15('" . $guid . "')";
                $temp = $db_rpt->createCommand($sql_main)->queryAll();
                $db_rpt->createCommand("DELETE FROM `rpt_hourly_directional_traffic_entrance` WHERE `guid`='$guid'")->execute();

            }

            return $this->render('analysisTimePeriodTraffic15/analysisTimePeriodTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisTimePeriodTraffic15/analysisTimePeriodTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisTimePeriodTraffic15Excel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisTimePeriodTraffic15/analysisTimePeriodTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisTimePeriodTraffic15Pdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisTimePeriodTraffic15/analysisTimePeriodTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Time Period Traffic Report.pdf', 'D');
        exit();

    }

    public function actionAnalysisHourlySectionalTraffic()
    {
        $model = new HourlySectionTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $temp = [];
            $time_intervals = $db->createCommand("SELECT * FROM `time_intervals_for_report`")->queryAll();
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();
            $i = 0;

            foreach ($time_intervals as $interval) {

                $sub_array_direction_1['time'] = $interval['start_time'] . '-' . $interval['end_time'];
                $sub_array_direction_1['direction'] = 1;

                $sub_array_direction_2['time'] = '';
                $sub_array_direction_2['direction'] = 2;

                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                $temp[$i . '-1'] = $sub_array_direction_1;
                $temp[$i . '-2'] = $sub_array_direction_2;
                $i++;
            }

            $results = $db->createCommand("SELECT hour( ET.exit_time ) as hr,ET.vehicle_category as vc,count(ET.vehicle_category) as count, R.direction FROM tbl_exit_ticket ET
                INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination = ET.exit_ic
                WHERE ET.exit_time >= '$model->startDate' AND ET.exit_time <= '$model->endDate' AND ((ET.exit_ic = $model->fIc OR ET.exit_ic = $model->sIc) OR (ET.entrance_ic = $model->fIc OR ET.entrance_ic = $model->sIc)) GROUP BY hour (ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();

            foreach ($results as $result) {
                $temp[$result['hr'] . '-' . $result['direction']][$result['vc']] = $result['count'];
            }

            return $this->render('analysisHourlySectionalTraffic/analysisHourlySectionalTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisHourlySectionalTraffic/analysisHourlySectionalTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisHourlySectionalTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisHourlySectionalTraffic/analysisHourlySectionalTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisHourlySectionalTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisHourlySectionalTraffic/analysisHourlySectionalTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Hourly Sectional Traffic Report.pdf', 'D');
        exit();

    }
    public function actionAnalysisTimePeriodRevenue()
    {
        $model = new AnalysisTimePeriodTraffic;
        $model->ticketType = 'exit';

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $results = [];
            // print_r($model->region);die;
            if ($model->region == 'all_highway') {
                $sql_main = "CALL Rpt_TimePeriodDirectionalExitRevenue('" . $model->startDate . "', '" . $model->endDate . "')";
                $temp = $db->createCommand($sql_main)->queryAll();
            } else {
                $sql_main = "CALL Rpt_TimePeriodDirectionalExitRevenueHighway('" . $model->startDate . "', '" . $model->endDate . "','" . $model->region . "')";
                $temp = $db->createCommand($sql_main)->queryAll();
            }

            return $this->render('analysisTimePeriodRevenue/analysisTimePeriodRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisTimePeriodRevenue/analysisTimePeriodRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisTimePeriodRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisTimePeriodRevenue/analysisTimePeriodRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisTimePeriodRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisTimePeriodRevenue/analysisTimePeriodRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Time Period Traffic Report.pdf', 'D');
        exit();

    }
    public function actionAnalysisHourlyRevenue()
    {
        $model = new AnalysisHourlyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $results = [];
            if ($model->ic == 'Any') {
                $sql_main = "CALL Rpt_HourlyRevenueDirectionalExitIcAny( '" . $model->date . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            } else {
                $sql_main = "CALL Rpt_HourlyRevenueDirectionalExitIc('" . $model->ic . "', '" . $model->date . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            }

            return $this->render('analysisHourlyRevenue/analysisHourlyRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisHourlyRevenue/analysisHourlyRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisHourlyRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisHourlyRevenue/analysisHourlyRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisHourlyRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisHourlyRevenue/analysisHourlyRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Hourly Revenue Report.pdf', 'D');
        exit();

    }
    public function actionAnalysisDailyTraffic()
    {
        $model = new AnalysisDailyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();

            if ($model->ticketType == 'exit') {
                //entrance new
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptDailyTrafficDirectionalExitAny('" . $model->year . "', '" . $model->month . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL RptDailyTrafficDirectionalExit('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                }
            } else {
				
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptDailyTrafficDirectionalEntranceAny('" . $model->year . "', '" . $model->month . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();
					

                } else {
                    $sql_main = "CALL RptDailyTrafficDirectionalEntrance('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();
					//print_r($model);die;

                }

            }
            return $this->render('analysisDailyTraffic/analysisDailyTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisDailyTraffic/analysisDailyTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisDailyTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisDailyTraffic/analysisDailyTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisDailyTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf(['format' => 'A4']);
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisDailyTraffic/analysisDailyTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Daily Traffic Report.pdf', 'D');
        exit();
    }

    public function actionAnalysisDailyRevenue()
    {
        $model = new AnalysisDailyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();

            if ($model->ic == 'Any') {
                $sql_main = "CALL RptDailyRevenueDirectionalExitAny('" . $model->year . "', '" . $model->month . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            } else {
                $sql_main = "CALL RptDailyRevenueDirectionalExit('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            }
            return $this->render('analysisDailyRevenue/analysisDailyRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisDailyRevenue/analysisDailyRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisDailyRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisDailyRevenue/analysisDailyRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisDailyRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisDailyRevenue/analysisDailyRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Daily Revenue Report.pdf', 'D');
        exit();
    }
    public function actionAnalysisMonthlyTraffic()
    {
        $model = new AnalysisMonthlyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            if ($model->ticketType == 'exit') {
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptMonthlyTrafficDirectionalExitIcAny('" . $model->year . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL RptMonthlyTrafficDirectionalExitIc('" . $model->year . "', '" . $model->ic . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();
                }

            } else {
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptMonthlyTrafficDirectionalEntranceIcAny('" . $model->year . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL RptMonthlyTrafficDirectionalEntranceIc('" . $model->year . "', '" . $model->ic . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                }

            }
            return $this->render('analysisMonthlyTraffic/analysisMonthlyTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisMonthlyTraffic/analysisMonthlyTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisMonthlyTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisMonthlyTraffic/analysisMonthlyTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisMonthlyTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisMonthlyTraffic/analysisMonthlyTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Monthly Traffic Report.pdf', 'D');
        exit();
    }
    public function actionAnalysisMonthlyRevenue()
    {
        $model = new AnalysisMonthlyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $sql_main = "CALL RptMonthlyRevenueDirectionalIcAny('" . $model->year . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            } else {
                $sql_main = "CALL RptMonthlyRevenueDirectionalIc('" . $model->year . "', '" . $model->ic . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            }

            return $this->render('analysisMonthlyRevenue/analysisMonthlyRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisMonthlyRevenue/analysisMonthlyRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisMonthlyRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisMonthlyRevenue/analysisMonthlyRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisMonthlyRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisMonthlyRevenue/analysisMonthlyRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Monthly Revenue Report.pdf', 'D');
        exit();
    }
    public function actionAnalysisYearlyTraffic()
    {
        $model = new AnalysisYearlyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ticketType == 'exit') {
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptYearlyTrafficDirectionalExitIcAny('" . $model->year_from . "', '" . $model->year_to . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL RptYearlyTrafficDirectionalExitIc('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->ic . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();
                }

            } else {
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptYearlyTrafficDirectionalEntranceIcAny('" . $model->year_from . "', '" . $model->year_to . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL RptYearlyTrafficDirectionalEntranceIc('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->ic . "')";
                    $temp = $db->createCommand($sql_main)->queryAll();

                }

            }

            return $this->render('analysisYearlyTraffic/analysisYearlyTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisYearlyTraffic/analysisYearlyTraffic', ['model' => $model]);
        }
    }
    public function actionAnalysisYearlyTrafficExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisYearlyTraffic/analysisYearlyTrafficExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisYearlyTrafficPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisYearlyTraffic/analysisYearlyTrafficPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Yearly Traffic Report.pdf', 'D');
        exit();
    }
    public function actionAnalysisYearlyRevenue()
    {
        $model = new AnalysisYearlyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $sql_main = "CALL RptYearlyRevenueDirectionalIcAny('" . $model->year_from . "', '" . $model->year_to . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            } else {
                $sql_main = "CALL RptYearlyRevenueDirectionalIc('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->ic . "')";
                $temp = $db->createCommand($sql_main)->queryAll();
            }

            return $this->render('analysisYearlyRevenue/analysisYearlyRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisYearlyRevenue/analysisYearlyRevenue', ['model' => $model]);
        }
    }
    public function actionAnalysisYearlyRevenueExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisYearlyRevenue/analysisYearlyRevenueExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisYearlyRevenuePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisYearlyRevenue/analysisYearlyRevenuePdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Yearly Revenue Report.pdf', 'D');
        exit();
    }
    public function actionIncidentLostTicket()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $sql_main = "CALL Rpt_LostTicketAny('" . $model->start_date . "','" . $model->end_date . "')";
                $results = $db->createCommand($sql_main)->queryAll();

            } else {
                $sql_main = "CALL Rpt_LostTicketIc('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                $results = $db->createCommand($sql_main)->queryAll();

            }
            return $this->render('incidentLostTicket/incidentLostTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentLostTicket/incidentLostTicket', ['model' => $model]);
        }
    }
    public function actionIncidentLostTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentLostTicket/incidentLostTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentLostTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentLostTicket/incidentLostTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Lost Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentExpiredTicket()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {

                $sql_main = "CALL Rpt_ExpiredTicketAnyIc('" . $model->start_date . "','" . $model->end_date . "')";
                $results = $db->createCommand($sql_main)->queryAll();
            } else {
                $sql_main = "CALL Rpt_ExpiredTicketIc('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                $results = $db->createCommand($sql_main)->queryAll();

            }

            return $this->render('incidentExpiredTicket/incidentExpiredTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentExpiredTicket/incidentExpiredTicket', ['model' => $model]);
        }
    }
    public function actionIncidentExpiredTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentExpiredTicket/incidentExpiredTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentExpiredTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentExpiredTicket/incidentExpiredTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Expired Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentBookReceipt()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                // print_r("dd");die;
                $sql_main = "CALL Rpt_BookReceiptTicketAnyIc('" . $model->start_date . "','" . $model->end_date . "')";
                $results = $db->createCommand($sql_main)->queryAll();
            } else {
                $sql_main = "CALL Rpt_BookReceiptTicketIc('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                $results = $db->createCommand($sql_main)->queryAll();

            }

            return $this->render('incidentBookReceipt/incidentBookReceipt', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentBookReceipt/incidentBookReceipt', ['model' => $model]);
        }
    }
    public function actionIncidentBookReceiptExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentBookReceipt/incidentBookReceiptExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentBookReceiptPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentBookReceipt/incidentBookReceiptPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Book Receipt Report.pdf', 'D');
        exit();
    }
    public function actionIncidentCategoryChanged()
    {
        $model = new IncidentCategoryChanged;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                if ($model->teller == 'Any') {
                    $sql_main = "CALL Rpt_CategoryChangedTicketAnyIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL Rpt_CategoryChangedTicketAnyIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                }
            } else {
                if ($model->teller == 'Any') {
                    $sql_main = "CALL Rpt_CategoryChangedTicketIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL Rpt_CategoryChangedTicketIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                }
            }

            return $this->render('incidentCategoryChanged/incidentCategoryChanged', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentCategoryChanged/incidentCategoryChanged', ['model' => $model]);
        }
    }
    public function actionIncidentCategoryChangedExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentCategoryChanged/incidentCategoryChangedExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentCategoryChangedPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentCategoryChanged/incidentCategoryChangedPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Category Changed Report.pdf', 'D');
        exit();
    }
    public function actionIncidentReprintTicket()
    {
        $model = new IncidentCategoryChanged;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            if ($model->ic == 'Any') {
                if ($model->teller == 'Any') {
                    $sql_main = "CALL Rpt_RePrintedTicketAnyIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL Rpt_RePrintedTicketAnyIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                }
            } else {
                if ($model->teller == 'Any') {
                    $sql_main = "CALL Rpt_RePrintedTicketIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                } else {
                $sql_main = "CALL Rpt_RePrintedTicketIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "','" . $model->teller. "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                }
            }

            return $this->render('incidentReprintTicket/incidentReprintTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentReprintTicket/incidentReprintTicket', ['model' => $model]);
        }
    }
    public function actionIncidentReprintTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentReprintTicket/incidentReprintTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentReprintTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentReprintTicket/incidentReprintTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Reprint Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentManualTicket()
    {
        $model = new IncidentCategoryChanged;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                if ($model->teller == 'Any') {
                    $sql_main = "CALL Rpt_ManualTicketAnyIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL Rpt_ManualTicketAnyIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                }
            } else {
                if ($model->teller == 'Any') {
                    $sql_main = "CALL Rpt_ManualTicketIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                } else {
                    $sql_main = "CALL Rpt_ManualTicketIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();

                }
            }

            return $this->render('incidentManualTicket/incidentManualTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentManualTicket/incidentManualTicket', ['model' => $model]);
        }
    }
    public function actionIncidentManualTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentManualTicket/incidentManualTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentManualTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentManualTicket/incidentManualTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Manual Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentMissedIssuedTicket()
    {
        $model = new IncidentMissedIssuedTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ticket_type == 'entrance') {
                $sql = "SELECT ET.serial_no,ET.entrance_time,IC.name ic,B.name booth,V.name vc,U.username
                    FROM rpt_mississued_ticket_summary_entrance ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.ticket_type_status_id = 12";
                if ($model->ic == 'Any') {
                    if ($model->teller == 'Any') {

                    } else {
                        $sql .= " AND ET.teller_id = $model->teller";
                    }
                } else {
                    if ($model->teller == 'Any') {
                        $sql .= " AND ET.entrance_ic = $model->ic";
                    } else {
                        $sql .= " AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller";
                    }
                }
            } else {
                $sql = "SELECT ET.entrance_serial as serial_no,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM rpt_mississued_ticket_summary_exit ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 12";
                if ($model->ic == 'Any') {
                    if ($model->teller == 'Any') {

                    } else {
                        $sql .= " AND ET.teller_id = $model->teller";
                    }
                } else {
                    if ($model->teller == 'Any') {
                        $sql .= " AND ET.exit_ic = $model->ic";
                    } else {
                        $sql .= " AND ET.exit_ic = $model->ic AND ET.teller_id = $model->teller";
                    }
                }
            }

            $results = $db->createCommand($sql)->queryAll();

            return $this->render('incidentMissedIssuedTicket/incidentMissedIssuedTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentMissedIssuedTicket/incidentMissedIssuedTicket', ['model' => $model]);
        }
    }
    public function actionIncidentMissedIssuedTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentMissedIssuedTicket/incidentMissedIssuedTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentMissedIssuedTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentMissedIssuedTicket/incidentMissedIssuedTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Missed Issued Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentBlacklistedCard()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,ET.entrance_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_nfc_card N ON N.uid = ET.uid AND N.status = 0
                INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                INNER JOIN user U ON U.id = ET.teller_id
                INNER JOIN tbl_devices D ON D.id = ET.device_id
                INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.uid IS NOT NULL

                UNION

                SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,Ex.exit_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                FROM tbl_exit_ticket Ex
                INNER JOIN tbl_nfc_card N ON N.uid = Ex.uid AND N.status = 0
                INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                INNER JOIN tbl_booth B ON B.id = Ex.booth_id
                INNER JOIN user U ON U.id = Ex.teller_id
                INNER JOIN tbl_devices D ON D.id = Ex.device_id
                INNER JOIN tbl_ic IC ON IC.id = Ex.exit_ic
                WHERE Ex.exit_time >= '$model->start_date' AND Ex.exit_time <= '$model->end_date' AND Ex.uid IS NOT NULL")->queryAll();
            } else {
                $results = $db->createCommand("SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,ET.entrance_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_nfc_card N ON N.uid = ET.uid AND N.status = 0
                INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                INNER JOIN user U ON U.id = ET.teller_id
                INNER JOIN tbl_devices D ON D.id = ET.device_id
                INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.uid IS NOT NULL AND ET.entrance_ic =  $model->ic

                UNION

                SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,Ex.exit_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                FROM tbl_exit_ticket Ex
                INNER JOIN tbl_nfc_card N ON N.uid = Ex.uid AND N.status = 0
                INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                INNER JOIN tbl_booth B ON B.id = Ex.booth_id
                INNER JOIN user U ON U.id = Ex.teller_id
                INNER JOIN tbl_devices D ON D.id = Ex.device_id
                INNER JOIN tbl_ic IC ON IC.id = Ex.exit_ic
                WHERE Ex.exit_time >= '$model->start_date' AND Ex.exit_time <= '$model->end_date' AND Ex.uid IS NOT NULL AND Ex.exit_ic =  $model->ic")->queryAll();
            }

            return $this->render('incidentBlacklistedCard/incidentBlacklistedCard', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentBlacklistedCard/incidentBlacklistedCard', ['model' => $model]);
        }
    }
    public function actionIncidentBlacklistedCardExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentBlacklistedCard/incidentBlacklistedCardExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentBlacklistedCardPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentBlacklistedCard/incidentBlacklistedCardPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Blacklisted Card Report.pdf', 'D');
        exit();
    }
    public function actionIncidentIncompleteTicket()
    {
        $model = new IncidentMissedIssuedTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ticket_type == 'entrance') {
                if ($model->ic == 'Any') {
                    if ($model->teller == 'Any') {
                        $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                        FROM tbl_entrance_ticket EN1
                        INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                        INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                        INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                        INNER JOIN user U ON U.id = EN1.teller_id
                        WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                        FROM tbl_entrance_ticket EN
                        WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date'))")->queryAll();
                    } else {
                        $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                        FROM tbl_entrance_ticket EN1
                        INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                        INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                        INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                        INNER JOIN user U ON U.id = EN1.teller_id
                        WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.teller_id = $model->teller AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                        FROM tbl_entrance_ticket EN
                        WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.teller_id = $model->teller))")->queryAll();

                    }
                } else {
                    if ($model->teller == 'Any') {
                        $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                        FROM tbl_entrance_ticket EN1
                        INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                        INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                        INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                        INNER JOIN user U ON U.id = EN1.teller_id
                        WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                        FROM tbl_entrance_ticket EN
                        WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic))")->queryAll();

                    } else {
                        $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                        FROM tbl_entrance_ticket EN1
                        INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                        INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                        INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                        INNER JOIN user U ON U.id = EN1.teller_id
                        WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.teller_id = $model->teller AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                        FROM tbl_entrance_ticket EN
                        WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.teller_id = $model->teller))")->queryAll();

                    }
                }
            } else {
                if ($model->ic == 'Any') {
                    if ($model->teller == 'Any') {
                        $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                            FROM tbl_exit_ticket ET
                            INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            INNER JOIN tbl_booth B ON B.id = ET.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            INNER JOIN user U ON U.id = ET.teller_id
                            WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3")->queryAll();
                    } else {
                        $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                            FROM tbl_exit_ticket ET
                            INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            INNER JOIN tbl_booth B ON B.id = ET.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            INNER JOIN user U ON U.id = ET.teller_id
                            WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3 AND ET.teller_id = $model->teller")->queryAll();

                    }
                } else {
                    if ($model->teller == 'Any') {
                        $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                            FROM tbl_exit_ticket ET
                            INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            INNER JOIN tbl_booth B ON B.id = ET.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            INNER JOIN user U ON U.id = ET.teller_id
                            WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3 AND ET.exit_ic = $model->ic")->queryAll();

                    } else {
                        $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                            FROM tbl_exit_ticket ET
                            INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            INNER JOIN tbl_booth B ON B.id = ET.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            INNER JOIN user U ON U.id = ET.teller_id
                            WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 3 AND ET.exit_ic = $model->ic AND ET.teller_id = $model->teller")->queryAll();

                    }
                }
            }

            return $this->render('incidentIncompleteTicket/incidentIncompleteTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentIncompleteTicket/incidentIncompleteTicket', ['model' => $model]);
        }
    }
    public function actionIncidentIncompleteTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentIncompleteTicket/incidentIncompleteTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentIncompleteTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentIncompleteTicket/incidentIncompleteTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Incomplete Ticket Report.pdf', 'D');
        exit();
    }
    public function actionIncidentEscapeTicket()
    {
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                $results = $db->createCommand("SELECT E.entrance_serial,E.entrance_time,E.exit_serial,E.exit_time,VC.name vc,B.name booth,E.amount,U.username teller,IC.name ic
                    FROM tbl_escape_tickets E
                    LEFT JOIN tbl_vehicle_category VC ON VC.id = E.vehicle_category
                    LEFT JOIN tbl_booth B ON B.id = E.booth_id
                    LEFT JOIN user U ON U.id = E.teller_id
                    LEFT JOIN tbl_ic IC ON IC.id = E.exit_ic
                    WHERE E.exit_time >= '$model->start_date' AND E.exit_time <= '$model->end_date'")->queryAll();
            } else {
                $results = $db->createCommand("SELECT E.entrance_serial,E.entrance_time,E.exit_serial,E.exit_time,VC.name vc,B.name booth,E.amount,U.username teller,IC.name ic
                    FROM tbl_escape_tickets E
                    LEFT JOIN tbl_vehicle_category VC ON VC.id = E.vehicle_category
                    LEFT JOIN tbl_booth B ON B.id = E.booth_id
                    LEFT JOIN user U ON U.id = E.teller_id
                    LEFT JOIN tbl_ic IC ON IC.id = E.exit_ic
                    WHERE E.exit_time >= '$model->start_date' AND E.exit_time <= '$model->end_date' AND E.exit_ic = $model->ic")->queryAll();
            }

            return $this->render('incidentEscapeTicket/incidentEscapeTicket', ['model' => $model, 'results' => $results]);
        } else {
            return $this->render('incidentEscapeTicket/incidentEscapeTicket', ['model' => $model]);
        }
    }
    public function actionIncidentEscapeTicketExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('incidentEscapeTicket/incidentEscapeTicketExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionIncidentEscapeTicketPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('incidentEscapeTicket/incidentEscapeTicketPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Escape Ticket Report.pdf', 'D');
        exit();
    }

    public function actionYearlyReport()
    {

        $model = new YearReportStats();

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            $results = $db->createCommand("SELECT t.name as tname,  d.name  as dname,  yr.vehicle_category as ca , SUM(yr.count) as count
            FROM tbl_year_report_stats yr
            INNER JOIN tbl_route ic on yr.source= ic.source and yr.destination = ic.destination
            inner join tbl_ic t on yr.source= t.id
            inner join tbl_ic d on yr.destination= d.id
            WHERE year ='$model->year'
            GROUP by yr.vehicle_category , t.name, d.name")->queryAll();

            foreach ($results as $result) {
                $temp[$result['tname'] . '-' . $result['dname']][$result['ca']] = $result['count'];

                $temp[$result['tname'] . '-' . $result['dname']]['name'] = $result['tname'];
                $temp[$result['tname'] . '-' . $result['dname']]['kname'] = $result['dname'];
                ++$i;

            }

            return $this->render('analysisYearlyReport/yearlyReport', ['model' => $model, 'results' => $temp, 'months' => $months]);
        } else {
            return $this->render('analysisYearlyReport/yearlyReport', ['model' => $model]);
        }
    }

    public function actionAnalysisYearReportExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisYearlyReport/analysisYearReportExcel', [
            'results' => $results,
            'model' => $model,

        ]);
    }

    public function actionAnalysisYearReportPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisYearlyReport/analysisYearReportPDF', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Yearly  Report.pdf', 'D');
        exit();
    }
    //ADT REPORT
    public function actionAverageDailyTrafficReport()
    {

        $db = new yii\db\Connection(Yii::$app->db);
        $model = new YearReportStats();

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            $ff = $db->createCommand("SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')) ")->execute();
            $months = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
            $ics = Ic::find()->orderBy([new \yii\db\Expression('FIELD(id,27,26,28,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,30,31,21,29,22,23,24,25)')])->all();

            return $this->render('averageDailyTrafficReport/averageDailyTrafficReport', [
                'model' => $model,
                'results' => $ics,
                'months' => $months,

            ]);
        } else {
            return $this->render('averageDailyTrafficReport/averageDailyTrafficReport', ['model' => $model]);
        }
    }

    public function actionAverageDailyTrafficReportExcel()
    {
        //  print_r("rrr");
        //  die;
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        return $this->render('averageDailyTrafficReport/averageDailyTrafficReportExcel', [
            'results' => $results,
            'model' => $model,
            'months' => $months,
            'routes' => $routes,
        ]);
    }

    public function actionAverageDailyTrafficReportPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('averageDailyTrafficReport/averageDailyTrafficReportPDF', [
            'results' => $results,
            'model' => $model,
            'months' => $months,
            'routes' => $routes,

        ]));
        $mpdf->Output('ADT.pdf', 'D');
        exit();
    }

    public function actionAnalysisSessionCash()
    {

        $model = new AnalysisDailyRevenue;
        $model->ic = 'Any';
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            if ($model->ic == 'Any') {
                // print_r('dd');die;
                $sql_main = "CALL Rpt_Session_cash('" . $model->year . "', '" . $model->month . "')";
                $temp = $db->createCommand($sql_main)->queryAll();

            }
            return $this->render('analysisSessionCash/analysisSessionCash', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisSessionCash/analysisSessionCash', ['model' => $model]);
        }
    }
    public function actionAnalysisSessionCashExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisSessionCash/analysisSessionCashExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionAnalysisSessionCashPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisSessionCash/analysisSessionCashPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('Session Cash.pdf', 'D');
        exit();
    }
// ADT2
    public function actionAverageDailyTrafficReport2()
    {

        $model = new YearReportStats();

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            $ff = $db->createCommand("SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')) ")->execute();
            $results = $db->createCommand("SELECT t.name as tname,t.id as tid,  d.name  as dname,d.id as did,yr.year,yr.month, SUM(yr.count) as count
            FROM tbl_year_report_stats yr
            INNER JOIN tbl_route ic on yr.source= ic.source and yr.destination = ic.destination
            inner join tbl_ic t on yr.source= t.id
            inner join tbl_ic d on yr.destination= d.id
            WHERE year ='$model->year'
            GROUP by  yr.month,t.name, d.name
            ORDER BY `yr`.`month`")->queryAll();

            $months = $db->createCommand("SELECT yr.year,yr.month FROM tbl_year_report_stats yr WHERE year ='$model->year' GROUP by yr.year,yr.month ORDER BY `yr`.`month`
                                            ")->queryAll();

            $routes = Route::find()->all();

            return $this->render('averageDailyTrafficReport2/averageDailyTrafficReport', [
                'model' => $model,
                'results' => $results,
                'months' => $months,
                'routes' => $routes,

            ]);
        } else {
            return $this->render('averageDailyTrafficReport2/averageDailyTrafficReport', ['model' => $model]);
        }
    }

    public function actionAverageDailyTrafficReportExcel2()
    {
        //  print_r("rrr");
        //  die;
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        return $this->render('averageDailyTrafficReport2/averageDailyTrafficReportExcel', [
            'results' => $results,
            'model' => $model,
            'months' => $months,
            'routes' => $routes,
        ]);
    }

    public function actionAverageDailyTrafficReportPdf2()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('averageDailyTrafficReport2/averageDailyTrafficReportPDF', [
            'results' => $results,
            'model' => $model,
            'months' => $months,
            'routes' => $routes,

        ]));
        $mpdf->Output('Yearly  Report.pdf', 'D');
        exit();
    }
//ADT 3

    public function actionAverageDailyTrafficReport3()
    {

        $model = new YearReportStats();

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            $ff = $db->createCommand("SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')) ")->execute();
            $results = $db->createCommand("SELECT
            t.name as tname,
            t.id as tid,
            d.name  as dname,
            d.id as did,yr.year,
            yr.month,
            yr.vehicle_category,
            IFNULL(SUM(case when v.id = 1 THEN count END),0) cat1,
            IFNULL(SUM(case when v.id = 2 THEN count END),0) cat2,
            IFNULL(SUM(case when v.id = 3 THEN count END),0) cat3,
            IFNULL(SUM(case when v.id = 4 THEN count END),0) cat4,
            IFNULL(SUM(case when v.id = 20 THEN count END),0) s,
            IFNULL(SUM(case when v.id = 21 THEN count END),0) ps,
            IFNULL(SUM(case when v.id = 22 THEN count END),0) pms,
            IFNULL(SUM(case when v.id = 30 THEN count END),0) CatAmbulance,
            IFNULL(SUM(case when v.id = 99 THEN count END),0) CatNotAssigned

            FROM tbl_year_report_stats yr
            INNER JOIN tbl_route ic on yr.source= ic.source and yr.destination = ic.destination
            inner join tbl_ic t on yr.source= t.id
            inner join tbl_ic d on yr.destination= d.id
            inner join tbl_vehicle_category v ON yr.vehicle_category =  v.id

            WHERE year ='$model->year' AND month = '$model->month'
            GROUP by  yr.month,t.name, d.name
            ORDER BY `yr`.`month`")->queryAll();

            // $months = $db->createCommand("SELECT yr.year,yr.month FROM tbl_year_report_stats yr WHERE year ='$model->year' GROUP by yr.year,yr.month ORDER BY `yr`.`month`")->queryAll();

            //  $categorie = $db->createCommand("SELECT id as vehicle_category,name FROM tbl_vehicle_category")->queryAll();

            //  $routes = Route::find()->all();

            // $routes =  $db->createCommand("SELECT t.name as tname, t.id as source, d.name as dname, d.id as destination FROM tbl_year_report_stats yr inner join tbl_ic t on yr.source= t.id inner join tbl_ic d on yr.destination= d.id WHERE year ='2020' GROUP by t.name, d.name ORDER BY `yr`.`month`")->queryAll();

            return $this->render('averageDailyTrafficReport3/averageDailyTrafficReport', [
                'model' => $model,
                'results' => $results,
                'months' => $months,
                'routes' => $routes,
                'categorie' => $categorie,

            ]);
        } else {
            return $this->render('averageDailyTrafficReport3/averageDailyTrafficReport', ['model' => $model]);
        }
    }

    public function actionAverageDailyTrafficReport3OLD()
    {

        $model = new YearReportStats();

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            $ff = $db->createCommand("SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')) ")->execute();
            $results = $db->createCommand("SELECT t.name as tname,t.id as tid,  d.name  as dname,d.id as did,yr.year,yr.month,yr.vehicle_category, SUM(yr.count) as count
        FROM tbl_year_report_stats yr
        INNER JOIN tbl_route ic on yr.source= ic.source and yr.destination = ic.destination
        inner join tbl_ic t on yr.source= t.id
        inner join tbl_ic d on yr.destination= d.id
        WHERE year ='$model->year'
        GROUP by  yr.month,yr.vehicle_category,t.name, d.name
ORDER BY `yr`.`month`")->queryAll();

            $months = $db->createCommand("SELECT yr.year,yr.month FROM tbl_year_report_stats yr WHERE year ='$model->year' GROUP by yr.year,yr.month ORDER BY `yr`.`month`
")->queryAll();

            $categorie = $db->createCommand("SELECT id as vehicle_category,name FROM tbl_vehicle_category

")->queryAll();

// $categorie = $db->createCommand("SELECT yr.vehicle_category,v.name FROM tbl_year_report_stats yr inner join tbl_vehicle_category v
            // on yr.vehicle_category= v.id
            // WHERE year ='$model->year' GROUP by yr.vehicle_category ORDER BY yr.vehicle_category
            // ")->queryAll();

            $routes = Route::find()->all();

            return $this->render('averageDailyTrafficReport3/averageDailyTrafficReport', [
                'model' => $model,
                'results' => $results,
                'months' => $months,
                'routes' => $routes,
                'categorie' => $categorie,

            ]);
        } else {
            return $this->render('averageDailyTrafficReport3/averageDailyTrafficReport', ['model' => $model]);
        }
    }

    public function actionAverageDailyTrafficReportExcel3()
    {

        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);
        $categorie = json::decode($_POST['categorie']);

        return $this->render('averageDailyTrafficReport3/averageDailyTrafficReportExcel', [
            'results' => $results,
            'model' => $model,
            'months' => $months,
            'routes' => $routes,
            'categorie' => $categorie,
        ]);
    }

    public function actionAverageDailyTrafficReportPdf3()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);
        $categorie = json::decode($_POST['categorie']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('averageDailyTrafficReport3/averageDailyTrafficReportPDF', [
            'results' => $results,
            'model' => $model,
            'months' => $months,
            'routes' => $routes,
            'categorie' => $categorie,

        ]));
        $mpdf->Output('Yearly  Report.pdf', 'D');
        exit();
    }

}
