<?php

namespace app\controllers;

use app\models\AnalysisDailyRevenue;
use app\models\AnalysisDailyTraffic;
use app\models\TowingCharge;
use app\models\AnalysisHourlyRevenue;
use app\models\AnalysisHourlyTraffic;
use app\models\AnalysisMonthlyRevenue;
use app\models\AnalysisMonthlyTraffic;
use app\models\AnalysisTimePeriodTraffic;
use app\models\AnalysisYearlyRevenue;
use app\models\AnalysisYearlyTraffic;
use app\models\BoothType;
use app\models\FareCollectionAllIcSummary;
use app\models\FareCollectionAllocationWise;
use app\models\FareCollectionBoothWise;
use app\models\FareCollectionPosWise;
use app\models\FareCollectionTellerWise;
use app\models\HourlySectionTraffic;
use app\models\Ic;
use app\models\IncidentCategoryChanged;
use app\models\IncidentLostTicket;
use app\models\IncidentMissedIssuedTicket;
use app\models\Route;
use app\models\VehicleCategory;
use app\models\YearReportStats;
use app\models\UserDetails;
use app\models\NfcCardDetails;
use app\models\EntranceTicket;
use app\models\IncompleteSessions;
use app\models\IncompleteTicket;
use app\models\CashReset;
use app\models\DuplicateTicket;
use app\models\InactiveIcExitTicket;
use webvimark\modules\UserManagement\models\User;
use Yii;
use yii\data\Pagination;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\Json;
use yii\web\Controller;
use app\models\AuditReport;
use app\models\YearReportStatsADT;
use app\models\IcUsers;

/**
 * RouteController implements the CRUD actions for Route model.
 */
class ReportsController extends Controller {
    // private $db = new yii\db\Connection(Yii::$app->db);

    /**
     * {@inheritdoc}
     */
    public function behaviors() {
        $requestroute = Yii::$app->requestedRoute;
        $editurl = '/' . $requestroute;
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'actions' => ['index', 'quick', 'view', 'create', 'update', 'delete', 'fare-collection-booth-wise',
                            'fare-collection-booth-wise-excel', 'fare-collection-booth-wise-pdf', 'fare-collection-teller-wise',
                            'fare-collection-teller-wise-excel', 'fare-collection-teller-wise-pdf', 'fare-collection-pos-wise',
                            'fare-collection-pos-wise-excel', 'fare-collection-pos-wise-pdf', 'fare-collection-all-ic-summary',
                            'fare-collection-all-ic-summary-excel', 'fare-collection-all-ic-summary-pdf', 'fare-collection-allocation-wise',
                            'fare-collection-allocation-wise-excel', 'fare-collection-allocation-wise-pdf', 'fare-collection-allocation-wise-view',
                            'analysis-hourly-traffic', 'analysis-hourly-traffic-excel', 'analysis-hourly-traffic-pdf', 'analysis-time-period-traffic',
                            'analysis-time-period-traffic-pdf', 'analysis-time-period-traffic-excel', 'analysis-hourly-sectional-traffic',
                            'analysis-hourly-sectional-traffic-excel', 'analysis-hourly-sectional-traffic-pdf', 'analysis-time-period-revenue'
                            , 'analysis-time-period-revenue-pdf', 'analysis-time-period-revenue-excel', 'analysis-hourly-revenue', 'analysis-hourly-revenue-pdf'
                            , 'analysis-hourly-revenue-excel', 'analysis-daily-traffic', 'analysis-daily-traffic-pdf', 'analysis-daily-traffic-excel',
                            'analysis-daily-revenue', 'analysis-daily-revenue-pdf', 'analysis-daily-revenue-excel', 'analysis-monthly-traffic',
                            'analysis-monthly-traffic-pdf', 'analysis-monthly-traffic-excel', 'analysis-monthly-revenue', 'analysis-monthly-revenue-pdf',
                            'analysis-monthly-revenue-excel', 'analysis-yearly-traffic', 'analysis-yearly-traffic-pdf', 'analysis-yearly-traffic-excel',
                            'analysis-yearly-revenue', 'analysis-yearly-revenue-pdf', 'analysis-yearly-revenue-excel', 'incident-lost-ticket',
                            'incident-lost-ticket-pdf', 'incident-lost-ticket-excel', 'incident-expired-ticket', 'incident-expired-ticket-pdf',
                            'incident-expired-ticket-excel', 'incident-book-receipt-pdf', 'incident-book-receipt', 'incident-book-receipt-excel',
                            'incident-category-changed', 'incident-category-changed-pdf', 'incident-category-changed-excel', 'incident-reprint-ticket',
                            'incident-reprint-ticket-pdf', 'incident-reprint-ticket-excel', 'incident-manual-ticket', 'incident-manual-ticket-pdf',
                            'incident-manual-ticket-excel', 'incident-missed-issued-ticket', 'incident-missed-issued-ticket-pdf', 'incident-missed-issued-ticket-excel',
                            'incident-blacklisted-card', 'incident-blacklisted-card-pdf', 'incident-blacklisted-card-excel', 'incident-incomplete-ticket',
                            'incident-incomplete-ticket-pdf', 'incident-incomplete-ticket-excel', 'incident-escape-ticket', 'incident-escape-ticket-pdf',
                            'incident-escape-ticket-excel', 'yearly-report', 'analysis-year-report-excel', 'analysis-year-report-pdf',
                            'average-daily-traffic-report', 'average-daily-traffic-report-excel', 'average-daily-traffic-report-pdf',
                            'average-daily-traffic-report2', 'average-daily-traffic-report-excel2', 'average-daily-traffic-report-pdf2',
                            'average-daily-traffic-report3', 'average-daily-traffic-report-excel3', 'average-daily-traffic-report-pdf3',
                            'average-daily-traffic-report-excel-new',
                            'analysis-time-period-traffic15',
                            'analysis-time-period-traffic15-pdf', 
                            'analysis-time-period-traffic15-excel', 'analysis-session-cash', 'analysis-session-cash-pdf', 
                            'analysis-session-cash-excel','towing-charge','towing-charge-pdf', 'towing-charge-excel',
                            'user-details-report', 'user-details-report-pdf', 'user-details-report-excel',
                            'nfc-card-report', 'nfc-card-report-pdf', 'nfc-card-report-excel', 'incomplete-sessions-report','incomplete-sessions-report-pdf','incomplete-sessions-report-excel', 
                            'cash-reset-report','cash-reset-report-pdf','cash-reset-report-excel','incomplete-ticket-report','incomplete-ticket-report-pdf','incomplete-ticket-report-excel',
                            'ic-list','duplicate-ticket-report','duplicate-ticket-report-pdf','duplicate-ticket-report-excel','inactive-ic-exit-ticket-report','inactive-ic-exit-ticket-report-pdf', 'qr-payment-report','qr-payment-report-pdf','qr-payment-report-excel',
                            
                            'audit-report', 'audit-report-pdf'
                        ],
                        'roles' => [$editurl],
                    ],
                ],
            ],
        ];
    }

    // Define a constant for the backup date
    const BACKUP_DATE = '2024-09-07 00:00:00';

    /**
     * Lists all Route models.
     * @return mixed
     */
    public function actionIndex() {

        return $this->render('index', [
        ]);
    }

    // Action to handle Fare Collection Booth Wise reports
    public function actionFareCollectionBoothWise() {
        // Initialize the model
        $model = new FareCollectionBoothWise;
        // Check if the request is a POST
        if (Yii::$app->request->post() || Yii::$app->request->get()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);
            $db_archive = new yii\db\Connection(Yii::$app->db_archive);

            // If POST request, load the data into the model and set cookies
            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                setcookie("fareBoothWise-IC", $model->ic, time() + 86400);
                setcookie("fareBoothWise-Booth", $model->booth, time() + 86400);
                setcookie("fareBoothWise-Type", $model->reportType, time() + 86400);
                setcookie("fareBoothWise-StartD", $model->startDate, time() + 86400);
                setcookie("fareBoothWise-EndD", $model->endDate, time() + 86400);
            } else {
                // If GET request, load values from cookies
                $model->ic = $_COOKIE["fareBoothWise-IC"];
                $model->booth = $_COOKIE["fareBoothWise-Booth"];
                $model->reportType = $_COOKIE["fareBoothWise-Type"];
                $model->startDate = $_COOKIE["fareBoothWise-StartD"];
                $model->endDate = $_COOKIE["fareBoothWise-EndD"];
            }
            // Determine booth type (entry/exit)
            $isExit = 0;
            $exitOrEntrance = $db->createCommand("SELECT `booth_type` FROM `tbl_booth` WHERE `id` = $model->booth")->queryScalar();
            // If the booth type is EXIT, set isExit to 1
            if ($exitOrEntrance == BoothType::EXIT) {
                $isExit = 1;
            }

            // If the start date is before the backup date
            if ($model->startDate < self::BACKUP_DATE) {
                // Handle the summary report type
                if ($model->reportType == 'summary') {
                    if ($isExit) {
                        /* $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                          GROUP BY VC.id")->queryAll(); */
    
                        // Optimized query for exit report summary
                        $results = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
                                      FROM tbl_vehicle_category VC
                                      LEFT JOIN (
                                          SELECT id, vehicle_category, amount
                                          FROM tbl_exit_ticket_ar
                                          WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
                                      ) ET ON ET.vehicle_category = VC.id
                                      GROUP BY VC.id
                                      ORDER BY VC.id ASC")->queryAll();
                    } else {
                        /* $results = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                          GROUP BY VC.id")->queryAll(); */
    
                        // Optimized query for entrance report summary				
                        $enResult = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN (
                          SELECT id, vehicle_category
                          FROM tbl_entrance_ticket_ar
                          WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                      ) ET ON ET.vehicle_category = VC.id
                      GROUP BY VC.id;")->queryAll();
                    }
                    // Render the summary result view
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseSummaryResult', [
                                'results' => $results,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                // Handle the detailed report type
                } else if ($model->reportType == 'detailed') {
                    // Pagination setup
                    $page = Yii::$app->request->get('page', 1);
                    $limit = Yii::$app->request->get('per-page', 10);
                    $from = ($page - 1) * $limit;
    
                    // Prepare SQL query for detailed report
                    if ($isExit) {
                        //optimize INNER JOIN to LEFT JOIN 
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_exit_ticket_ar ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    } else {
                        //optimize INNER JOIN to LEFT JOIN 
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket_ar ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                    }
    
                    // Execute query with pagination
                    $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    // $result = $db_archive->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
    
    
    
                    $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
                    // $count = $db_archive->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
    
                    // Set up pagination
                    $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
                    //  print_r('fareCollectionBoothWiseDetailedResult');
                    // print_r($result);die;
    
                    // Render the detailed result view
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseDetailedResult', [
                                'results' => $result,
                                'pages' => $pages,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                // Handle the combined report (summary + detailed)
                } else if ($model->reportType == 'all') {
                    // Fetch summary and detailed results for the 'all' report type
                    //summary report=========================
                    if ($isExit) {
                        /* $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                          GROUP BY VC.id")->queryAll(); */
    
                        //optimize	    
                        $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
                                      FROM tbl_vehicle_category VC
                                      LEFT JOIN (
                                          SELECT id, vehicle_category, amount
                                          FROM tbl_exit_ticket_ar
                                          WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
                                      ) ET ON ET.vehicle_category = VC.id
                                      GROUP BY VC.id
                                      ORDER BY VC.id ASC")->queryAll();
                    } else {
                        /* $sResults = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                          GROUP BY VC.id")->queryAll(); */
    
                        //optimize					
                        $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN (
                          SELECT id, vehicle_category
                          FROM tbl_entrance_ticket_ar
                          WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                      ) ET ON ET.vehicle_category = VC.id
                      GROUP BY VC.id;")->queryAll();
                    }
    
                    //detailed report========================
                    $page = Yii::$app->request->get('page', 1);
                    $limit = Yii::$app->request->get('per-page', 10);
                    $from = ($page - 1) * $limit;
    
                    if ($isExit) {
                        //optimize INNER JOIN to LEFT JOIN 
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_exit_ticket_ar ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    } else {
                        //optimize INNER JOIN to LEFT JOIN 
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket_ar ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                    }
    
                    $dResults = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
    
                    // $dResults = $db_archive->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    // $count = $db_archive->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
    
                    $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
    
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseAllResult', [
                                'dResults' => $dResults,
                                'sResults' => $sResults,
                                'pages' => $pages,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                }

                //end backup
            }else{
                // If the start date is after the backup date, use live data
                // Follow similar logic for summary, detailed, and all report types as above...
                if ($model->reportType == 'summary') {
                    if ($isExit) {
                        /* $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                          GROUP BY VC.id")->queryAll(); */
    
                        //optimize
                        $results = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
                                      FROM tbl_vehicle_category VC
                                      LEFT JOIN (
                                          SELECT id, vehicle_category, amount
                                          FROM tbl_exit_ticket
                                          WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
                                      ) ET ON ET.vehicle_category = VC.id
                                      GROUP BY VC.id
                                      ORDER BY VC.id ASC")->queryAll();
                    } else {
                        /* $results = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                          GROUP BY VC.id")->queryAll(); */
    
                        //optimize					
                        $enResult = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN (
                          SELECT id, vehicle_category
                          FROM tbl_entrance_ticket
                          WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                      ) ET ON ET.vehicle_category = VC.id
                      GROUP BY VC.id;")->queryAll();
                    }
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseSummaryResult', [
                                'results' => $results,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'detailed') {
    
                    $page = Yii::$app->request->get('page', 1);
                    $limit = Yii::$app->request->get('per-page', 10);
                    $from = ($page - 1) * $limit;
    
                    //prepare SQL query
                    if ($isExit) {
                        //optimize INNER JOIN to LEFT JOIN 
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_exit_ticket ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    } else {
                        //optimize INNER JOIN to LEFT JOIN 
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                    }
    
                    //Fire it!
                    $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    // $result = $db_archive->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
    
    
    
                    $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
                    // $count = $db_archive->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
    
    
                    $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
                    //  print_r('fareCollectionBoothWiseDetailedResult');
                    // print_r($result);die;
    
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseDetailedResult', [
                                'results' => $result,
                                'pages' => $pages,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'all') {
    
                    //summary report=========================
                    if ($isExit) {
                        /* $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                          GROUP BY VC.id")->queryAll(); */
    
                        //optimize	    
                        $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
                                      FROM tbl_vehicle_category VC
                                      LEFT JOIN (
                                          SELECT id, vehicle_category, amount
                                          FROM tbl_exit_ticket
                                          WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
                                      ) ET ON ET.vehicle_category = VC.id
                                      GROUP BY VC.id
                                      ORDER BY VC.id ASC")->queryAll();
                    } else {
                        /* $sResults = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                          GROUP BY VC.id")->queryAll(); */
    
                        //optimize					
                        $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN (
                          SELECT id, vehicle_category
                          FROM tbl_entrance_ticket
                          WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                      ) ET ON ET.vehicle_category = VC.id
                      GROUP BY VC.id;")->queryAll();
                    }
    
                    //detailed report========================
                    $page = Yii::$app->request->get('page', 1);
                    $limit = Yii::$app->request->get('per-page', 10);
                    $from = ($page - 1) * $limit;
    
                    if ($isExit) {
                        //optimize INNER JOIN to LEFT JOIN 
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_exit_ticket ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    } else {
                        //optimize INNER JOIN to LEFT JOIN 
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                    }
    
                    $dResults = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
    
                    // $dResults = $db_archive->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    // $count = $db_archive->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
    
                    $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
    
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseAllResult', [
                                'dResults' => $dResults,
                                'sResults' => $sResults,
                                'pages' => $pages,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                }

            }
   
        } else {
            return $this->render('fareCollectionBoothWise/fareCollectionBoothWise', ['model' => $model]);
        }
    }

    // Action to handle Fare Collection Booth Wise Excel reports
    public function actionFareCollectionBoothWiseExcel() {
        $model = new FareCollectionBoothWise;
        $db = new yii\db\Connection(Yii::$app->db);
        $db_archive = new yii\db\Connection(Yii::$app->db_archive);
        $model->ic = $_COOKIE["fareBoothWise-IC"];
        $model->booth = $_COOKIE["fareBoothWise-Booth"];
        $model->reportType = $_COOKIE["fareBoothWise-Type"];
        $model->startDate = $_COOKIE["fareBoothWise-StartD"];
        $model->endDate = $_COOKIE["fareBoothWise-EndD"];

        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT `booth_type` FROM `tbl_booth` WHERE `id` = $model->booth")->queryScalar();

        if ($exitOrEntrance == BoothType::EXIT) {
            $isExit = 1;
        }

            if ($model->startDate < self::BACKUP_DATE) {

                if ($model->reportType == 'summary') {

                    if ($isExit) {
                        //optimize
                        $results = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
                                          FROM tbl_vehicle_category VC
                                          LEFT JOIN (
                                              SELECT id, vehicle_category, amount
                                              FROM tbl_exit_ticket_ar
                                              WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
                                          ) ET ON ET.vehicle_category = VC.id
                                          GROUP BY VC.id
                                          ORDER BY VC.id ASC")->queryAll();
                    } else {
                        
                        //optimize					
                        $enResult = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN (
                              SELECT id, vehicle_category
                              FROM tbl_entrance_ticket_ar
                              WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                          ) ET ON ET.vehicle_category = VC.id
                          GROUP BY VC.id;")->queryAll();
                    }
        
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseSummaryExcel', [
                                'results' => $results,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'detailed') {
        
                    if ($isExit) {
                        $results = $db->createCommand("SELECT  ET.*,VC.name
                                FROM tbl_exit_ticket_ar ET
                                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
                    } else {
                        $results = $db->createCommand("SELECT  ET.*,VC.name
                                FROM tbl_entrance_ticket_ar ET
                                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
                    }
        
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseDetailedExcel', [
                                'results' => $results,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'all') {
        
                    if ($isExit) {
                        //optimize
                        $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
                                          FROM tbl_vehicle_category VC
                                          LEFT JOIN (
                                              SELECT id, vehicle_category, amount
                                              FROM tbl_exit_ticket_ar
                                              WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
                                          ) ET ON ET.vehicle_category = VC.id
                                          GROUP BY VC.id
                                          ORDER BY VC.id ASC")->queryAll();
        
                        $dResults = $db->createCommand("SELECT  ET.*,VC.name
                            FROM tbl_exit_ticket_ar ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
                    } else {
                        
                        //optimize					
                        $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN (
                              SELECT id, vehicle_category
                              FROM tbl_entrance_ticket_ar
                              WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                          ) ET ON ET.vehicle_category = VC.id
                          GROUP BY VC.id;")->queryAll();
        
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket_ar ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
                    }
        
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseAllExcel', [
                                'sResults' => $sResults,
                                'dResults' => $dResults,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                }
                //end backup
            }else{

                if ($model->reportType == 'summary') {

                    if ($isExit) {
                        //optimize
                        $results = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
                                          FROM tbl_vehicle_category VC
                                          LEFT JOIN (
                                              SELECT id, vehicle_category, amount
                                              FROM tbl_exit_ticket
                                              WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
                                          ) ET ON ET.vehicle_category = VC.id
                                          GROUP BY VC.id
                                          ORDER BY VC.id ASC")->queryAll();
                    } else {
                        
                        //optimize					
                        $enResult = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN (
                              SELECT id, vehicle_category
                              FROM tbl_entrance_ticket
                              WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                          ) ET ON ET.vehicle_category = VC.id
                          GROUP BY VC.id;")->queryAll();
                    }
        
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseSummaryExcel', [
                                'results' => $results,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'detailed') {
        
                    if ($isExit) {
                        $results = $db->createCommand("SELECT  ET.*,VC.name
                                FROM tbl_exit_ticket ET
                                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
                    } else {
                        $results = $db->createCommand("SELECT  ET.*,VC.name
                                FROM tbl_entrance_ticket ET
                                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
                    }
        
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseDetailedExcel', [
                                'results' => $results,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'all') {
        
                    if ($isExit) {
                        //optimize
                        $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
                                          FROM tbl_vehicle_category VC
                                          LEFT JOIN (
                                              SELECT id, vehicle_category, amount
                                              FROM tbl_exit_ticket
                                              WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
                                          ) ET ON ET.vehicle_category = VC.id
                                          GROUP BY VC.id
                                          ORDER BY VC.id ASC")->queryAll();
        
                        $dResults = $db->createCommand("SELECT  ET.*,VC.name
                            FROM tbl_exit_ticket ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
                    } else {
                        //optimize					
                        $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                          FROM tbl_vehicle_category VC
                          LEFT JOIN (
                              SELECT id, vehicle_category
                              FROM tbl_entrance_ticket
                              WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                          ) ET ON ET.vehicle_category = VC.id
                          GROUP BY VC.id;")->queryAll();
        
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket ET
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
                    }
        
                    return $this->render('fareCollectionBoothWise/fareCollectionBoothWiseAllExcel', [
                                'sResults' => $sResults,
                                'dResults' => $dResults,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                }
            }
 
    }

    // Action to handle Fare Collection Booth Wise PDF reports
    public function actionFareCollectionBoothWisePdf() {
        $model = new FareCollectionBoothWise;
        $db = new yii\db\Connection(Yii::$app->db);
        $db_archive = new yii\db\Connection(Yii::$app->db_archive);
        $model->ic = $_COOKIE["fareBoothWise-IC"];
        $model->booth = $_COOKIE["fareBoothWise-Booth"];
        $model->reportType = $_COOKIE["fareBoothWise-Type"];
        $model->startDate = $_COOKIE["fareBoothWise-StartD"];
        $model->endDate = $_COOKIE["fareBoothWise-EndD"];

        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT `booth_type` FROM `tbl_booth` WHERE `id` = $model->booth")->queryScalar();

        if ($exitOrEntrance == BoothType::EXIT) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                /* $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                  GROUP BY VC.id")->queryAll(); */
                //optimize
                $results = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
								  FROM tbl_vehicle_category VC
								  LEFT JOIN (
									  SELECT id, vehicle_category, amount
									  FROM tbl_exit_ticket
									  WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
								  ) ET ON ET.vehicle_category = VC.id
								  GROUP BY VC.id
								  ORDER BY VC.id ASC")->queryAll();
            } else {
                /* $results = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                  GROUP BY VC.id")->queryAll(); */

                //optimize					
                $enResult = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket
                      WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionBoothWise/fareCollectionBoothWiseSummaryPdf', array('results' => $results, 'model' => $model,
                        'isExit' => $isExit)));
            $mpdf->Output('Fare Collection Booth Wise Summery  ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $results = $db->createCommand("SELECT ET.*,VC.name
                        FROM tbl_exit_ticket ET
                        LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $results = $db_archive->createCommand("SELECT ET.*,VC.name
                        FROM tbl_entrance_ticket ET
                        LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                        WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                        ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionBoothWise/fareCollectionBoothWiseDetailedPdf', array('results' => $results, 'model' => $model,
                        'isExit' => $isExit)));
            $mpdf->Output('Fare Collection Booth Wise Detailed  ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        } else if ($model->reportType == 'all') {

            if ($isExit) {

                /* $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                  GROUP BY VC.id")->queryAll(); */

                //optimize
                $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description,COUNT(ET.id) AS vcount,IFNULL(SUM(ET.amount), 0.00) AS amount
								  FROM tbl_vehicle_category VC
								  LEFT JOIN (
									  SELECT id, vehicle_category, amount
									  FROM tbl_exit_ticket
									  WHERE booth_id = $model->booth AND exit_time >= '" . $model->startDate . "' AND exit_time <= '" . $model->endDate . "'
								  ) ET ON ET.vehicle_category = VC.id
								  GROUP BY VC.id
								  ORDER BY VC.id ASC")->queryAll();

                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.booth_id = $model->booth AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {

                /* $sResults = $db->createCommand("SELECT VC.name,VC.description,COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND  ET.entrance_time <= '" . $model->endDate . "'
                  GROUP BY VC.id")->queryAll(); */

                //optimize	
                $sResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket
                      WHERE booth_id = $model->booth AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.booth_id = $model->booth AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionBoothWise/fareCollectionBoothWiseAllPdf', array('sResults' => $sResults, 'dResults' => $dResults, 'model' => $model,
                        'isExit' => $isExit)));
            $mpdf->Output('Fare Collection Booth Wise Summary & Detailed  ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        }
    }

    // Action for Fare Collection Teller Wise Reports
    public function actionFareCollectionTellerWise() {
        // Create a new model instance for FareCollectionTellerWise
        $model = new FareCollectionTellerWise;

        if (Yii::$app->request->post() || Yii::$app->request->get()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);
            $db_archive = new yii\db\Connection(Yii::$app->db_archive);

            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                // Set cookies to save the user input for future sessions
                setcookie("fareTellerWise-IC", $model->ic, time() + 86400);
                setcookie("fareTellerWise-Teller", $model->teller, time() + 86400);
                setcookie("fareTellerWise-Type", $model->reportType, time() + 86400);
                setcookie("fareTellerWise-StartD", $model->startDate, time() + 86400);
                setcookie("fareTellerWise-EndD", $model->endDate, time() + 86400);
            } else {
                // Retrieve cookie values and set them to model if there was no POST request
                $model->ic = $_COOKIE["fareTellerWise-IC"];
                $model->teller = $_COOKIE["fareTellerWise-Teller"];
                $model->reportType = $_COOKIE["fareTellerWise-Type"];
                $model->startDate = $_COOKIE["fareTellerWise-StartD"];
                $model->endDate = $_COOKIE["fareTellerWise-EndD"];
            }

            // If start date is before the backup date
            if ($model->startDate < self::BACKUP_DATE) {
                // Generate summary report
                if ($model->reportType == 'summary') {

                    /* $enResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                      GROUP BY VC.id")->queryAll(); */

                    // Optimized query to get the vehicle categories and count the corresponding entrance tickets
                    $enResult = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket_ar
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

                    /* $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                      GROUP BY VC.id ORDER BY VC.id ASC
                      ")->queryAll(); */

                    // Optimized query to get exit ticket details for the summary report
                    $exResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket_ar
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();
                    // Render summary results
                    return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseSummaryResult', [
                                'model' => $model,
                                'enResults' => $enResult,
                                'exResults' => $exResults,
                    ]);
                // Generate detailed report
                } else if ($model->reportType == 'detailed') {

                    // Set pagination for entrance tickets
                    $page_en = Yii::$app->request->get('page', 1);
                    $limit_en = Yii::$app->request->get('per-page', 10);
                    $from_en = ($page_en - 1) * $limit_en;

                    /* $sql_en = "SELECT  ET.*,VC.name
                      FROM tbl_entrance_ticket ET
                      INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                      WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                      ORDER BY ET.entrance_time DESC,ET.teller_id,ET.vehicle_category"; */

                    // Optimized SQL query to get entrance ticket details
                    $sql_en = "SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket_ar ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.entrance_time DESC,ET.teller_id,ET.vehicle_category";

                    // Execute the entrance query and apply pagination
                    $result_en = $db->createCommand($sql_en . ' LIMIT ' . $from_en . ',' . $limit_en)->queryAll();
                    $count_en = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_en . ') a')->queryScalar();
                    // Set up pagination for entrance tickets
                    $pages_en = new Pagination(['totalCount' => $count_en, 'pageSize' => $limit_en]);

                    // Set pagination for exit tickets
                    $page_ex = Yii::$app->request->get('page', 1);
                    $limit_ex = Yii::$app->request->get('per-page', 10);
                    $from_ex = ($page_ex - 1) * $limit_ex;

                    /* $sql_ex = "SELECT  ET.*,VC.name
                      FROM tbl_exit_ticket ET
                      INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                      WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                      ORDER BY ET.exit_time DESC,ET.teller_id,ET.vehicle_category"; */

                    // Optimized SQL query to get exit ticket details
                    $sql_ex = "SELECT  ET.*,VC.name
                FROM tbl_exit_ticket_ar ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.exit_time DESC,ET.teller_id,ET.vehicle_category";

                    // Execute the exit query and apply pagination
                    $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                    $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                    // $sql_ex = "SELECT  ET.*,VC.name
                    // FROM tbl_exit_ticket ET
                    // INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    // WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    // ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    // $result_ex = $db_archive->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                    // $count_ex = $db_archive->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                    // Set up pagination for exit tickets
                    $pages_ex = new Pagination(['totalCount' => $count_ex, 'pageSize' => $limit_ex]);

                    // Render detailed results
                    return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseDetailedResult', [
                                'results_en' => $result_en,
                                'results_ex' => $result_ex,
                                'pages_en' => $pages_en,
                                'pages_ex' => $pages_ex,
                                'model' => $model,
                    ]);
                // Generate all data report
                } else if ($model->reportType == 'all') {
                    //entrance summary
                    /* $enResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                      GROUP BY VC.id")->queryAll(); */

                    //Entrance summary results
                    $enResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket_ar
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

                    //exit summary
                    /* $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                      GROUP BY VC.id ORDER BY VC.id ASC")->queryAll(); */

                    //Exit summary results	
                    $exResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket_ar
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();

                    // $exResults = $db_archive->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    //     FROM tbl_vehicle_category VC
                    //     LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    //     GROUP BY VC.id")->queryAll();
                    //entrance detailed
                    $page_en = Yii::$app->request->get('page', 1);
                    $limit_en = Yii::$app->request->get('per-page', 10);
                    $from_en = ($page_en - 1) * $limit_en;

                    /* $sql_en = "SELECT  ET.*,VC.name
                      FROM tbl_entrance_ticket ET
                      INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                      WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                      ORDER BY ET.entrance_time DESC,ET.teller_id,ET.vehicle_category"; */

                    //Entrance detailed report
                    $sql_en = "SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket_ar ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.entrance_time DESC,ET.teller_id,ET.vehicle_category";

                    // Execute entrance query with pagination
                    $result_en = $db->createCommand($sql_en . ' LIMIT ' . $from_en . ',' . $limit_en)->queryAll();
                    $count_en = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_en . ') a')->queryScalar();
                    // Set up pagination for entrance tickets
                    $pages_en = new Pagination(['totalCount' => $count_en, 'pageSize' => $limit_en]);

                    //exit detailed
                    $page_ex = Yii::$app->request->get('page', 1);
                    $limit_ex = Yii::$app->request->get('per-page', 10);
                    $from_ex = ($page_ex - 1) * $limit_ex;

                    // $sql_ex = "SELECT ET.*,VC.name
                    // FROM tbl_exit_ticket ET
                    // INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    // WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    // ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    // $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                    // $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                    /* $sql_ex = "SELECT ET.*,VC.name
                      FROM tbl_exit_ticket ET
                      INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                      WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                      ORDER BY ET.exit_time DESC,ET.teller_id,ET.vehicle_category"; */

                    // Exit detailed report
                    $sql_ex = "SELECT ET.*,VC.name
                FROM tbl_exit_ticket_ar ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.exit_time DESC,ET.teller_id,ET.vehicle_category";

                    // Execute exit query with pagination
                    $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                    $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();
                    // Set up pagination for exit tickets
                    $pages_ex = new Pagination(['totalCount' => $count_ex, 'pageSize' => $limit_ex]);

                    // Render all results
                    return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseAllResult', [
                                'results_en' => $result_en,
                                'results_ex' => $result_ex,
                                'enResults' => $enResults,
                                'exResults' => $exResults,
                                'pages_en' => $pages_en,
                                'pages_ex' => $pages_ex,
                                'model' => $model,
                    ]);
                }


                //end backup    
            } else {
                // If report type is 'summary', prepare optimized queries for summary report
                if ($model->reportType == 'summary') {

                    /* $enResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                      GROUP BY VC.id")->queryAll(); */

                    //optimize
                    $enResult = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

                    /* $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                      GROUP BY VC.id ORDER BY VC.id ASC
                      ")->queryAll(); */

                    //optimize	
                    $exResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();

                    return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseSummaryResult', [
                                'model' => $model,
                                'enResults' => $enResult,
                                'exResults' => $exResults,
                    ]);
                } else if ($model->reportType == 'detailed') {

                    //entrance
                    $page_en = Yii::$app->request->get('page', 1);
                    $limit_en = Yii::$app->request->get('per-page', 10);
                    $from_en = ($page_en - 1) * $limit_en;

                    /* $sql_en = "SELECT  ET.*,VC.name
                      FROM tbl_entrance_ticket ET
                      INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                      WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                      ORDER BY ET.entrance_time DESC,ET.teller_id,ET.vehicle_category"; */

                    //optimize
                    $sql_en = "SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.entrance_time DESC,ET.teller_id,ET.vehicle_category";

                    $result_en = $db->createCommand($sql_en . ' LIMIT ' . $from_en . ',' . $limit_en)->queryAll();
                    $count_en = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_en . ') a')->queryScalar();

                    $pages_en = new Pagination(['totalCount' => $count_en, 'pageSize' => $limit_en]);

                    //exit
                    $page_ex = Yii::$app->request->get('page', 1);
                    $limit_ex = Yii::$app->request->get('per-page', 10);
                    $from_ex = ($page_ex - 1) * $limit_ex;

                    /* $sql_ex = "SELECT  ET.*,VC.name
                      FROM tbl_exit_ticket ET
                      INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                      WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                      ORDER BY ET.exit_time DESC,ET.teller_id,ET.vehicle_category"; */

                    //optimize
                    $sql_ex = "SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.exit_time DESC,ET.teller_id,ET.vehicle_category";

                    $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                    $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                    // $sql_ex = "SELECT  ET.*,VC.name
                    // FROM tbl_exit_ticket ET
                    // INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    // WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    // ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    // $result_ex = $db_archive->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                    // $count_ex = $db_archive->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                    $pages_ex = new Pagination(['totalCount' => $count_ex, 'pageSize' => $limit_ex]);

                    return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseDetailedResult', [
                                'results_en' => $result_en,
                                'results_ex' => $result_ex,
                                'pages_en' => $pages_en,
                                'pages_ex' => $pages_ex,
                                'model' => $model,
                    ]);
                } else if ($model->reportType == 'all') {
                    //entrance summary
                    /* $enResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                      GROUP BY VC.id")->queryAll(); */

                    //optimize
                    $enResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

                    //exit summary
                    /* $exResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                      FROM tbl_vehicle_category VC
                      LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                      GROUP BY VC.id ORDER BY VC.id ASC")->queryAll(); */

                    //optimize	
                    $exResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();

                    // $exResults = $db_archive->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    //     FROM tbl_vehicle_category VC
                    //     LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.teller_id = $model->teller AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    //     GROUP BY VC.id")->queryAll();
                    //entrance detailed
                    $page_en = Yii::$app->request->get('page', 1);
                    $limit_en = Yii::$app->request->get('per-page', 10);
                    $from_en = ($page_en - 1) * $limit_en;

                    /* $sql_en = "SELECT  ET.*,VC.name
                      FROM tbl_entrance_ticket ET
                      INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                      WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                      ORDER BY ET.entrance_time DESC,ET.teller_id,ET.vehicle_category"; */

                    //optimize
                    $sql_en = "SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.entrance_time DESC,ET.teller_id,ET.vehicle_category";

                    $result_en = $db->createCommand($sql_en . ' LIMIT ' . $from_en . ',' . $limit_en)->queryAll();
                    $count_en = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_en . ') a')->queryScalar();

                    $pages_en = new Pagination(['totalCount' => $count_en, 'pageSize' => $limit_en]);

                    //exit detailed
                    $page_ex = Yii::$app->request->get('page', 1);
                    $limit_ex = Yii::$app->request->get('per-page', 10);
                    $from_ex = ($page_ex - 1) * $limit_ex;

                    // $sql_ex = "SELECT ET.*,VC.name
                    // FROM tbl_exit_ticket ET
                    // INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    // WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    // ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    // $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                    // $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                    /* $sql_ex = "SELECT ET.*,VC.name
                      FROM tbl_exit_ticket ET
                      INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                      WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                      ORDER BY ET.exit_time DESC,ET.teller_id,ET.vehicle_category"; */

                    //optimize
                    $sql_ex = "SELECT ET.*,VC.name
                FROM tbl_exit_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.exit_time DESC,ET.teller_id,ET.vehicle_category";

                    $result_ex = $db->createCommand($sql_ex . ' LIMIT ' . $from_ex . ',' . $limit_ex)->queryAll();
                    $count_ex = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql_ex . ') a')->queryScalar();

                    $pages_ex = new Pagination(['totalCount' => $count_ex, 'pageSize' => $limit_ex]);

                    return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseAllResult', [
                                'results_en' => $result_en,
                                'results_ex' => $result_ex,
                                'enResults' => $enResults,
                                'exResults' => $exResults,
                                'pages_en' => $pages_en,
                                'pages_ex' => $pages_ex,
                                'model' => $model,
                    ]);
                }
            }
        } else {
            return $this->render('fareCollectionTellerWise/fareCollectionTellerWise', ['model' => $model]);
        }
    }

    // Action for Fare Collection Teller Wise Excel Reports
    public function actionFareCollectionTellerWiseExcel() {

        $model = new FareCollectionTellerWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["fareTellerWise-IC"];
        $model->teller = $_COOKIE["fareTellerWise-Teller"];
        $model->reportType = $_COOKIE["fareTellerWise-Type"];
        $model->startDate = $_COOKIE["fareTellerWise-StartD"];
        $model->endDate = $_COOKIE["fareTellerWise-EndD"];

        if ($model->startDate < self::BACKUP_DATE) {
            if ($model->reportType == 'summary') {


                //optimize
                $enSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket_ar
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

                //optimize	
                $exSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket_ar
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseSummaryExcel', [
                            'enSResults' => $enSResults,
                            'exSResults' => $exSResults,
                            'model' => $model,
                ]);
            } else if ($model->reportType == 'detailed') {

                $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket_ar ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

                $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket_ar ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseDetailedExcel', [
                            'enDResults' => $enDResults,
                            'exDResults' => $exDResults,
                            'model' => $model,
                ]);
            } else if ($model->reportType == 'all') {


                //optimize
                $enSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket_ar
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

                //optimize	
                $exSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket_ar
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();

                $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket_ar ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

                $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket_ar ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseAllExcel', [
                            'enSResults' => $enSResults,
                            'exSResults' => $exSResults,
                            'enDResults' => $enDResults,
                            'exDResults' => $exDResults,
                            'model' => $model,
                ]);
            }

            ///end Backup
        } else {

            if ($model->reportType == 'summary') {


                //optimize
                $enSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

                //optimize	
                $exSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseSummaryExcel', [
                            'enSResults' => $enSResults,
                            'exSResults' => $exSResults,
                            'model' => $model,
                ]);
            } else if ($model->reportType == 'detailed') {

                $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

                $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseDetailedExcel', [
                            'enDResults' => $enDResults,
                            'exDResults' => $exDResults,
                            'model' => $model,
                ]);
            } else if ($model->reportType == 'all') {


                //optimize
                $enSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

                //optimize	
                $exSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();

                $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

                $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

                return $this->render('fareCollectionTellerWise/fareCollectionTellerWiseAllExcel', [
                            'enSResults' => $enSResults,
                            'exSResults' => $exSResults,
                            'enDResults' => $enDResults,
                            'exDResults' => $exDResults,
                            'model' => $model,
                ]);
            }
        }
    }

    // Action for Fare Collection Teller Wise PDF Reports
    public function actionFareCollectionTellerWisePdf() {
        $model = new FareCollectionTellerWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["fareTellerWise-IC"];
        $model->teller = $_COOKIE["fareTellerWise-Teller"];
        $model->reportType = $_COOKIE["fareTellerWise-Type"];
        $model->startDate = $_COOKIE["fareTellerWise-StartD"];
        $model->endDate = $_COOKIE["fareTellerWise-EndD"];

        if ($model->reportType == 'summary') {

            //optimize
            $enResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

            //optimize	
            $exResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionTellerWise/fareCollectionTellerWiseSummaryPdf', array('enResults' => $enResults, 'exResults' => $exResults, 'model' => $model)));
            $mpdf->Output('Fare Collection Teller Wise Summary  ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        } else if ($model->reportType == 'detailed') {

            $enResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionTellerWise/fareCollectionTellerWiseDetailedPdf', array('enResults' => $enResults, 'exResults' => $exResults, 'model' => $model)));
            $mpdf->Output('Fare Collection Teller Wise Detailed  ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        } else if ($model->reportType == 'all') {


            //optimize
            $enSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, COUNT(ET.id) as vcount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category
                      FROM tbl_entrance_ticket
                      WHERE entrance_ic = $model->ic AND teller_id = $model->teller 
                      AND entrance_time >= '" . $model->startDate . "' AND entrance_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id;")->queryAll();

            //optimize	
            $exSResults = $db->createCommand("SELECT VC.id, VC.name, VC.description, 
                         COUNT(ET.id) AS vcount, 
                         IFNULL(SUM(ET.amount), 0.00) AS amount
                  FROM tbl_vehicle_category VC
                  LEFT JOIN (
                      SELECT id, vehicle_category, amount
                      FROM tbl_exit_ticket
                      WHERE teller_id = $model->teller 
                        AND exit_ic = $model->ic
                        AND exit_time >= '" . $model->startDate . "' 
                        AND exit_time <= '" . $model->endDate . "'
                  ) ET ON ET.vehicle_category = VC.id
                  GROUP BY VC.id
                  ORDER BY VC.id ASC")->queryAll();

            $enDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();

            $exDResults = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionTellerWise/fareCollectionTellerWiseAllPdf', array('enSResults' => $enSResults, 'exSResults' => $exSResults, 'enDResults' => $enDResults, 'exDResults' => $exDResults, 'model' => $model)));
            $mpdf->Output('Fare Collection Teller Wise All  ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        }
    }

    // Fare Collection POS Wise Report Generation
    public function actionFareCollectionPosWise() {
        // Create a new instance of FareCollectionPosWise model
        $model = new FareCollectionPosWise;

        if (Yii::$app->request->post() || Yii::$app->request->get()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);

            // If the request is a POST, load the POST data into the model and set cookies
            if (Yii::$app->request->post()) {
                $model->load(Yii::$app->request->post());
                // Set cookies with the model's data for later use
                setcookie("farePosWise-IC", $model->ic, time() + 86400);
                setcookie("farePosWise-Pos", $model->pos, time() + 86400);
                setcookie("farePosWise-Type", $model->reportType, time() + 86400);
                setcookie("farePosWise-StartD", $model->startDate, time() + 86400);
                setcookie("farePosWise-EndD", $model->endDate, time() + 86400);
            } else {
                // If it's a GET request, load values from cookies into the model
                $model->ic = $_COOKIE["farePosWise-IC"];
                $model->pos = $_COOKIE["farePosWise-Pos"];
                $model->reportType = $_COOKIE["farePosWise-Type"];
                $model->startDate = $_COOKIE["farePosWise-StartD"];
                $model->endDate = $_COOKIE["farePosWise-EndD"];
            }

            // Check if the POS is an exit device
            $isExit = 0;
            $exitOrEntrance = $db->createCommand("SELECT BT.id
                FROM tbl_booth_devices BD
                INNER JOIN tbl_booth B ON B.id = BD.booth_id
                INNER JOIN tbl_booth_type BT ON BT.id = B.booth_type
                WHERE BD.device_id = $model->pos AND BD.ic_id = $model->ic AND BD.status = 1")->queryScalar();

            if ($exitOrEntrance == BoothType::EXIT) {
                $isExit = 1; // It's an exit POS
            }

            // Check if the start date is before the backup date
            if ($model->startDate < self::BACKUP_DATE) {
                // Handle different report types for older data (summary, detailed, all)
                if ($model->reportType == 'summary') {
                    // Handle summary report for exit or entrance tickets
                    if ($isExit) {
                        // Fetch exit ticket summary data
                        $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_exit_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
                    } else {
                        // Fetch entrance ticket summary data
                        $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_entrance_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
                    }
                    // Render summary result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseSummaryResult', [
                                'results' => $results,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'detailed') {
                    // Handle detailed report with pagination
                    $page = Yii::$app->request->get('page', 1);
                    $limit = Yii::$app->request->get('per-page', 10);
                    $from = ($page - 1) * $limit;
    
                    if ($isExit) {
                        // Fetch detailed exit ticket data
                        $sql = "SELECT  ET.*,VC.name
                            FROM tbl_exit_ticket_ar ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    } else {
                        // Fetch detailed entrance ticket data
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket_ar ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                    }
                    // Paginate the results
                    $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
                    // Create pagination
                    $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
    
                    // Render detailed result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseDetailedResult', [
                                'results' => $result,
                                'pages' => $pages,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'all') {
                    // Handle 'all' report type combining both summary and detailed
                    $page = Yii::$app->request->get('page', 1);
                    $limit = Yii::$app->request->get('per-page', 10);
                    $from = ($page - 1) * $limit;
    
                    if ($isExit) {
                        // Fetch summary and detailed data for exit tickets
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_exit_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
    
                        $sql = "SELECT  ET.*,VC.name
                            FROM tbl_exit_ticket_ar ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    } else {
                        // Fetch summary and detailed data for entrance tickets
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_entrance_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
    
                        $sql = "SELECT  ET.*,VC.name
                            FROM tbl_entrance_ticket_ar ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                    }
                    // Paginate the detailed results
                    $dResults = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
                    // Create pagination
                    $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
    
                    // Render 'all' result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseAllResult', [
                                'sResults' => $sResults,
                                'dResults' => $dResults,
                                'pages' => $pages,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                }
                //end backup
            } else {
                // Handle the case when the start date is after the backup date
                // Similar logic applies for different report types
                if ($model->reportType == 'summary') {
                    // Fetch summary data based on exit/entrance type
                    if ($isExit) {
                        $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
                    } else {
                        $results = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
                    }
                    // Render summary result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseSummaryResult', [
                                'results' => $results,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'detailed') {
                    // Fetch detailed data with pagination
                    $page = Yii::$app->request->get('page', 1);
                    $limit = Yii::$app->request->get('per-page', 10);
                    $from = ($page - 1) * $limit;
    
                    if ($isExit) {
                        // Fetch exit ticket detailed data
                        $sql = "SELECT  ET.*,VC.name
                            FROM tbl_exit_ticket ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    } else {
                        // Fetch entrance ticket detailed data
                        $sql = "SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                    }
    
                    $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
    
                    $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

                    // Render detailed result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseDetailedResult', [
                                'results' => $result,
                                'pages' => $pages,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'all') {
                    // Fetch summary and detailed data for the 'all' report type
                    $page = Yii::$app->request->get('page', 1);
                    $limit = Yii::$app->request->get('per-page', 10);
                    $from = ($page - 1) * $limit;
    
                    if ($isExit) {
                        // Summary and detailed data for exit tickets
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
    
                        $sql = "SELECT  ET.*,VC.name
                            FROM tbl_exit_ticket ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
                    } else {
                        // Summary and detailed data for entrance tickets
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
    
                        $sql = "SELECT  ET.*,VC.name
                            FROM tbl_entrance_ticket ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
                    }
    
                    $dResults = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
                    $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
    
                    $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
    
                    // Render 'all' result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseAllResult', [
                                'sResults' => $sResults,
                                'dResults' => $dResults,
                                'pages' => $pages,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                }
            }

            
        } else {
            return $this->render('fareCollectionPosWise/fareCollectionPosWise', ['model' => $model]);
        }
    }

    // Fare Collection POS Wise Excel Report Generation
    public function actionFareCollectionPosWiseExcel() {
        // Initialize the FareCollectionPosWise model and database connection
        $model = new FareCollectionPosWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["farePosWise-IC"];
        $model->pos = $_COOKIE["farePosWise-Pos"];
        $model->reportType = $_COOKIE["farePosWise-Type"];
        $model->startDate = $_COOKIE["farePosWise-StartD"];
        $model->endDate = $_COOKIE["farePosWise-EndD"];

        // Check if the POS is an exit device
        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT BT.id
            FROM tbl_booth_devices BD
            INNER JOIN tbl_booth B ON B.id = BD.booth_id
            INNER JOIN tbl_booth_type BT ON BT.id = B.booth_type
            WHERE BD.device_id = $model->pos AND BD.ic_id = $model->ic AND BD.status = 1")->queryScalar();

        if ($exitOrEntrance == BoothType::EXIT) {
            $isExit = 1; // It's an exit POS
        }

            // Check if the start date is before the backup date
            if ($model->startDate < self::BACKUP_DATE) {
                // Handle different report types for older data (summary, detailed, all)
                if ($model->reportType == 'summary') {
                    // Handle summary report for exit or entrance tickets
                    if ($isExit) {
                        // Fetch exit ticket summary data
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_exit_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
                    } else {
                        // Fetch entrance ticket summary data
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_entrance_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
                    }
                    // Render summary result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseSummaryExcel', [
                                'sResults' => $sResults,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'detailed') {
        
                    if ($isExit) {
                        // Fetch detailed exit ticket data
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_exit_ticket_ar ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
                    } else {
                        // Fetch detailed entrance ticket data
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket_ar ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
                    }
        
                    // Render detailed result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseDetailedExcel', [
                                'dResults' => $dResults,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'all') {
        
                    if ($isExit) {
                        // Fetch summary and detailed data for exit tickets
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_exit_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
        
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_exit_ticket_ar ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
                    } else {
                        // Fetch summary and detailed data for entrance tickets
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_entrance_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
        
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket_ar ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
                    }
                    // Render 'all' result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseAllExcel', [
                                'dResults' => $dResults,
                                'sResults' => $sResults,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                }
                //end backup
            }else{
                // Handle the case when the start date is after the backup date
                // Similar logic applies for different report types
                if ($model->reportType == 'summary') {
                    // Fetch summary data based on exit/entrance type
                    if ($isExit) {
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
                    } else {
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
                    }
                    // Render summary result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseSummaryExcel', [
                                'sResults' => $sResults,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'detailed') {
        
                    if ($isExit) {
                        // Fetch exit ticket detailed data
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_exit_ticket ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
                    } else {
                        // Fetch entrance ticket detailed data
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
                    }
                    // Render detailed result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseDetailedExcel', [
                                'dResults' => $dResults,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                } else if ($model->reportType == 'all') {
                    // Fetch summary and detailed data for the 'all' report type
                    if ($isExit) {
                        // Summary and detailed data for exit tickets
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
        
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_exit_ticket ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
                    } else {
                        // Summary and detailed data for entrance tickets
                        $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                            FROM tbl_vehicle_category VC
                            LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            GROUP BY VC.id")->queryAll();
        
                        $dResults = $db->createCommand("SELECT ET.*,VC.name
                            FROM tbl_entrance_ticket ET
                            INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                            ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
                    }
                    // Render 'all' result view
                    return $this->render('fareCollectionPosWise/fareCollectionPosWiseAllExcel', [
                                'dResults' => $dResults,
                                'sResults' => $sResults,
                                'model' => $model,
                                'isExit' => $isExit,
                    ]);
                }
            }

        
    }

    // Fare Collection POS Wise PDF Report Generation
    public function actionFareCollectionPosWisePdf() {
        $model = new FareCollectionPosWise;
        $db = new yii\db\Connection(Yii::$app->db);

        $model->ic = $_COOKIE["farePosWise-IC"];
        $model->pos = $_COOKIE["farePosWise-Pos"];
        $model->reportType = $_COOKIE["farePosWise-Type"];
        $model->startDate = $_COOKIE["farePosWise-StartD"];
        $model->endDate = $_COOKIE["farePosWise-EndD"];
        $isExit = 0;
        $exitOrEntrance = $db->createCommand("SELECT BT.id
            FROM tbl_booth_devices BD
            INNER JOIN tbl_booth B ON B.id = BD.booth_id
            INNER JOIN tbl_booth_type BT ON BT.id = B.booth_type
            WHERE BD.device_id = $model->pos AND BD.ic_id = $model->ic AND BD.status = 1")->queryScalar();

        if ($exitOrEntrance == BoothType::EXIT) {
            $isExit = 1;
        }

        if ($model->reportType == 'summary') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionPosWise/fareCollectionPosWiseSummaryPdf', [
                        'sResults' => $sResults,
                        'model' => $model,
                        'isExit' => $isExit,
            ]));
            $mpdf->Output('Fare Collection POS Wise Summary  ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        } else if ($model->reportType == 'detailed') {

            if ($isExit) {
                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionPosWise/fareCollectionPosWiseDetailedPdf', [
                        'dResults' => $dResults,
                        'model' => $model,
                        'isExit' => $isExit,
            ]));
            $mpdf->Output('Fare Collection POS Wise Detailed  ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        } else if ($model->reportType == 'all') {

            if ($isExit) {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $model->pos AND ET.exit_ic = $model->ic AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.exit_ic = $model->ic AND ET.device_id = $model->pos AND ET.exit_time >= '" . $model->startDate . "' AND ET.exit_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            } else {
                $sResults = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    GROUP BY VC.id")->queryAll();

                $dResults = $db->createCommand("SELECT ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.entrance_ic = $model->ic AND ET.device_id = $model->pos AND ET.entrance_time >= '" . $model->startDate . "' AND ET.entrance_time <= '" . $model->endDate . "'
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            }

            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
            $mpdf->WriteHTML($this->renderPartial('fareCollectionPosWise/fareCollectionPosWiseAllPdf', [
                        'dResults' => $dResults,
                        'sResults' => $sResults,
                        'model' => $model,
                        'isExit' => $isExit,
            ]));
            $mpdf->Output('Fare Collection POS Wise All  ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        }
    }

    // Action to handle fare collection summary based on ticket type (entrance/exit)
    public function actionFareCollectionAllIcSummary() {
        $model = new FareCollectionAllIcSummary; // Create a new model instance

        if (Yii::$app->request->post()) {
            //Get the db connection
            $db = new yii\db\Connection(Yii::$app->db);

            $model->load(Yii::$app->request->post());
            // Store form data in cookies for later use
            setcookie("fareCollectionAllIcSummary-Type", $model->ticketType, time() + 86400);
            setcookie("fareCollectionAllIcSummary-StartD", $model->startDate, time() + 86400);
            setcookie("fareCollectionAllIcSummary-EndD", $model->endDate, time() + 86400);

            //print_r( $model->startDate);die;
            // Handle different ticket types and execute respective stored procedures
            if ($model->ticketType == 'entrance') {
                // Fetch vehicle categories
                $vehicleTypes = VehicleCategory::find()->all();

                // Call the stored procedure for entrance summary
                $sql_main = "CALL Rpt_AllICEntranceSummary('" . $model->startDate . "', '" . $model->endDate . "')";
                $results = $db->createCommand($sql_main)->queryAll();

                // Render the results for entrance ticket type
                return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);
            } else if ($model->ticketType == 'exit(traffic)') {

                $vehicleTypes = VehicleCategory::find()->all();

                // Call the stored procedure for exit (traffic) summary
                $sql_main = "CALL Rpt_AllICExitSummary('" . $model->startDate . "', '" . $model->endDate . "')";
                $results = $db->createCommand($sql_main)->queryAll();

                // Render the results for exit (traffic) ticket type
                return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);
            } else if ($model->ticketType == 'exit(revenue)') {

                $vehicleTypes = VehicleCategory::find()->all();

                // Call the stored procedure for exit (revenue) summary
                $sql_main = "CALL Rpt_AllICExitSummaryAmount('" . $model->startDate . "', '" . $model->endDate . "')";
                $results = $db->createCommand($sql_main)->queryAll();

                // Render the results for exit (revenue) ticket type
                return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);
            }
        } else {
            // If no data was posted, render the empty form
            return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummary', ['model' => $model]);
        }
    }

    // Action to export the fare collection summary results to Excel
    public function actionFareCollectionAllIcSummaryExcel() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $vehicleTypes = json::decode($_POST['vCategor']);

        // Handle export logic based on ticket type
        if ($model['ticketType'] == 'entrance') {
            // Render the Excel view for entrance ticket type
            return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummaryEntranceExcel', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);
        } else if ($model['ticketType'] == 'exit(traffic)' || $model['ticketType'] == 'exit(revenue)') {
            // Render the Excel view for exit ticket types (traffic or revenue)
            return $this->render('fareCollectionAllIcSummary/fareCollectionAllIcSummaryExitExcel', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]);
        }
    }

    // Action to generate the fare collection summary as a PDF
    public function actionFareCollectionAllIcSummaryPdf() {

        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $vehicleTypes = json::decode($_POST['vCategor']);

        // Handle PDF generation logic based on ticket type
        if ($model['ticketType'] == 'entrance') {
            // Create a new mPDF instance for entrance ticket type
            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');

            // Render and output the PDF for entrance ticket type
            $mpdf->WriteHTML($this->renderPartial('fareCollectionAllIcSummary/fareCollectionAllIcSummaryEntrancePdf', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]));
            $mpdf->Output('Fare Collection All Ic Summary(Entrance) ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        } else if ($model['ticketType'] == 'exit(traffic)' || $model['ticketType'] == 'exit(revenue)') {
            // Create a new mPDF instance for exit ticket types (traffic or revenue)
            $mpdf = new \Mpdf\Mpdf();
            $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');

            // Render and output the PDF for exit ticket types
            $mpdf->WriteHTML($this->renderPartial('fareCollectionAllIcSummary/fareCollectionAllIcSummaryExitPdf', ['model' => $model, 'isResult' => 1, 'results' => $results, 'vCategor' => $vehicleTypes]));
            $mpdf->Output('Fare Collection All Ic Summary(Exit) ' . date('Y-m-d H:i:s') . '.pdf', 'D');
            exit();
        }
    }

    // public function actionFareCollectionAllocationWise() {
    //     $model = new FareCollectionAllocationWise;
    //     $db = new yii\db\Connection(Yii::$app->db);

    //     if (Yii::$app->request->post() || Yii::$app->request->get()) {

    //         if (Yii::$app->request->post()) {
    //             $model->load(Yii::$app->request->post());
    //             setcookie("fareAllocationWise-IC", $model->ic, time() + 86400);
    //             setcookie("fareAllocationWise-StartD", $model->startDate, time() + 86400);
    //             setcookie("fareAllocationWise-EndD", $model->endDate, time() + 86400);
    //         } else {
    //             $model->ic = $_COOKIE["fareAllocationWise-IC"];
    //             $model->startDate = $_COOKIE["fareAllocationWise-StartD"];
    //             $model->endDate = $_COOKIE["fareAllocationWise-EndD"];
    //             $model->region = Yii::$app->request->get('region');
    //         }

    //         // Ensure region is set for initial population of IC dropdown
    //         if (isset($model->region)) {
    //             $model->ic = $model->ic ?? key(Ic::getListByRegion($model->region));
    //         }

    //         $sdate = date('Y-m-d', strtotime($model->startDate));
    //         $edate = date('Y-m-d', strtotime($model->endDate));

    //         $page = Yii::$app->request->get('page', 1);
    //         $limit = Yii::$app->request->get('per-page', 10);
    //         $from = ($page - 1) * $limit;
            

    //         $sql = "SELECT SESU.user_id,SES.booth_id,BD.device_id,DATE_FORMAT(concat(SCH.date,' ',SES.start_time), '%Y-%m-%d %H:%i') as sDate,DATE_FORMAT(concat(SCH.date,' ',SES.end_time), '%Y-%m-%d %H:%i') as eDate,SHF.id shiftId
    //             FROM tbl_schedule SCH
    //             INNER JOIN tbl_shift SHF ON SHF.schedule_id = SCH.id AND SHF.ic_id = $model->ic
    //             INNER JOIN tbl_session SES ON SES.shift_id = SHF.id
    //             INNER JOIN tbl_session_users SESU ON SESU.session_id = SES.id
    //             INNER JOIN tbl_booth_devices BD ON BD.booth_id = SES.booth_id AND BD.status = 1
    //             WHERE SCH.date >= '" . $sdate . "' AND SCH.date <= '" . $edate . "' AND DATE_FORMAT(concat(SCH.date,' ',SES.start_time), '%Y-%m-%d %H:%i') > '" . $model->startDate . "' AND DATE_FORMAT(concat(SCH.date,' ',SES.start_time), '%Y-%m-%d %H:%i') < '" . $model->endDate . "'";

    //         $result = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
    //         $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();

    //         $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);

    //         return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWise', [
    //                     'results' => $result,
    //                     'pages' => $pages,
    //                     'model' => $model,
    //         ]);
    //     } else {
    //         return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWise', ['model' => $model]);
    //     }
    // }

    // Action to handle fare collection allocation-wise report
    public function actionFareCollectionAllocationWise()
    {
        // Create a new instance of the FareCollectionAllocationWise model
        $model = new FareCollectionAllocationWise();

        // Handle both POST and GET requests
        //if (Yii::$app->request->isPost || Yii::$app->request->isGet) {
            if (Yii::$app->request->isPost) {
                $model->load(Yii::$app->request->post());
            // Load data from request or cookies
            // if (Yii::$app->request->isPost) {
            //     $model->load(Yii::$app->request->post());
            //     // Store user selections in cookies for persistence
            //     setcookie("fareAllocationWise-IC", $model->ic, time() + 86400); // Expiry: 1 day
            //     setcookie("fareAllocationWise-StartD", $model->startDate, time() + 86400);
            //     setcookie("fareAllocationWise-EndD", $model->endDate, time() + 86400);
            // } else {
            //     // Load data from cookies if available
            //     $model->ic = Yii::$app->request->cookies->getValue('fareAllocationWise-IC', '');
            //     $model->startDate = Yii::$app->request->cookies->getValue('fareAllocationWise-StartD', '');
            //     $model->endDate = Yii::$app->request->cookies->getValue('fareAllocationWise-EndD', '');
            // }

            // Prepare query parameters for SQL execution
            $queryParams = [
                ':startDate' => date('Y-m-d', strtotime($model->startDate)),
                ':endDate' => date('Y-m-d', strtotime($model->endDate)),
            ];

            // Base SQL query for fetching data
            $sql = "
                SELECT SES.user_id, SES.booth_id, SES.device_id, 
                    SES.login_time AS sDate, SES.logout_time AS eDate, 
                    SES.shift_id AS shiftId
                FROM tbl_login_logout_session SES
                INNER JOIN tbl_booth B ON SES.booth_id = B.id
                INNER JOIN tbl_ic IC ON B.ic_id = IC.id
                INNER JOIN tbl_region R ON IC.region_id = R.id
                WHERE SES.login_time >= :startDate
                AND SES.logout_time < :endDate
                AND SES.status = 0
            ";

            if ($model->region !== 'Any') {
                $sql .= " AND R.id = :regionId";
                $queryParams[':regionId'] = $model->region;
            }

            if ($model->ic !== 'Any') {
                $sql .= " AND IC.id = :ic";
                $queryParams[':ic'] = $model->ic;
            }


            // Count total records for pagination
            // $countQueryParams = $queryParams; // Exclude :offset and :limit
            // $countSql = "SELECT COUNT(*) FROM ($sql) AS temp";
            // $count = Yii::$app->db->createCommand($countSql, $countQueryParams)->queryScalar();

            // Set up pagination with a page size of 10 records
             $pagination = new Pagination(['totalCount' => $count, 'pageSize' => 10]);
            // $queryParams[':offset'] = $pagination->offset;
            // $queryParams[':limit'] = $pagination->limit;

            // Fetch the paginated results
           // $results = Yii::$app->db->createCommand($sql . " LIMIT :offset, :limit", $queryParams)->queryAll();
           // Remove pagination setup
            $results = Yii::$app->db->createCommand($sql, $queryParams)->queryAll();


            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Render the view with the model, results, and pagination
            return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWise', [
                'results' => $results,
                'pages' => $pagination,
                'model' => $model,
                'icOptions' => $icOptions,
            ]);
        }

        // Default rendering of the view with an empty model
        return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWise', ['model' => $model, 'icOptions' => [],]);
    }

    
    // Action to handle detailed fare collection allocation-wise view
    public function actionFareCollectionAllocationWiseView($shiftId, $uId, $boothId, $deviecId, $ticketType, $ic, $sDate, $eDate, $isExit) {
        // Determine if the action is for exit tickets
        $isExit = $isExit == 'Exit' ? 1 : 0;
        $db = new yii\db\Connection(Yii::$app->db);

        // Store parameters in cookies for session persistence
        setcookie("fareAllocationWiseView-shiftId", $shiftId, time() + 86400);
        setcookie("fareAllocationWiseView-uId", $uId, time() + 86400);
        setcookie("fareAllocationWiseView-boothId", $boothId, time() + 86400);
        setcookie("fareAllocationWiseView-deviecId", $deviecId, time() + 86400);
        setcookie("fareAllocationWiseView-ticketType", $ticketType, time() + 86400);
        setcookie("fareAllocationWiseView-ic", $ic, time() + 86400);
        setcookie("fareAllocationWiseView-sDate", $sDate, time() + 86400);
        setcookie("fareAllocationWiseView-eDate", $eDate, time() + 86400);
        setcookie("fareAllocationWiseView-isExit", $isExit, time() + 86400);

        if ($sDate < self::BACKUP_DATE) {

            // Determine query logic based on the ticket type
            if ($ticketType == 'Entrance') {
                // Fetch summary results for entrance tickets
                $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    GROUP BY VC.id")->queryAll();

                // Fetch detailed results for entrance tickets
                $sql = "SELECT  ET.*,VC.name
                    FROM tbl_entrance_ticket_ar ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
            } else {
                // Fetch summary results for exit tickets
                $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    GROUP BY VC.id")->queryAll();

                // Fetch detailed results for exit tickets
                $sql = "SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket_ar ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
            }
            // Pagination setup
            $page = Yii::$app->request->get('page', 1);
            $limit = Yii::$app->request->get('per-page', 10);
            $from = ($page - 1) * $limit;

            // Fetch paginated detailed results
            $dResult = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
            // Count total records for pagination
            $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
            // Create pagination object
            $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
            // Render the view with the fetched data
            return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWiseResult', [
                        'dResults' => $dResult,
                        'sResults' => $sResult,
                        'pages' => $pages,
                        'shiftId' => $shiftId,
                        'uId' => $uId,
                        'boothId' => $boothId,
                        'deviecId' => $deviecId,
                        'ticketType' => $ticketType,
                        'ic' => $ic,
                        'sDate' => $sDate,
                        'eDate' => $eDate,
                        'isExit' => $isExit,
            ]);
        // end backup 
        } else {

            // Determine query logic based on the ticket type
            if ($ticketType == 'Entrance') {
                // Fetch summary results for entrance tickets
                $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    GROUP BY VC.id")->queryAll();

                // Fetch detailed results for entrance tickets
                $sql = "SELECT  ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time";
            } else {
                // Fetch summary results for exit tickets
                $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    GROUP BY VC.id")->queryAll();

                // Fetch detailed results for exit tickets
                $sql = "SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time";
            }
            // Pagination setup
            $page = Yii::$app->request->get('page', 1);
            $limit = Yii::$app->request->get('per-page', 10);
            $from = ($page - 1) * $limit;

            // Fetch paginated detailed results
            $dResult = $db->createCommand($sql . ' LIMIT ' . $from . ',' . $limit)->queryAll();
            // Count total records for pagination
            $count = $db->createCommand('SELECT COUNT(*) as total FROM (' . $sql . ') a')->queryScalar();
            // Create pagination object
            $pages = new Pagination(['totalCount' => $count, 'pageSize' => $limit]);
            // Render the view with the fetched data
            return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWiseResult', [
                        'dResults' => $dResult,
                        'sResults' => $sResult,
                        'pages' => $pages,
                        'shiftId' => $shiftId,
                        'uId' => $uId,
                        'boothId' => $boothId,
                        'deviecId' => $deviecId,
                        'ticketType' => $ticketType,
                        'ic' => $ic,
                        'sDate' => $sDate,
                        'eDate' => $eDate,
                        'isExit' => $isExit,
            ]);

        }
        
    }

    // Action to generate Excel report for fare collection allocation-wise view
    public function actionFareCollectionAllocationWiseExcel() {
        $db = new yii\db\Connection(Yii::$app->db);

        // Retrieve parameters from cookies
        $shiftId = $_COOKIE["fareAllocationWiseView-shiftId"];
        $uId = $_COOKIE["fareAllocationWiseView-uId"];
        $boothId = $_COOKIE["fareAllocationWiseView-boothId"];
        $deviecId = $_COOKIE["fareAllocationWiseView-deviecId"];
        $ticketType = $_COOKIE["fareAllocationWiseView-ticketType"];
        $ic = $_COOKIE["fareAllocationWiseView-ic"];
        $sDate = $_COOKIE["fareAllocationWiseView-sDate"];
        $eDate = $_COOKIE["fareAllocationWiseView-eDate"];
        $isExit = $_COOKIE["fareAllocationWiseView-isExit"];

        if ($sDate < self::BACKUP_DATE) {

             // Determine the query logic based on ticket type (Entrance or Exit)
            if ($ticketType == 'Entrance') {
                // Fetch summary results for entrance tickets
                $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    GROUP BY VC.id")->queryAll();
                // Fetch detailed results for entrance tickets
                $dResult = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_entrance_ticket_ar ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            } else {
                // Fetch summary results for exit tickets
                $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket_ar ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    GROUP BY VC.id")->queryAll();
                // Fetch detailed results for exit tickets
                $dResult = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket_ar ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            }

            // Render the view to generate the Excel report
            return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWiseExcel', [
                        'dResults' => $dResult,
                        'sResults' => $sResult,
                        'pages' => $pages,
                        'shiftId' => $shiftId,
                        'uId' => $uId,
                        'boothId' => $boothId,
                        'deviecId' => $deviecId,
                        'ticketType' => $ticketType,
                        'ic' => $ic,
                        'sDate' => $sDate,
                        'eDate' => $eDate,
                        'isExit' => $isExit,
            ]);
        //end backup
        } else {

             // Determine the query logic based on ticket type (Entrance or Exit)
            if ($ticketType == 'Entrance') {
                // Fetch summary results for entrance tickets
                $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    GROUP BY VC.id")->queryAll();
                // Fetch detailed results for entrance tickets
                $dResult = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
            } else {
                // Fetch summary results for exit tickets
                $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                    FROM tbl_vehicle_category VC
                    LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    GROUP BY VC.id")->queryAll();
                // Fetch detailed results for exit tickets
                $dResult = $db->createCommand("SELECT  ET.*,VC.name
                    FROM tbl_exit_ticket ET
                    INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                    WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                    ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
            }

            // Render the view to generate the Excel report
            return $this->render('fareCollectionAllocationWise/fareCollectionAllocationWiseExcel', [
                        'dResults' => $dResult,
                        'sResults' => $sResult,
                        'pages' => $pages,
                        'shiftId' => $shiftId,
                        'uId' => $uId,
                        'boothId' => $boothId,
                        'deviecId' => $deviecId,
                        'ticketType' => $ticketType,
                        'ic' => $ic,
                        'sDate' => $sDate,
                        'eDate' => $eDate,
                        'isExit' => $isExit,
            ]);
        }
       
    }

    // Action to generate PDF report for fare collection allocation-wise view
    public function actionFareCollectionAllocationWisePdf() {
        $db = new yii\db\Connection(Yii::$app->db);

        // Retrieve parameters from cookies
        $shiftId = $_COOKIE["fareAllocationWiseView-shiftId"];
        $uId = $_COOKIE["fareAllocationWiseView-uId"];
        $boothId = $_COOKIE["fareAllocationWiseView-boothId"];
        $deviecId = $_COOKIE["fareAllocationWiseView-deviecId"];
        $ticketType = $_COOKIE["fareAllocationWiseView-ticketType"];
        $ic = $_COOKIE["fareAllocationWiseView-ic"];
        $sDate = $_COOKIE["fareAllocationWiseView-sDate"];
        $eDate = $_COOKIE["fareAllocationWiseView-eDate"];
        $isExit = $_COOKIE["fareAllocationWiseView-isExit"];

        // Determine the query logic based on ticket type (Entrance or Exit)
        if ($ticketType == 'Entrance') {
            // Fetch summary results for entrance tickets
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_entrance_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            // Fetch detailed results for entrance tickets
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_entrance_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.entrance_time")->queryAll();
        } else {
            // Fetch summary results for exit tickets
            $sResult = $db->createCommand("SELECT VC.id,VC.name,VC.description,COUNT(ET.id) as vcount,IFNULL(sum(ET.amount),0.00) as amount
                FROM tbl_vehicle_category VC
                LEFT JOIN tbl_exit_ticket ET ON ET.vehicle_category = VC.id AND ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                GROUP BY VC.id")->queryAll();
            // Fetch detailed results for exit tickets
            $dResult = $db->createCommand("SELECT  ET.*,VC.name
                FROM tbl_exit_ticket ET
                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                WHERE ET.device_id = $deviecId AND ET.booth_id = $boothId AND ET.teller_id = $uId AND ET.shift_id = $shiftId
                ORDER BY ET.teller_id,ET.vehicle_category,ET.exit_time")->queryAll();
        }

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF
        $mpdf->WriteHTML($this->renderPartial('fareCollectionAllocationWise/fareCollectionAllocationWisePdf', [
                    'dResults' => $dResult,
                    'sResults' => $sResult,
                    'pages' => $pages,
                    'shiftId' => $shiftId,
                    'uId' => $uId,
                    'boothId' => $boothId,
                    'deviecId' => $deviecId,
                    'ticketType' => $ticketType,
                    'ic' => $ic,
                    'sDate' => $sDate,
                    'eDate' => $eDate,
                    'isExit' => $isExit,
        ]));
        $mpdf->Output('Fare Collection Allocation ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to analyze hourly traffic
    public function actionAnalysisHourlyTraffic() {
        // Initialize the model and database connection
        $model = new AnalysisHourlyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $results = [];

            // Check the type of ticket (exit or entrance)
            if ($model->ticketType == 'exit') {
                // Handle 'exit' ticket type
                if ($model->region == 'Any') { // If region is 'Any', check if IC is 'Any' or specific
                    if ($model->ic == 'Any') { 
                        // Call stored procedure for exit with 'Any' IC
                        $sql_main = "CALL Rpt_HourlyTrafficDirectionalExitAnyIc('" . $model->date . "')";
                        
                    } else {
                        // Call stored procedure for exit with specific IC
                        $sql_main = "CALL Rpt_HourlyTrafficDirectionalExit('" . $model->ic . "', '" . $model->date . "')";
                        
                    }
                } else {
                    // If a specific region is selected
                    if ($model->ic == 'Any') {
                        // Call stored procedure for exit with 'Any' IC in a specific region
                        $sql_main = "CALL Rpt_HourlyTrafficDirectionalExitAnyIcRegion('" . $model->region . "', '" . $model->date . "')";
                        
                    } else {
                        // Call stored procedure for exit with specific IC in a specific region
                        $sql_main = "CALL Rpt_HourlyTrafficDirectionalExit('" . $model->ic . "', '" . $model->date . "')";
                        
                    }
                }
            } else {
                // Handle ticket types other than 'exit' (e.g., entrance)
                if ($model->region == 'Any') { // If region is 'Any', check if IC is 'Any' or specific
                    if ($model->ic == 'Any') {
                        // Call stored procedure for entrance with 'Any' IC
                        $sql_main = "CALL Rpt_HourlyTrafficDirectionalEntranceAnyIc('" . $model->date . "')";
                        
                    } else {
                        // Call stored procedure for entrance with specific IC
                        $sql_main = "CALL Rpt_HourlyTrafficDirectionalEntrance('" . $model->ic . "', '" . $model->date . "')";
                        
                    }
                } else {
                    // If a specific region is selected
                    if ($model->ic == 'Any') {
                        // Call stored procedure for entrance with 'Any' IC in a specific region
                        $sql_main = "CALL Rpt_HourlyTrafficDirectionalEntranceAnyIcRegion('" . $model->region . "', '" . $model->date . "')";
                        
                    } else {
                        // Call stored procedure for entrance with specific IC in a specific region
                        $sql_main = "CALL Rpt_HourlyTrafficDirectionalEntrance('" . $model->ic . "', '" . $model->date . "')";
                        
                    }
                }
            }

            // Execute the query and fetch results
            $temp = $db->createCommand($sql_main)->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Render the view with the model and results
            return $this->render('analysisHourlyTraffic/analysisHourlyTraffic', ['model' => $model, 'results' => $temp, 'icOptions' => $icOptions,]);
        } else {
            // Render the initial view with an empty model
            return $this->render('analysisHourlyTraffic/analysisHourlyTraffic', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to export hourly traffic data to Excel
    public function actionAnalysisHourlyTrafficExcel() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel-specific view with the data
        return $this->render('analysisHourlyTraffic/analysisHourlyTrafficExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to export hourly traffic data to PDF
    public function actionAnalysisHourlyTrafficPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF content
        $mpdf->WriteHTML($this->renderPartial('analysisHourlyTraffic/analysisHourlyTrafficPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Hourly Traffic Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to analyze traffic for a specific time period
    public function actionAnalysisTimePeriodTraffic() {
        // Initialize the model and database connection
        $model = new AnalysisTimePeriodTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Determine the type of ticket (exit or entrance) and prepare the SQL query
            if ($model->ticketType == 'exit') {
                // Use stored procedure to fetch exit traffic data for the time period
                $sql_main = "CALL Rpt_TimePeriodDirectionalExit('" . $model->startDate . "', '" . $model->endDate . "')";
                $temp = $db->createCommand($sql_main)->queryAll();
            } else {
                // Use stored procedure to fetch entrance traffic data for the time period
                $sql_main = "CALL Rpt_TimePeriodDirectionalEntrance('" . $model->startDate . "', '" . $model->endDate . "')";
                $temp = $db->createCommand($sql_main)->queryAll();
            }
            //   print_r($temp);die;
            // Render the view with the model and fetched data
            return $this->render('analysisTimePeriodTraffic/analysisTimePeriodTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            // Render the initial view with an empty model
            return $this->render('analysisTimePeriodTraffic/analysisTimePeriodTraffic', ['model' => $model]);
        }
    }

    // Action to export time period traffic data to Excel
    public function actionAnalysisTimePeriodTrafficExcel() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view specifically designed for Excel export
        return $this->render('analysisTimePeriodTraffic/analysisTimePeriodTrafficExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to export time period traffic data to PDF
    public function actionAnalysisTimePeriodTrafficPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF content
        $mpdf->WriteHTML($this->renderPartial('analysisTimePeriodTraffic/analysisTimePeriodTrafficPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Time Period Traffic Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    public function actionAnalysisTimePeriodTraffic15() {
        $model = new AnalysisTimePeriodTraffic;

        $db = new yii\db\Connection(Yii::$app->db);
        $db_rpt = new yii\db\Connection(Yii::$app->db_rpt);

        $guid = Yii::$app->Guid->getGUID();
        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $partions = $db_rpt->createCommand("SELECT name FROM `tbl_exit_partion_details` WHERE DATE(related_date) BETWEEN DATE('$model->startDate') AND DATE('$model->endDate') GROUP BY name")->queryAll();
            if ($model->ticketType == 'exit') {

                foreach ($partions as $p) {
                    $p_name = $p["name"];

                    // $sql_main = "CALL Insert_TimePeriodDirectionalExit_15('" . $model->startDate . "', '" . $model->endDate . "', '" . $guid . "', '" . $p_name . "' )";

                    $sql_main = "INSERT INTO rpt_hourly_traffic_directional_exit_revenue(guid,exit_ic,direction,cat1_count,cat2_count,cat3_count,cat4_count,catS_count,catPS_count,catPMS_count,catAmbulance_count,catNotAssigned_count, cat1_amount,cat2_amount,cat3_amount,cat4_amount,catS_amount,catPS_amount,catPMS_amount,catAmbulance_amount,catNotAssigned_amount)
                    SELECT
                    '" . $guid . "',
                        tb.exit_ic,
                        tb.direction,
                        IFNULL(SUM(case when tb.vehicle_category = 1 THEN tb.count END),0) Cat01,
                        IFNULL(SUM(case when tb.vehicle_category = 2 THEN tb.count END),0) Cat02,
                        IFNULL(SUM(case when tb.vehicle_category = 3 THEN tb.count END),0) Cat03,
                        IFNULL(SUM(case when tb.vehicle_category = 4 THEN tb.count END),0) Cat04,
                        IFNULL(SUM(case when tb.vehicle_category = 20 THEN tb.count END),0) CatS,
                        IFNULL(SUM(case when tb.vehicle_category = 21 THEN tb.count END),0) CatPS,
                        IFNULL(SUM(case when tb.vehicle_category = 22 THEN tb.count END),0) CatPMS,
                        IFNULL(SUM(case when tb.vehicle_category = 30 THEN tb.count END),0) CatAmbulance,
                        IFNULL(SUM(case when tb.vehicle_category = 99 THEN tb.count END),0) CatNotAssigned,
                        IFNULL(SUM(case when tb.vehicle_category = 1 THEN tb.amount END),0) Cat01Amount,
                        IFNULL(SUM(case when tb.vehicle_category = 2 THEN tb.amount END),0) Cat02Amount,
                        IFNULL(SUM(case when tb.vehicle_category = 3 THEN tb.amount END),0) Cat03Amount,
                        IFNULL(SUM(case when tb.vehicle_category = 4 THEN tb.amount END),0) Cat04Amount,
                        IFNULL(SUM(case when tb.vehicle_category = 20 THEN tb.amount END),0) CatSAmount,
                        IFNULL(SUM(case when tb.vehicle_category = 21 THEN tb.amount END),0) CatPSAmount,
                        IFNULL(SUM(case when tb.vehicle_category = 22 THEN tb.amount END),0) CatPMSAmount,
                        IFNULL(SUM(case when tb.vehicle_category = 30 THEN tb.amount END),0) CatAmbulanceAmount,
                        IFNULL(SUM(case when tb.vehicle_category = 99 THEN tb.amount END),0) CatNotAssignedAmount

                    FROM
                    (

                    SELECT d.name AS direction, t.exit_ic,t.vehicle_category ,COUNT(t.vehicle_category) AS count, SUM(t.amount) AS amount FROM
                    (
                    SELECT date(exit_time) AS day, exit_ic,vehicle_category,entrance_ic ,amount FROM ($p_name)
                        where
                         ticket_type_status_id NOT IN (2,12) and
                        exit_time >= '" . $model->startDate . "' and exit_time < '" . $model->endDate . "'
                    ) t
                    INNER JOIN tbl_route r ON r.source = t.entrance_ic AND r.destination = t.exit_ic
                    INNER JOIN tbl_direction d ON r.direction = d.id
                    GROUP BY d.name, t.exit_ic,t.vehicle_category

                    ) tb
                    GROUP BY tb.direction,tb.exit_ic";

                    $temp = $db_rpt->createCommand($sql_main)->execute();
                }

                $sql_main = "CALL Rpt_TimePeriodDirectionalExit_15('" . $guid . "')";
                $temp = $db_rpt->createCommand($sql_main)->queryAll();
                $db_rpt->createCommand("DELETE FROM `rpt_hourly_traffic_directional_exit_revenue` WHERE `guid`='$guid'")->execute();
            } else {
                foreach ($partions as $p) {
                    $p_name = $p["name"];
                    // $sql_main = "CALL Rpt_TimePeriodDirectionalExit_15('" . $model->startDate . "', '" . $model->endDate . "', '" . $p_name . "')";
                    $sql_main = "INSERT INTO rpt_hourly_directional_traffic_entrance(guid,ic_id,direction,cat1_count,cat2_count,cat3_count,cat4_count,catS_count,catPS_count,catPMS_count,catAmbulance_count,catNotAssigned_count)
                    SELECT
                    '" . $guid . "',
                        tb.entrance_ic,
                        tb.direction,
                        IFNULL(SUM(case when tb.vehicle_category = 1 THEN tb.count END),0) Cat01,
                        IFNULL(SUM(case when tb.vehicle_category = 2 THEN tb.count END),0) Cat02,
                        IFNULL(SUM(case when tb.vehicle_category = 3 THEN tb.count END),0) Cat03,
                        IFNULL(SUM(case when tb.vehicle_category = 4 THEN tb.count END),0) Cat04,
                        IFNULL(SUM(case when tb.vehicle_category = 20 THEN tb.count END),0) CatS,
                        IFNULL(SUM(case when tb.vehicle_category = 21 THEN tb.count END),0) CatPS,
                        IFNULL(SUM(case when tb.vehicle_category = 22 THEN tb.count END),0) CatPMS,
                        IFNULL(SUM(case when tb.vehicle_category = 30 THEN tb.count END),0) CatAmbulance,
                        IFNULL(SUM(case when tb.vehicle_category = 99 THEN tb.count END),0) CatNotAssigned
                        FROM (
                            SELECT
                            '" . $guid . "',

                            tbl.entrance_ic,
                            tbl.vehicle_category,
                            tbl.direction,
                            tbl.count
                             FROM
                                (SELECT
                                '" . $guid . "',

                                t.entrance_ic,
                                t.vehicle_category,
                                d.name AS direction,
                                COUNT(t.vehicle_category) AS count FROM
                                (
                                SELECT * FROM ($p_name) where entrance_time >= '" . $model->startDate . "' and entrance_time < '" . $model->endDate . "'
                                ) t
                                INNER JOIN tbl_route r ON r.source = t.entrance_ic AND r.destination = t.exit_ic
                                INNER JOIN tbl_direction d ON r.direction = d.id
                                GROUP BY t.entrance_ic,t.vehicle_category,d.name ) tbl

                             ) tb GROUP BY
                        tb.entrance_ic,
                        tb.vehicle_category,
                        tb.direction";

                    $temp = $db_rpt->createCommand($sql_main)->execute();
                }

                $sql_main = "CALL Rpt_TimePeriodDirectionalEntrance_15('" . $guid . "')";
                $temp = $db_rpt->createCommand($sql_main)->queryAll();
                $db_rpt->createCommand("DELETE FROM `rpt_hourly_directional_traffic_entrance` WHERE `guid`='$guid'")->execute();
            }

            return $this->render('analysisTimePeriodTraffic15/analysisTimePeriodTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            return $this->render('analysisTimePeriodTraffic15/analysisTimePeriodTraffic', ['model' => $model]);
        }
    }

    public function actionAnalysisTimePeriodTraffic15Excel() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('analysisTimePeriodTraffic15/analysisTimePeriodTrafficExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    public function actionAnalysisTimePeriodTraffic15Pdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('analysisTimePeriodTraffic15/analysisTimePeriodTrafficPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Time Period Traffic Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display Hourly Sectional Traffic Analysis
    public function actionAnalysisHourlySectionalTraffic() {
        // Initialize the model and database connection
        $model = new HourlySectionTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            $temp = [];
            // Fetch time intervals for the report
            $time_intervals = $db->createCommand("SELECT * FROM `time_intervals_for_report`")->queryAll();
            // Fetch active vehicle categories
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();
            $i = 0; // Index to track time intervals

            // Determine the table name based on the backup date logic
            $tableName = $model->startDate < self::BACKUP_DATE ? 'tbl_exit_ticket_ar' : 'tbl_exit_ticket';

            // Prepare the structure of the $temp array
            foreach ($time_intervals as $interval) {

                // Initialize data for direction 1
                $sub_array_direction_1['time'] = $interval['start_time'] . '-' . $interval['end_time'];
                $sub_array_direction_1['direction'] = 1;

                // Initialize data for direction 2
                $sub_array_direction_2['time'] = '';
                $sub_array_direction_2['direction'] = 2;

                // Initialize counts for all vehicle categories to 0
                foreach ($vehicle_categories as $category) {
                    $sub_array_direction_1[$category['id']] = 0;
                    $sub_array_direction_2[$category['id']] = 0;
                }

                // Store data in the $temp array for both directions
                $temp[$i . '-1'] = $sub_array_direction_1;
                $temp[$i . '-2'] = $sub_array_direction_2;
                $i++;
            }
            
            // // Query to fetch traffic data based on the selected time period and sections
            // $results = $db->createCommand("SELECT hour( ET.exit_time ) as hr,ET.vehicle_category as vc,count(ET.vehicle_category) as count, R.direction FROM tbl_exit_ticket ET
            //     INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination = ET.exit_ic
            //     WHERE ET.exit_time >= '$model->startDate' AND ET.exit_time <= '$model->endDate' AND ((ET.exit_ic = $model->fIc OR ET.exit_ic = $model->sIc) OR (ET.entrance_ic = $model->fIc OR ET.entrance_ic = $model->sIc)) GROUP BY hour (ET.exit_time ),ET.vehicle_category,R.direction")->queryAll();

            // Fetch hourly traffic data from the database
            // The query groups by hour, vehicle category, and direction
                $results = $db->createCommand("
                SELECT HOUR(ET.exit_time) as hr, ET.vehicle_category as vc, COUNT(ET.vehicle_category) as count, R.direction
                FROM {$tableName} ET
                INNER JOIN tbl_route R ON R.source = ET.entrance_ic AND R.destination = ET.exit_ic
                WHERE ET.exit_time BETWEEN :startDate AND :endDate
                AND ((ET.exit_ic IN (:fIc, :sIc)) OR (ET.entrance_ic IN (:fIc, :sIc)))
                GROUP BY HOUR(ET.exit_time), ET.vehicle_category, R.direction
            ")
            ->bindValues([
                ':startDate' => $model->startDate, 
                ':endDate' => $model->endDate,     
                ':fIc' => $model->fIc,             
                ':sIc' => $model->sIc,             
            ])->queryAll();

            // Populate the $temp array with actual data from the query
            foreach ($results as $result) {
                $temp[$result['hr'] . '-' . $result['direction']][$result['vc']] = $result['count'];
            }
            // Render the view with the model and the processed data
            return $this->render('analysisHourlySectionalTraffic/analysisHourlySectionalTraffic', ['model' => $model, 'results' => $temp]);
        } else {
            // Render the initial view with the empty model
            return $this->render('analysisHourlySectionalTraffic/analysisHourlySectionalTraffic', ['model' => $model]);
        }
    }

    // Action to export Hourly Sectional Traffic data to Excel
    public function actionAnalysisHourlySectionalTrafficExcel() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view specifically designed for Excel export
        return $this->render('analysisHourlySectionalTraffic/analysisHourlySectionalTrafficExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to export Hourly Sectional Traffic data to PDF
    public function actionAnalysisHourlySectionalTrafficPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF content
        $mpdf->WriteHTML($this->renderPartial('analysisHourlySectionalTraffic/analysisHourlySectionalTrafficPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Hourly Sectional Traffic Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display Time Period Revenue analysis data
    public function actionAnalysisTimePeriodRevenue() {
        // Initialize the model and set default ticketType
        $model = new AnalysisTimePeriodTraffic;
        $model->ticketType = 'exit';

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $results = [];
            // print_r($model->region);die;
            // Construct the SQL query based on the region filter
            if ($model->region == 'all_highway') {
                // Query for all highways
                $sql_main = "CALL Rpt_TimePeriodDirectionalExitRevenue('" . $model->startDate . "', '" . $model->endDate . "')";
            } else {
                // Query for a specific highway
                $sql_main = "CALL Rpt_TimePeriodDirectionalExitRevenueHighway('" . $model->startDate . "', '" . $model->endDate . "','" . $model->region . "')";  
            }

            // Execute the query and fetch results
            $temp = $db->createCommand($sql_main)->queryAll();

            // Render the view with the model and query results
            return $this->render('analysisTimePeriodRevenue/analysisTimePeriodRevenue', ['model' => $model, 'results' => $temp]);
        } else {
            // Render the initial view with the empty model
            return $this->render('analysisTimePeriodRevenue/analysisTimePeriodRevenue', ['model' => $model]);
        }
    }

    // Action to export Time Period Revenue data to Excel
    public function actionAnalysisTimePeriodRevenueExcel() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view specifically designed for Excel export
        return $this->render('analysisTimePeriodRevenue/analysisTimePeriodRevenueExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to export Time Period Revenue data to PDF
    public function actionAnalysisTimePeriodRevenuePdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF content
        $mpdf->WriteHTML($this->renderPartial('analysisTimePeriodRevenue/analysisTimePeriodRevenuePdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Time Period Traffic Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display Hourly Revenue analysis data
    public function actionAnalysisHourlyRevenue() {
        // Create a new model for Hourly Revenue analysis
        $model = new AnalysisHourlyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $results = [];

            // Build the SQL query dynamically based on the region and IC filters
            if ($model->region == 'Any') {
                if ($model->ic == 'Any') {
                    // Call stored procedure with only the date parameter
                    $sql_main = "CALL Rpt_HourlyRevenueDirectionalExitIcAny( '" . $model->date . "')";
                } else {
                    // Call stored procedure with IC and date parameters
                    $sql_main = "CALL Rpt_HourlyRevenueDirectionalExitIc('" . $model->ic . "', '" . $model->date . "')";
                }
            } else {
                if ($model->ic == 'Any') {
                    // Call stored procedure with region and date parameters
                    $sql_main = "CALL Rpt_HourlyRevenueDirectionalExitIcAnyRegion('" . $model->region . "', '" . $model->date . "')";
                } else {
                    // Call stored procedure with IC and date parameters
                    $sql_main = "CALL Rpt_HourlyRevenueDirectionalExitIc('" . $model->ic . "', '" . $model->date . "')";
                }
            }
            // Execute the query and fetch the results
            $temp = $db->createCommand($sql_main)->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Render the view with the model and query results
            return $this->render('analysisHourlyRevenue/analysisHourlyRevenue', ['model' => $model, 'results' => $temp, 'icOptions' => $icOptions,]);
        } else {
            // Render the initial view with the empty model
            return $this->render('analysisHourlyRevenue/analysisHourlyRevenue', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to export Hourly Revenue data to Excel
    public function actionAnalysisHourlyRevenueExcel() {
        // Decode the results and model passed via POST
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for Excel export with the results and model
        return $this->render('analysisHourlyRevenue/analysisHourlyRevenueExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to export Hourly Revenue data to PDF
    public function actionAnalysisHourlyRevenuePdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for PDF content
        $mpdf->WriteHTML($this->renderPartial('analysisHourlyRevenue/analysisHourlyRevenuePdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Hourly Revenue Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display Daily Traffic analysis data
    public function actionAnalysisDailyTraffic() {
        // Create a new model for Daily Traffic analysis
        $model = new AnalysisDailyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Retrieve all active vehicle categories from the database
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();

            // Build the SQL query based on the ticket type, region, and IC filters
            if ($model->ticketType == 'exit') { // Handle 'exit' ticket type
                if ($model->region == 'Any') {
                    if ($model->ic == 'Any') {
                    // Call stored procedure with year and month parameters for all regions and ICs
                        $sql_main = "CALL RptDailyTrafficDirectionalExitAny('" . $model->year . "', '" . $model->month . "')";
                    } else {
                    // Call stored procedure with year, month, and IC parameters for all regions
                        $sql_main = "CALL RptDailyTrafficDirectionalExit('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                    }
                } else {
                    if ($model->ic == 'Any') {
                    // Call stored procedure with year, month, and region parameters for all ICs
                        $sql_main = "CALL RptDailyTrafficDirectionalExitAnyRegion('" . $model->year . "', '" . $model->month . "', '" . $model->region . "')";
                    } else {
                    // Call stored procedure with year, month, region, and IC parameters
                        $sql_main = "CALL RptDailyTrafficDirectionalExit('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                    }
                }
            } else {
                // Handle 'entrance' ticket type
                if ($model->region == 'Any') {
                    if ($model->ic == 'Any') {
                        // Call stored procedure with year and month parameters for all regions and ICs
                        $sql_main = "CALL RptDailyTrafficDirectionalEntranceAny('" . $model->year . "', '" . $model->month . "')";
                    } else {
                        // Call stored procedure with year, month, and IC parameters for all regions
                        $sql_main = "CALL RptDailyTrafficDirectionalEntrance('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                    }
                } else {
                    if ($model->ic == 'Any') {
                        // Call stored procedure with year, month, and region parameters for all ICs
                        $sql_main = "CALL RptDailyTrafficDirectionalEntranceAnyRegion('" . $model->year . "', '" . $model->month . "', '" . $model->region . "')";
                    } else {
                        // Call stored procedure with year, month, region, and IC parameters
                        $sql_main = "CALL RptDailyTrafficDirectionalEntrance('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                    }
                }
            }
            
            // Execute the query to fetch data
            $temp = $db->createCommand($sql_main)->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
            
            // Render the view with the results and the model
            return $this->render('analysisDailyTraffic/analysisDailyTraffic', ['model' => $model, 'results' => $temp, 'icOptions' => $icOptions,]);
        } else {
            // Render the initial view with only the model
            return $this->render('analysisDailyTraffic/analysisDailyTraffic', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action for exporting Daily Traffic data to Excel
    public function actionAnalysisDailyTrafficExcel() {
        // Decode the results and model passed from the POST request
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for Excel export, passing the data
        return $this->render('analysisDailyTraffic/analysisDailyTrafficExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action for exporting Daily Traffic data to PDF
    public function actionAnalysisDailyTrafficPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf(['format' => 'A4']);
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF, passing the results and model
        $mpdf->WriteHTML($this->renderPartial('analysisDailyTraffic/analysisDailyTrafficPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Daily Traffic Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display Daily Revenue analysis data
    public function actionAnalysisDailyRevenue() {
        // Create a new model for Daily Revenue analysis
        $model = new AnalysisDailyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Retrieve all active vehicle categories from the database
            $vehicle_categories = $db->createCommand("SELECT * FROM tbl_vehicle_category V WHERE V.active_status = 1")->queryAll();

            // Determine the SQL query based on region and IC filters
            if ($model->region == 'Any') {
                if ($model->ic == 'Any') {
                 // Call stored procedure with year and month parameters for all regions and ICs
                    $sql_main = "CALL RptDailyRevenueDirectionalExitAny('" . $model->year . "', '" . $model->month . "')";
                } else {
                // Call stored procedure with year, month, and IC parameters for all regions
                    $sql_main = "CALL RptDailyRevenueDirectionalExit('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                }
            } else {
                if ($model->ic == 'Any') {
                // Call stored procedure with year, month, and region parameters for all ICs
                    $sql_main = "CALL RptDailyRevenueDirectionalExitAnyRegion('" . $model->year . "', '" . $model->month . "', '" . $model->region . "')";
                } else {
                    // Call stored procedure with year, month, region, and IC parameters
                    $sql_main = "CALL RptDailyRevenueDirectionalExit('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                }
            }
            
            // Execute the query to fetch data
            $temp = $db->createCommand($sql_main)->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
            
            // Render the view with the results and the model
            return $this->render('analysisDailyRevenue/analysisDailyRevenue', ['model' => $model, 'results' => $temp, 'icOptions' => $icOptions,]);
        } else {
            // Render the initial view with only the model
            return $this->render('analysisDailyRevenue/analysisDailyRevenue', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action for exporting Daily Revenue data to Excel
    public function actionAnalysisDailyRevenueExcel() {
        // Decode the results and model passed from the POST request
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for Excel export, passing the data
        return $this->render('analysisDailyRevenue/analysisDailyRevenueExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action for exporting Daily Revenue data to PDF
    public function actionAnalysisDailyRevenuePdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF, passing the results and model
        $mpdf->WriteHTML($this->renderPartial('analysisDailyRevenue/analysisDailyRevenuePdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Daily Revenue Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action for displaying Monthly Traffic analysis data
    public function actionAnalysisMonthlyTraffic() {
        // Create a new model for Monthly Traffic analysis
        $model = new AnalysisMonthlyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Determine the SQL query based on ticket type, region, and IC filters
            if ($model->ticketType == 'exit') {
                // Handle 'exit' ticket type
                if ($model->region == 'Any') {
                    if ($model->ic == 'Any') {
                        // Call the stored procedure for 'exit' with only the year parameter
                        $sql_main = "CALL RptMonthlyTrafficDirectionalExitIcAny('" . $model->year . "')";
                    } else {
                        // Call the stored procedure for 'exit' with year and IC parameters
                        $sql_main = "CALL RptMonthlyTrafficDirectionalExitIc('" . $model->year . "', '" . $model->ic . "')";
                    }
                } else {
                    if ($model->ic == 'Any') {
                        // Call the stored procedure for 'exit' with year and region parameters
                        $sql_main = "CALL RptMonthlyTrafficDirectionalExitIcAnyRegion('" . $model->year . "', '" . $model->region . "')";
                    } else {
                        // Call the stored procedure for 'exit' with year, region, and IC parameters
                        $sql_main = "CALL RptMonthlyTrafficDirectionalExitIc('" . $model->year . "', '" . $model->ic . "')";
                    }
                }
            } else {
                // Handle 'entrance' ticket type
                if ($model->region == 'Any') {
                    if ($model->ic == 'Any') {
                        // Call the stored procedure for 'entrance' with only the year parameter
                        $sql_main = "CALL RptMonthlyTrafficDirectionalEntranceIcAny('" . $model->year . "')";
                    } else {
                        // Call the stored procedure for 'entrance' with year and IC parameters
                        $sql_main = "CALL RptMonthlyTrafficDirectionalEntranceIc('" . $model->year . "', '" . $model->ic . "')";
                    }
                } else {
                    if ($model->ic == 'Any') {
                        // Call the stored procedure for 'entrance' with year and region parameters
                        $sql_main = "CALL RptMonthlyTrafficDirectionalEntranceIcAnyRegion('" . $model->year . "', '" . $model->region . "')";
                    } else {
                        // Call the stored procedure for 'entrance' with year, region, and IC parameters
                        $sql_main = "CALL RptMonthlyTrafficDirectionalEntranceIc('" . $model->year . "', '" . $model->ic . "')";
                    }
                }
            }
            
            // Execute the query to fetch data
            $temp = $db->createCommand($sql_main)->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
            

            // Render the view with the results and the model
            return $this->render('analysisMonthlyTraffic/analysisMonthlyTraffic', ['model' => $model, 'results' => $temp, 'icOptions' => $icOptions,]);
        } else {
            // Render the initial view with only the model
            return $this->render('analysisMonthlyTraffic/analysisMonthlyTraffic', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action for exporting Monthly Traffic data to Excel
    public function actionAnalysisMonthlyTrafficExcel() {
        // Decode the results and model passed from the POST request
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for Excel export, passing the data
        return $this->render('analysisMonthlyTraffic/analysisMonthlyTrafficExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action for exporting Monthly Traffic data to PDF
    public function actionAnalysisMonthlyTrafficPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF, passing the results and model
        $mpdf->WriteHTML($this->renderPartial('analysisMonthlyTraffic/analysisMonthlyTrafficPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Monthly Traffic Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action for displaying Monthly Revenue analysis data
    public function actionAnalysisMonthlyRevenue() {
        // Create a new model for Monthly Revenue analysis
        $model = new AnalysisMonthlyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Check if the region is set to 'Any'
            if ($model->region == 'Any') {
                // If IC is 'Any', call the stored procedure for Monthly Revenue without specific IC filter
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptMonthlyRevenueDirectionalIcAny('" . $model->year . "')";
                } else {
                    // If IC is specified, call the stored procedure with IC filter
                    $sql_main = "CALL RptMonthlyRevenueDirectionalIc('" . $model->year . "', '" . $model->ic . "')";
                }
            } else {
                // If a specific region is selected, apply the region filter
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptMonthlyRevenueDirectionalRegionIcAny('" . $model->year . "', '" . $model->region . "')";
                } else {
                    // If IC is specified, call the stored procedure with both region and IC filters
                    $sql_main = "CALL RptMonthlyRevenueDirectionalIc('" . $model->year . "', '" . $model->ic . "')";
                }
            }
            
            // Execute the query to fetch the data
            $temp = $db->createCommand($sql_main)->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
            
            // Render the view with the data (results) and model for display
            return $this->render('analysisMonthlyRevenue/analysisMonthlyRevenue', ['model' => $model, 'results' => $temp, 'icOptions' => $icOptions,]);
        } else {
            // If no POST request is made, render the initial view with just the model
            return $this->render('analysisMonthlyRevenue/analysisMonthlyRevenue', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action for exporting Monthly Revenue data to Excel
    public function actionAnalysisMonthlyRevenueExcel() {
        // Decode the results and model passed from the POST request
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for the Excel export, passing the results and model to the view
        return $this->render('analysisMonthlyRevenue/analysisMonthlyRevenueExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action for exporting Monthly Revenue data to PDF
    public function actionAnalysisMonthlyRevenuePdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF, passing the results and model data to it
        $mpdf->WriteHTML($this->renderPartial('analysisMonthlyRevenue/analysisMonthlyRevenuePdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Monthly Revenue Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display and process the Yearly Traffic Analysis
    public function actionAnalysisYearlyTraffic() {
        // Create a new model instance for Yearly Traffic Analysis
        $model = new AnalysisYearlyTraffic;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Determine the SQL query based on ticket type, region, and incident category
            if ($model->ticketType == 'exit') {
                if ($model->region == 'Any') {
                    // If region is 'Any', check if IC is 'Any' or specific
                    if ($model->ic == 'Any') {
                        $sql_main = "CALL RptYearlyTrafficDirectionalExitIcAny('" . $model->year_from . "', '" . $model->year_to . "')";
                    } else {
                        // If IC is specific, include it in the query
                        $sql_main = "CALL RptYearlyTrafficDirectionalExitIc('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->ic . "')";
                    }
                } else {
                    // If region is specific, check if IC is 'Any' or specific
                    if ($model->ic == 'Any') {
                        $sql_main = "CALL RptYearlyTrafficDirectionalExitRegionIcAny('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->region . "')";
                    } else {
                        // If IC is specific, include both region and IC in the query
                        $sql_main = "CALL RptYearlyTrafficDirectionalExitIc('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->ic . "')";
                    }
                }
            } else {
                // Handle the 'entrance' ticket type
                if ($model->region == 'Any') {
                    // If region is 'Any', check if IC is 'Any' or specific
                    if ($model->ic == 'Any') {
                        $sql_main = "CALL RptYearlyTrafficDirectionalEntranceIcAny('" . $model->year_from . "', '" . $model->year_to . "')";
                    } else {
                        // If IC is specific, include it in the query
                        $sql_main = "CALL RptYearlyTrafficDirectionalEntranceIc('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->ic . "')";
                    }
                } else {
                    // If region is specific, check if IC is 'Any' or specific
                    if ($model->ic == 'Any') {
                        $sql_main = "CALL RptYearlyTrafficDirectionalEntranceRegionIcAny('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->region . "')";
                    } else {
                        // If IC is specific, include both region and IC in the query
                        $sql_main = "CALL RptYearlyTrafficDirectionalEntranceIc('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->ic . "')";
                    }
                }
            }
            
            // Execute the query and get the results
            $temp = $db->createCommand($sql_main)->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
            
            // Render the view with the model and the query results
            return $this->render('analysisYearlyTraffic/analysisYearlyTraffic', ['model' => $model, 'results' => $temp, 'icOptions' => $icOptions,]);
        } else {
             // If no form data is submitted, render the view with an empty model
            return $this->render('analysisYearlyTraffic/analysisYearlyTraffic', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action for exporting Yearly Traffic data to Excel
    public function actionAnalysisYearlyTrafficExcel() {
        // Decode the results and model passed from the POST request
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for the Excel export, passing the results and model to the view
        return $this->render('analysisYearlyTraffic/analysisYearlyTrafficExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action for exporting Yearly Traffic data to PDF
    public function actionAnalysisYearlyTrafficPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF, passing the results and model data to it
        $mpdf->WriteHTML($this->renderPartial('analysisYearlyTraffic/analysisYearlyTrafficPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Yearly Traffic Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display and process the Yearly Revenue Analysis
    public function actionAnalysisYearlyRevenue() {
        // Create a new model instance for Yearly Revenue Analysis
        $model = new AnalysisYearlyRevenue;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Determine the SQL query based on selected conditions (region, ic, year_from, year_to)
            if ($model->region == 'Any') {
                // If region is 'Any', check if the IC is 'Any' or specific
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptYearlyRevenueDirectionalIcAny('" . $model->year_from . "', '" . $model->year_to . "')";
                } else {
                    // If IC is specific, include it in the query
                    $sql_main = "CALL RptYearlyRevenueDirectionalIc('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->ic . "')";
                }
            } else {
                // If region is specific, check if IC is 'Any' or specific
                if ($model->ic == 'Any') {
                    $sql_main = "CALL RptYearlyRevenueDirectionalRegionIcAny('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->region . "')";
                } else {
                    // If IC is specific, include both region and IC in the query
                    $sql_main = "CALL RptYearlyRevenueDirectionalIc('" . $model->year_from . "', '" . $model->year_to . "', '" . $model->ic . "')";
                }
            }
            
            // Execute the query and get the results
            $temp = $db->createCommand($sql_main)->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
            
            // Render the view with the model and the query results
            return $this->render('analysisYearlyRevenue/analysisYearlyRevenue', ['model' => $model, 'results' => $temp, 'icOptions' => $icOptions,]);
        } else {
            // If no form data is submitted, render the view with an empty model
            return $this->render('analysisYearlyRevenue/analysisYearlyRevenue', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to export the Yearly Revenue Analysis to Excel
    public function actionAnalysisYearlyRevenueExcel() {
        // Decode the JSON data from the POST request to retrieve the results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel export view with the decoded results and model
        return $this->render('analysisYearlyRevenue/analysisYearlyRevenueExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to export the Yearly Revenue Analysis to PDF
    public function actionAnalysisYearlyRevenuePdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF using a partial view
        $mpdf->WriteHTML($this->renderPartial('analysisYearlyRevenue/analysisYearlyRevenuePdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Yearly Revenue Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display and process the expired ticket report
    public function actionIncidentLostTicket() {
        // Initialize the model for incident lost ticket
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Build the SQL query based on the selected conditions (IC, start_date, end_date)
            if ($model->ic == 'Any') {
                // Call the stored procedure for any IC
                $sql_main = "CALL Rpt_LostTicketAny('" . $model->start_date . "','" . $model->end_date . "')";
                $results = $db->createCommand($sql_main)->queryAll();
            } else {
                // Call the stored procedure for a specific IC
                $sql_main = "CALL Rpt_LostTicketIc('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                $results = $db->createCommand($sql_main)->queryAll();
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Render the view with the model data and query results
            return $this->render('incidentLostTicket/incidentLostTicket', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions,]);
        } else {
            // Render the view with an empty model when no form data is submitted
            return $this->render('incidentLostTicket/incidentLostTicket', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to handle exporting the expired ticket report to Excel
    public function actionIncidentLostTicketExcel() {
        // Decode the JSON data from the POST request to retrieve the results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel export view with the decoded results and model
        return $this->render('incidentLostTicket/incidentLostTicketExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to handle exporting the expired ticket report to PDF
    public function actionIncidentLostTicketPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF using a partial view
        $mpdf->WriteHTML($this->renderPartial('incidentLostTicket/incidentLostTicketPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Lost Ticket Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display and process the expired ticket report
    public function actionIncidentExpiredTicket() {
        // Initialize the model for incident lost ticket
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Build the SQL query based on the selected conditions (IC, start_date, end_date)
            if ($model->ic == 'Any') {
                // Call the stored procedure for any IC
                $sql_main = "CALL Rpt_ExpiredTicketAnyIc('" . $model->start_date . "','" . $model->end_date . "')";
                $results = $db->createCommand($sql_main)->queryAll();
            } else {
                // Call the stored procedure for a specific IC
                $sql_main = "CALL Rpt_ExpiredTicketIc('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                $results = $db->createCommand($sql_main)->queryAll();
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Render the view with the model data and query results
            return $this->render('incidentExpiredTicket/incidentExpiredTicket', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions,]);
        } else {
            // Render the view with an empty model when no form data is submitted
            return $this->render('incidentExpiredTicket/incidentExpiredTicket', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to handle exporting the expired ticket report to Excel
    public function actionIncidentExpiredTicketExcel() {
        // Decode the JSON data from the POST request to retrieve the results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel export view with the decoded results and model
        return $this->render('incidentExpiredTicket/incidentExpiredTicketExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to handle exporting the expired ticket report to PDF
    public function actionIncidentExpiredTicketPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF using a partial view
        $mpdf->WriteHTML($this->renderPartial('incidentExpiredTicket/incidentExpiredTicketPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Expired Ticket Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to handle displaying and processing the book receipt report
    public function actionIncidentBookReceipt() {
        // Initialize the model for incident lost ticket
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Build the SQL query based on the selected conditions (IC, start_date, end_date)
            if ($model->ic == 'Any') {
                // print_r("dd");die;
                // Call the stored procedure for any IC
                $sql_main = "CALL Rpt_BookReceiptTicketAnyIc('" . $model->start_date . "','" . $model->end_date . "')";
                $results = $db->createCommand($sql_main)->queryAll();
            } else {
                // Call the stored procedure for specific IC
                $sql_main = "CALL Rpt_BookReceiptTicketIc('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                $results = $db->createCommand($sql_main)->queryAll();
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Render the view with the model data and query results
            return $this->render('incidentBookReceipt/incidentBookReceipt', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions,]);
        } else {
            // Render the initial view with an empty model when no data is submitted
            return $this->render('incidentBookReceipt/incidentBookReceipt', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to handle exporting the book receipt report as an Excel file
    public function actionIncidentBookReceiptExcel() {
        // Decode the JSON data from the POST request to retrieve results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for Excel export with the decoded results and model
        return $this->render('incidentBookReceipt/incidentBookReceiptExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to handle exporting the book receipt report as a PDF file
    public function actionIncidentBookReceiptPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF using a partial view
        $mpdf->WriteHTML($this->renderPartial('incidentBookReceipt/incidentBookReceiptPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Book Receipt Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to handle displaying and processing the category change report
    public function actionIncidentCategoryChanged() {
        // Initialize the model for incident category change
        $model = new IncidentCategoryChanged;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Build the SQL query based on the selected conditions (IC, teller, start_date, end_date)
            if ($model->ic == 'Any') {
                if ($model->teller == 'Any') {
                    // Call the stored procedure for any IC and any teller
                    $sql_main = "CALL Rpt_CategoryChangedTicketAnyIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                } else {
                    // Call the stored procedure for any IC and specific teller
                    $sql_main = "CALL Rpt_CategoryChangedTicketAnyIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                }
            } else {
                if ($model->teller == 'Any') {
                    // Call the stored procedure for specific IC and any teller
                    $sql_main = "CALL Rpt_CategoryChangedTicketIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                } else {
                    // Call the stored procedure for specific IC and specific teller
                    $sql_main = "CALL Rpt_CategoryChangedTicketIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                }
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Preload teller options for the selected ic
            $tellerOptions = $model->ic === 'Any' ? IcUsers::getTellerListAll() : IcUsers::getTellerList($model->ic);

            // Make sure $tellerOptions is an array
            if (!is_array($tellerOptions)) {
                $tellerOptions = [];
            }

            // Render the view with the model data and query results
            return $this->render('incidentCategoryChanged/incidentCategoryChanged', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions, 'tellerOptions' => $tellerOptions,]);
        } else {
            // Render the initial view with an empty model when no data is submitted
            return $this->render('incidentCategoryChanged/incidentCategoryChanged', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to handle exporting the category change report as an Excel file
    public function actionIncidentCategoryChangedExcel() {
        // Decode the JSON data from the POST request to retrieve results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for Excel export with the decoded results and model
        return $this->render('incidentCategoryChanged/incidentCategoryChangedExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to handle exporting the category change report as a PDF file
    public function actionIncidentCategoryChangedPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF using a partial view
        $mpdf->WriteHTML($this->renderPartial('incidentCategoryChanged/incidentCategoryChangedPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Category Changed Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to handle displaying and processing the reprinted ticket report
    public function actionIncidentReprintTicket() {
        // Initialize the model for incident category change
        $model = new IncidentCategoryChanged;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Build the SQL query based on the selected conditions (IC, teller, start_date, end_date)
            if ($model->ic == 'Any') {
                if ($model->teller == 'Any') {
                    // Call the stored procedure for any IC and any teller
                    $sql_main = "CALL Rpt_RePrintedTicketAnyIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                } else {
                    // Call the stored procedure for any IC and specific teller
                    $sql_main = "CALL Rpt_RePrintedTicketAnyIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                }
            } else {
                if ($model->teller == 'Any') {
                    // Call the stored procedure for specific IC and any teller
                    $sql_main = "CALL Rpt_RePrintedTicketIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                } else {
                    // Call the stored procedure for specific IC and specific teller
                    $sql_main = "CALL Rpt_RePrintedTicketIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                }
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Preload teller options for the selected ic
            $tellerOptions = $model->ic === 'Any' ? IcUsers::getTellerListAll() : IcUsers::getTellerList($model->ic);

            // Make sure $tellerOptions is an array
            if (!is_array($tellerOptions)) {
                $tellerOptions = [];
            }

            // Render the view with the model data and query results
            return $this->render('incidentReprintTicket/incidentReprintTicket', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions, 'tellerOptions' => $tellerOptions,]);
        } else {
            // Render the initial view with an empty model when no data is submitted
            return $this->render('incidentReprintTicket/incidentReprintTicket', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to handle exporting the reprinted ticket report as an Excel file
    public function actionIncidentReprintTicketExcel() {
        // Decode the JSON data from the POST request to retrieve results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for Excel export with the decoded results and model
        return $this->render('incidentReprintTicket/incidentReprintTicketExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to handle exporting the reprinted ticket report as a PDF file
    public function actionIncidentReprintTicketPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF using a partial view
        $mpdf->WriteHTML($this->renderPartial('incidentReprintTicket/incidentReprintTicketPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Reprint Ticket Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to handle displaying and processing the manual ticket report
    public function actionIncidentManualTicket() {
        // Initialize the model for incident category change
        $model = new IncidentCategoryChanged;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Build the SQL query based on the selected conditions
            if ($model->ic == 'Any') {
                if ($model->teller == 'Any') {
                    // Call the stored procedure for any IC and any teller
                    $sql_main = "CALL Rpt_ManualTicketAnyIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                } else {
                    // Call the stored procedure for any IC and specific teller
                    $sql_main = "CALL Rpt_ManualTicketAnyIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                }
            } else {
                if ($model->teller == 'Any') {
                    // Call the stored procedure for specific IC and any teller
                    $sql_main = "CALL Rpt_ManualTicketIcAnyTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                } else {
                    // Call the stored procedure for specific IC and specific teller
                    $sql_main = "CALL Rpt_ManualTicketIcTeller('" . $model->start_date . "','" . $model->end_date . "','" . $model->ic . "','" . $model->teller . "')";
                    $results = $db->createCommand($sql_main)->queryAll();
                }
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Preload teller options for the selected ic
            $tellerOptions = $model->ic === 'Any' ? IcUsers::getTellerListAll() : IcUsers::getTellerList($model->ic);

            // Make sure $tellerOptions is an array
            if (!is_array($tellerOptions)) {
                $tellerOptions = [];
            }

            // Render the view with the model data and query results
            return $this->render('incidentManualTicket/incidentManualTicket', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions, 'tellerOptions' => $tellerOptions,]);
        } else {
            // Render the initial view with an empty model when no data is submitted
            return $this->render('incidentManualTicket/incidentManualTicket', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to handle exporting the manual ticket report as an Excel file
    public function actionIncidentManualTicketExcel() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for Excel export with the decoded results and model
        return $this->render('incidentManualTicket/incidentManualTicketExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to handle exporting the manual ticket report as a PDF file
    public function actionIncidentManualTicketPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF using a partial view
        $mpdf->WriteHTML($this->renderPartial('incidentManualTicket/incidentManualTicketPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Manual Ticket Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to handle missed issued tickets for both entrance and exit types
    public function actionIncidentMissedIssuedTicket() {
        // Instantiate the model for missed issued tickets
        $model = new IncidentMissedIssuedTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Check the ticket type (entrance or exit) to determine the appropriate query
            if ($model->ticket_type == 'entrance') {
                // SQL query for entrance ticket data with conditions on ticket status, date range, and filter criteria
                $sql = "SELECT ET.serial_no,ET.entrance_time,IC.name ic,B.name booth,V.name vc,U.username
                    FROM rpt_mississued_ticket_summary_entrance ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.ticket_type_status_id = 12";

                // Apply additional filters based on the `ic` and `teller` fields
                if ($model->ic == 'Any') {
                    // If no specific IC is chosen, filter by teller if provided
                    if ($model->teller == 'Any') {
                        // No additional filter applied
                    } else {
                        $sql .= " AND ET.teller_id = $model->teller"; // Filter by teller
                    }
                } else {
                    // If a specific IC is chosen, filter by both IC and teller (if provided)
                    if ($model->teller == 'Any') {
                        $sql .= " AND ET.entrance_ic = $model->ic"; // Filter by IC
                    } else {
                        $sql .= " AND ET.entrance_ic = $model->ic AND ET.teller_id = $model->teller"; // Filter by both IC and teller
                    }
                }
            } else {
                // SQL query for exit ticket data with conditions on ticket status, date range, and filter criteria
                $sql = "SELECT ET.entrance_serial as serial_no,ET.entrance_time,ET.exit_serial,ET.exit_time,IC.name ic,B.name booth,ET.amount,V.name vc,U.username
                    FROM rpt_mississued_ticket_summary_exit ET
                    INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    LEFT JOIN tbl_vehicle_category V ON V.id = ET.vehicle_category
                    WHERE ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 12";

                // Apply additional filters based on the `ic` and `teller` fields    
                if ($model->ic == 'Any') {
                    // If no specific IC is chosen, filter by teller if provided
                    if ($model->teller == 'Any') {
                        // No additional filter applied
                    } else {
                        $sql .= " AND ET.teller_id = $model->teller"; // Filter by teller
                    }
                } else {
                     // If a specific IC is chosen, filter by both IC and teller (if provided)
                    if ($model->teller == 'Any') {
                        $sql .= " AND ET.exit_ic = $model->ic"; // Filter by IC
                    } else {
                        $sql .= " AND ET.exit_ic = $model->ic AND ET.teller_id = $model->teller"; // Filter by both IC and teller
                    }
                }
            }

            // Execute the SQL query and get the results from the database
            $results = $db->createCommand($sql)->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Preload teller options for the selected ic
            $tellerOptions = $model->ic === 'Any' ? IcUsers::getTellerListAll() : IcUsers::getTellerList($model->ic);

            // Make sure $tellerOptions is an array
            if (!is_array($tellerOptions)) {
                $tellerOptions = [];
            }

            // Render the view with the model and results
            return $this->render('incidentMissedIssuedTicket/incidentMissedIssuedTicket', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions, 'tellerOptions' => $tellerOptions,]);
        } else {
            // If there is no POST data, simply render the view with an empty model
            return $this->render('incidentMissedIssuedTicket/incidentMissedIssuedTicket', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to handle generating the Excel file for missed issued tickets
    public function actionIncidentMissedIssuedTicketExcel() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for generating the Excel file, passing the decoded results and model
        return $this->render('incidentMissedIssuedTicket/incidentMissedIssuedTicketExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to handle generating the PDF file for missed issued tickets
    public function actionIncidentMissedIssuedTicketPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF using a partial view
        $mpdf->WriteHTML($this->renderPartial('incidentMissedIssuedTicket/incidentMissedIssuedTicketPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Missed Issued Ticket Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to handle blacklisted card incidents
    public function actionIncidentBlacklistedCard() {
        // Create an instance of the IncidentLostTicket model
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Check if the start date falls before the backup threshold
            if ($model->start_date < self::BACKUP_DATE) {
                if ($model->ic == 'Any') {
                    // Fetch results for all ICs before the backup date
                    $results = $db->createCommand("SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,ET.entrance_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                    FROM tbl_entrance_ticket_ar ET
                    INNER JOIN tbl_nfc_card N ON N.uid = ET.uid AND N.status = 0
                    INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    INNER JOIN tbl_devices D ON D.id = ET.device_id
                    INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                    WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.uid IS NOT NULL
    
                    UNION
    
                    SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,Ex.exit_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                    FROM tbl_exit_ticket_ar Ex
                    INNER JOIN tbl_nfc_card N ON N.uid = Ex.uid AND N.status = 0
                    INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                    INNER JOIN tbl_booth B ON B.id = Ex.booth_id
                    INNER JOIN user U ON U.id = Ex.teller_id
                    INNER JOIN tbl_devices D ON D.id = Ex.device_id
                    INNER JOIN tbl_ic IC ON IC.id = Ex.exit_ic
                    WHERE Ex.exit_time >= '$model->start_date' AND Ex.exit_time <= '$model->end_date' AND Ex.uid IS NOT NULL")->queryAll();
                } else {
                    // Fetch results for a specific IC before the backup date
                    $results = $db->createCommand("SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,ET.entrance_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                    FROM tbl_entrance_ticket_ar ET
                    INNER JOIN tbl_nfc_card N ON N.uid = ET.uid AND N.status = 0
                    INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    INNER JOIN tbl_devices D ON D.id = ET.device_id
                    INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                    WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.uid IS NOT NULL AND ET.entrance_ic =  $model->ic
    
                    UNION
    
                    SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,Ex.exit_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                    FROM tbl_exit_ticket_ar Ex
                    INNER JOIN tbl_nfc_card N ON N.uid = Ex.uid AND N.status = 0
                    INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                    INNER JOIN tbl_booth B ON B.id = Ex.booth_id
                    INNER JOIN user U ON U.id = Ex.teller_id
                    INNER JOIN tbl_devices D ON D.id = Ex.device_id
                    INNER JOIN tbl_ic IC ON IC.id = Ex.exit_ic
                    WHERE Ex.exit_time >= '$model->start_date' AND Ex.exit_time <= '$model->end_date' AND Ex.uid IS NOT NULL AND Ex.exit_ic =  $model->ic")->queryAll();
                }
                //end backup
            }else{
                // Handle queries for data after the backup date
                if ($model->ic == 'Any') {
                    // Fetch results for all ICs after the backup date
                    $results = $db->createCommand("SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,ET.entrance_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_nfc_card N ON N.uid = ET.uid AND N.status = 0
                    INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    INNER JOIN tbl_devices D ON D.id = ET.device_id
                    INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                    WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.uid IS NOT NULL
    
                    UNION
    
                    SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,Ex.exit_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                    FROM tbl_exit_ticket Ex
                    INNER JOIN tbl_nfc_card N ON N.uid = Ex.uid AND N.status = 0
                    INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                    INNER JOIN tbl_booth B ON B.id = Ex.booth_id
                    INNER JOIN user U ON U.id = Ex.teller_id
                    INNER JOIN tbl_devices D ON D.id = Ex.device_id
                    INNER JOIN tbl_ic IC ON IC.id = Ex.exit_ic
                    WHERE Ex.exit_time >= '$model->start_date' AND Ex.exit_time <= '$model->end_date' AND Ex.uid IS NOT NULL")->queryAll();
                } else {
                    // Fetch results for a specific IC after the backup date
                    $results = $db->createCommand("SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,ET.entrance_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                    FROM tbl_entrance_ticket ET
                    INNER JOIN tbl_nfc_card N ON N.uid = ET.uid AND N.status = 0
                    INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                    INNER JOIN tbl_booth B ON B.id = ET.booth_id
                    INNER JOIN user U ON U.id = ET.teller_id
                    INNER JOIN tbl_devices D ON D.id = ET.device_id
                    INNER JOIN tbl_ic IC ON IC.id = ET.entrance_ic
                    WHERE ET.entrance_time >= '$model->start_date' AND ET.entrance_time <= '$model->end_date' AND ET.uid IS NOT NULL AND ET.entrance_ic =  $model->ic
    
                    UNION
    
                    SELECT N.serial,NA.vehicle_no,N.uid,IC.name as ic,Ex.exit_time as detected_time,B.name as booth,U.username as teller,D.name as pos
                    FROM tbl_exit_ticket Ex
                    INNER JOIN tbl_nfc_card N ON N.uid = Ex.uid AND N.status = 0
                    INNER JOIN tbl_nfc_allocation NA ON NA.nfc_card_id = N.id
                    INNER JOIN tbl_booth B ON B.id = Ex.booth_id
                    INNER JOIN user U ON U.id = Ex.teller_id
                    INNER JOIN tbl_devices D ON D.id = Ex.device_id
                    INNER JOIN tbl_ic IC ON IC.id = Ex.exit_ic
                    WHERE Ex.exit_time >= '$model->start_date' AND Ex.exit_time <= '$model->end_date' AND Ex.uid IS NOT NULL AND Ex.exit_ic =  $model->ic")->queryAll();
                }
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Render the view with the model and results
            return $this->render('incidentBlacklistedCard/incidentBlacklistedCard', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions,]);
        } else {
            // Render the view with just the model if no POST data is provided
            return $this->render('incidentBlacklistedCard/incidentBlacklistedCard', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to generate an Excel report for blacklisted card incidents
    public function actionIncidentBlacklistedCardExcel() {
        // Decode the results and model from the POST data received
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the view for generating the Excel report, passing the results and model
        return $this->render('incidentBlacklistedCard/incidentBlacklistedCardExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to generate a PDF report for blacklisted card incidents
    public function actionIncidentBlacklistedCardPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF from the partial view, passing the results and model
        $mpdf->WriteHTML($this->renderPartial('incidentBlacklistedCard/incidentBlacklistedCardPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Blacklisted Card Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display or process the Incident Incomplete Ticket report
    public function actionIncidentIncompleteTicket() {
        // Initialize the model for the incident of missed issued tickets
        $model = new IncidentMissedIssuedTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Check if the start date is before the backup date
            if ($model->start_date < self::BACKUP_DATE) {

                if ($model->ticket_type == 'entrance') {
                    // Check if IC filter is set to 'Any'
                    if ($model->ic == 'Any') {
                        // Check if Teller filter is set to 'Any'
                        if ($model->teller == 'Any') {
                            // Fetch all entrance tickets within the specified date range that do not have a corresponding exit ticket
                            $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                            FROM tbl_entrance_ticket_ar EN1
                            INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            INNER JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket_ar EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                            FROM tbl_entrance_ticket_ar EN
                            WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date'))")->queryAll();
                        } else {
                            // Fetch entrance tickets for a specific teller within the date range that do not have corresponding exit tickets
                            $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                            FROM tbl_entrance_ticket_ar EN1
                            INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            INNER JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.teller_id = $model->teller AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket_ar EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                            FROM tbl_entrance_ticket_ar EN
                            WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.teller_id = $model->teller))")->queryAll();
                        }
                    } else {
                        // Check if Teller filter is set to 'Any'
                        if ($model->teller == 'Any') {
                            // Fetch entrance tickets for a specific IC within the date range that do not have corresponding exit tickets
                            $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                            FROM tbl_entrance_ticket_ar EN1
                            INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            INNER JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket_ar EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                            FROM tbl_entrance_ticket_ar EN
                            WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic))")->queryAll();
                        } else {
                            // Fetch entrance tickets for a specific IC and teller within the date range that do not have corresponding exit tickets
                            $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                            FROM tbl_entrance_ticket_ar EN1
                            INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            INNER JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.teller_id = $model->teller AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket_ar EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                            FROM tbl_entrance_ticket_ar EN
                            WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.teller_id = $model->teller))")->queryAll();
                        }
                    }
                } else {
                    // Handle case for 'exit' tickets
                    if ($model->ic == 'Any') {
                        if ($model->teller == 'Any') {
                            // Fetch all exit tickets within the date range with ticket type status 3
                            $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                                FROM  tbl_exit_ticket_ar ET
                                LEFT JOIN tbl_entrance_ticket_ar EN1 ON EN1.serial_no = ET.entrance_barcode
                                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                INNER JOIN user U ON U.id = ET.teller_id
                                WHERE EN1.serial_no IS NULL AND ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'")->queryAll();
                        } else {
                            // Fetch exit tickets for a specific teller within the date range with ticket type status 3
                            $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                                FROM  tbl_exit_ticket_ar ET
                                LEFT JOIN tbl_entrance_ticket_ar EN1 ON EN1.serial_no = ET.entrance_barcode
                                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                INNER JOIN user U ON U.id = ET.teller_id
                                WHERE EN1.serial_no IS NULL AND ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.teller_id = $model->teller AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'")->queryAll();
                        }
                    } else {
                        if ($model->teller == 'Any') {
                            // Fetch exit tickets for a specific IC within the date range with ticket type status 3
                            $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                                FROM  tbl_exit_ticket_ar ET
                                LEFT JOIN tbl_entrance_ticket_ar EN1 ON EN1.serial_no = ET.entrance_barcode
                                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                INNER JOIN user U ON U.id = ET.teller_id
                                WHERE EN1.serial_no IS NULL AND ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.exit_ic = $model->ic AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'")->queryAll();
                        } else {
                             // Fetch exit tickets for a specific IC and teller within the date range with ticket type status 3
                            $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                                FROM  tbl_exit_ticket_ar ET
                                LEFT JOIN tbl_entrance_ticket_ar EN1 ON EN1.serial_no = ET.entrance_barcode
                                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                INNER JOIN user U ON U.id = ET.teller_id
                                WHERE EN1.serial_no IS NULL AND ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'")->queryAll();
                        }
                    }
                }
                //end backup
            } else {
                //Fetch data from the active table
                if ($model->ticket_type == 'entrance') {
                    if ($model->ic == 'Any') {
                        if ($model->teller == 'Any') {
                            $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                            FROM tbl_entrance_ticket EN1
                            INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            INNER JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                            FROM tbl_entrance_ticket EN
                            WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date'))")->queryAll();
                        } else {
                            $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                            FROM tbl_entrance_ticket EN1
                            INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            INNER JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.teller_id = $model->teller AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                            FROM tbl_entrance_ticket EN
                            WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.teller_id = $model->teller))")->queryAll();
                        }
                    } else {
                        if ($model->teller == 'Any') {
                            $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                            FROM tbl_entrance_ticket EN1
                            INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            INNER JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                            FROM tbl_entrance_ticket EN
                            WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic))")->queryAll();
                        } else {
                            $results = $db->createCommand("SELECT EN1.serial_no as entrance_serial,EN1.entrance_time,IC.name as ic,B.name as booth,VC.name as vc,U.username as teller
                            FROM tbl_entrance_ticket EN1
                            INNER JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            INNER JOIN tbl_booth B ON B.id = EN1.booth_id
                            INNER JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            INNER JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= '$model->start_date' AND EN1.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.teller_id = $model->teller AND EN1.serial_no NOT IN (SELECT EX.entrance_barcode FROM tbl_exit_ticket EX WHERE EX.entrance_barcode IN (SELECT EN.serial_no
                            FROM tbl_entrance_ticket EN
                            WHERE EN.entrance_time >= '$model->start_date' AND EN.entrance_time <= '$model->end_date' AND EN1.entrance_ic = $model->ic AND EN1.teller_id = $model->teller))")->queryAll();
                        }
                    }
                } else {
                    if ($model->ic == 'Any') {
                        if ($model->teller == 'Any') {
                            $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                                FROM  tbl_exit_ticket ET
                                LEFT JOIN tbl_entrance_ticket EN1 ON EN1.serial_no = ET.entrance_barcode
                                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                INNER JOIN user U ON U.id = ET.teller_id
                                WHERE EN1.serial_no IS NULL AND ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'")->queryAll();
                        } else {
                            $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                                FROM  tbl_exit_ticket ET
                                LEFT JOIN tbl_entrance_ticket EN1 ON EN1.serial_no = ET.entrance_barcode
                                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                INNER JOIN user U ON U.id = ET.teller_id
                                WHERE EN1.serial_no IS NULL AND ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.teller_id = $model->teller AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'")->queryAll();
                        }
                    } else {
                        if ($model->teller == 'Any') {
                            $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                                FROM  tbl_exit_ticket ET
                                LEFT JOIN tbl_entrance_ticket EN1 ON EN1.serial_no = ET.entrance_barcode
                                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                INNER JOIN user U ON U.id = ET.teller_id
                                WHERE EN1.serial_no IS NULL AND ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.exit_ic = $model->ic AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'")->queryAll();
                        } else {
                            $results = $db->createCommand("SELECT ET.entrance_serial,ET.entrance_time,ET.exit_serial,ET.exit_time,ET.amount,IC.name ic,B.name booth,VC.name as vc,U.username as teller
                                FROM  tbl_exit_ticket ET
                                LEFT JOIN tbl_entrance_ticket EN1 ON EN1.serial_no = ET.entrance_barcode
                                INNER JOIN tbl_ic IC ON IC.id = ET.exit_ic
                                INNER JOIN tbl_booth B ON B.id = ET.booth_id
                                INNER JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                                INNER JOIN user U ON U.id = ET.teller_id
                                WHERE EN1.serial_no IS NULL AND ET.exit_time >= '$model->start_date' AND ET.exit_time <= '$model->end_date' AND ET.exit_ic = $model->ic AND ET.teller_id = $model->teller AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'")->queryAll();
                        }
                    }
                }
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Preload teller options for the selected ic
            $tellerOptions = $model->ic === 'Any' ? IcUsers::getTellerListAll() : IcUsers::getTellerList($model->ic);

            // Make sure $tellerOptions is an array
            if (!is_array($tellerOptions)) {
                $tellerOptions = [];
            }

            // Render the incomplete ticket report view with the results and model
            return $this->render('incidentIncompleteTicket/incidentIncompleteTicket', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions, 'tellerOptions' => $tellerOptions,]);
        } else {
            // Render the initial form for incomplete ticket input
            return $this->render('incidentIncompleteTicket/incidentIncompleteTicket', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to generate an Excel report for Incident Incomplete Tickets
    public function actionIncidentIncompleteTicketExcel() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel view for Incident Incomplete Ticket report
        return $this->render('incidentIncompleteTicket/incidentIncompleteTicketExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to generate a PDF report for Incident Incomplete Tickets
    public function actionIncidentIncompleteTicketPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF content
        $mpdf->WriteHTML($this->renderPartial('incidentIncompleteTicket/incidentIncompleteTicketPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Incomplete Ticket Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to display the Incident Escape Ticket report
    public function actionIncidentEscapeTicket() {

        // Initialize the model for incident lost ticket
        $model = new IncidentLostTicket;
        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Check if the "ic" field is set to "Any"
            if ($model->ic == 'Any') {
                // Query to retrieve all escape ticket incidents within the date range
                $results = $db->createCommand("SELECT E.entrance_serial,E.entrance_time,E.exit_serial,E.exit_time,VC.name vc,B.name booth,E.amount,U.username teller,IC.name ic
                    FROM rpt_escape_ticket_summary E
                    LEFT JOIN tbl_vehicle_category VC ON VC.id = E.vehicle_category
                    LEFT JOIN tbl_booth B ON B.id = E.booth_id
                    LEFT JOIN user U ON U.id = E.teller_id
                    LEFT JOIN tbl_ic IC ON IC.id = E.exit_ic
                    WHERE E.exit_time >= '$model->start_date' AND E.exit_time <= '$model->end_date'")->queryAll();
            } else {
                // Query to retrieve escape ticket incidents for a specific IC within the date range
                $results = $db->createCommand("SELECT E.entrance_serial,E.entrance_time,E.exit_serial,E.exit_time,VC.name vc,B.name booth,E.amount,U.username teller,IC.name ic
                    FROM rpt_escape_ticket_summary E
                    LEFT JOIN tbl_vehicle_category VC ON VC.id = E.vehicle_category
                    LEFT JOIN tbl_booth B ON B.id = E.booth_id
                    LEFT JOIN user U ON U.id = E.teller_id
                    LEFT JOIN tbl_ic IC ON IC.id = E.exit_ic
                    WHERE E.exit_time >= '$model->start_date' AND E.exit_time <= '$model->end_date' AND E.exit_ic = $model->ic")->queryAll();
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Render the incident escape ticket view with the results and model
            return $this->render('incidentEscapeTicket/incidentEscapeTicket', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions,]);
        } else {
            // Render the initial form for incident escape ticket input
            return $this->render('incidentEscapeTicket/incidentEscapeTicket', ['model' => $model, 'icOptions' => [],]);
        }
    }

    // Action to generate and export the Incident Escape Ticket report as an Excel file
    public function actionIncidentEscapeTicketExcel() {

        // Decode the JSON-encoded POST data for results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel view with the results and model
        return $this->render('incidentEscapeTicket/incidentEscapeTicketExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to generate and export the Incident Escape Ticket report as a PDF file
    public function actionIncidentEscapeTicketPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Write the HTML content to the PDF by rendering the PDF view
        $mpdf->WriteHTML($this->renderPartial('incidentEscapeTicket/incidentEscapeTicketPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Escape Ticket Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // Action to generate and display the Yearly Report
    public function actionYearlyReport() {

        // Initialize a new model instance for year report statistics
        $model = new YearReportStats();

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            // Query to retrieve the yearly report statistics from the database
            $results = $db->createCommand("SELECT t.name as tname,  d.name  as dname,  yr.vehicle_category as ca , SUM(yr.count) as count
            FROM tbl_year_report_stats yr
            INNER JOIN tbl_route ic on yr.source= ic.source and yr.destination = ic.destination
            inner join tbl_ic t on yr.source= t.id
            inner join tbl_ic d on yr.destination= d.id
            WHERE year ='$model->year'
            GROUP by yr.vehicle_category , t.name, d.name")->queryAll();

            // Organize the results into a structured format
            foreach ($results as $result) {
                $temp[$result['tname'] . '-' . $result['dname']][$result['ca']] = $result['count'];

                $temp[$result['tname'] . '-' . $result['dname']]['name'] = $result['tname'];
                $temp[$result['tname'] . '-' . $result['dname']]['kname'] = $result['dname'];
                ++$i;
            }
            // Render the yearly report view with the model and organized results
            return $this->render('analysisYearlyReport/yearlyReport', ['model' => $model, 'results' => $temp, 'months' => $months]);
        } else {
            // Render the form for yearly report input
            return $this->render('analysisYearlyReport/yearlyReport', ['model' => $model]);
        }
    }

    // Action to generate and export the Yearly Report as an Excel file
    public function actionAnalysisYearReportExcel() {

        // Decode the JSON-encoded POST data for results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel view with the results and model
        return $this->render('analysisYearlyReport/analysisYearReportExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    // Action to generate and export the Yearly Report as a PDF file
    public function actionAnalysisYearReportPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Write the HTML content to the PDF by rendering the PDF view
        $mpdf->WriteHTML($this->renderPartial('analysisYearlyReport/analysisYearReportPDF', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Yearly  Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    // ADT REPORT: This function generates the Average Daily Traffic (ADT) report
    public function actionAverageDailyTrafficReport() {

        $db = new yii\db\Connection(Yii::$app->db);
        $model = new YearReportStats();

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            // Disable the 'ONLY_FULL_GROUP_BY' SQL mode to allow queries with GROUP BY without an explicit aggregate function
            // This can be useful if you're performing queries that group data without all columns in the SELECT being aggregated
            $ff = $db->createCommand("SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')) ")->execute();

            // Define the months for the report (1 to 12)
            $months = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];

            // Fetch a list of IC (interchange) records, ordering them by a custom field order
            // The custom order is specified by the FIELD function, where the values represent specific IC IDs in a desired order
            $ics = Ic::find()->orderBy([new \yii\db\Expression('FIELD(id,27,26,28,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,30,31,21,29,22,23,24,25)')])->all();

            // Render the report view and pass the model, IC results, and months to it for display
            return $this->render('averageDailyTrafficReport/averageDailyTrafficReport', [
                        'model' => $model,
                        'results' => $ics,
                        'months' => $months,
            ]);
        } else {
            // If the request is not a POST, render the report page with just the model (empty form)
            return $this->render('averageDailyTrafficReport/averageDailyTrafficReport', ['model' => $model]);
        }
    }

    // Action to generate Average Daily Traffic (ADT) report in Excel format
    public function actionAverageDailyTrafficReportExcel() {
        //   print_r("rrr");
        //  die;
        // Decode the POST data for results, model, months, and routes from JSON format
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        // Increase PCRE backtrack limit to avoid errors in complex regex operations
        ini_set("pcre.backtrack_limit", "5000000");
        $db = new yii\db\Connection(Yii::$app->db);

        // Execute the stored procedure 'Rpt_ADT_2024' to get the ADT data based on year and month
        $sql_main = "CALL Rpt_ADT_2024('" . $model['year'] . "','" . $model['month'] . "')";
        $results = $db->createCommand($sql_main)->queryAll();

        // Render the Excel view and pass the results, model, months, and routes to it
        return $this->render('averageDailyTrafficReport/averageDailyTrafficReportExcel', [
                    'results' => $results,
                    'model' => $model,
                    'months' => $months,
                    'routes' => $routes,
        ]);
    }
    
   public function actionAverageDailyTrafficReportExcelNew() {

        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        ini_set("pcre.backtrack_limit", "5000000");


        return $this->render('averageDailyTrafficReport/averageDailyTrafficReportExcelNew2', [
                    'model' => $model,
                    'months' => $months,
                    'routes' => $routes,
        ]);
    }

    // Action to generate Average Daily Traffic (ADT) report in PDF format
    public function actionAverageDailyTrafficReportPdf() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        ini_set("pcre.backtrack_limit", "5000000");
        $db = new yii\db\Connection(Yii::$app->db);

        // Execute the stored procedure 'Rpt_ADT_2024' to get the ADT data based on year and month
        $sql_main = "CALL Rpt_ADT_2024('" . $model['year'] . "','" . $model['month'] . "')";
        $results = $db->createCommand($sql_main)->queryAll();

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Write the HTML content to the PDF. The content is rendered from the 'averageDailyTrafficReportPDF' view.
        $mpdf->WriteHTML($this->renderPartial('averageDailyTrafficReport/averageDailyTrafficReportPDF', [
                    'results' => $results,
                    'model' => $model,
                    'months' => $months,
                    'routes' => $routes,
        ]));
        $mpdf->Output('ADT ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    public function actionAnalysisSessionCash() {

        // Create a new instance of the AnalysisDailyRevenue model
        $model = new AnalysisDailyRevenue;
        // Set the default value of 'ic' to 'Any'
        $model->ic = 'Any';
        $db = new yii\db\Connection(Yii::$app->db);

        // Check if the request is a POST request
        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Check if the 'ic' is set to 'Any', if so, fetch all session cash data
            if ($model->ic == 'Any') {
                // print_r('dd');die;
                // Call the stored procedure 'Rpt_Session_cash' with the specified year and month
                $sql_main = "CALL Rpt_Session_cash('" . $model->year . "', '" . $model->month . "')";
                $temp = $db->createCommand($sql_main)->queryAll();
            }
            // Render the 'analysisSessionCash' view, passing the model and query results to the view
            return $this->render('analysisSessionCash/analysisSessionCash', ['model' => $model, 'results' => $temp]);
        } else {
            // If the request is not POST, render the form without any results
            return $this->render('analysisSessionCash/analysisSessionCash', ['model' => $model]);
        }
    }

    public function actionAnalysisSessionCashExcel() {

        // Decode the results and model from the POST data (usually JSON encoded)
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the 'analysisSessionCashExcel' view, passing the results and model to the view
        return $this->render('analysisSessionCash/analysisSessionCashExcel', [
                    'results' => $results,
                    'model' => $model,
        ]);
    }

    public function actionAnalysisSessionCashPdf() {

        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');

        // Render the HTML content of the 'analysisSessionCashPdf' view and pass the results and model data to it
        // The renderPartial method is used to include the view content inside the PDF
        $mpdf->WriteHTML($this->renderPartial('analysisSessionCash/analysisSessionCashPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));

        // Output the generated PDF with a dynamically generated filename that includes the current date and time
        // The 'D' option triggers the download of the file
        $mpdf->Output('Session Cash ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

// ADT2
    public function actionAverageDailyTrafficReport2() {

        ini_set("max_execution_time", 0);
        ini_set("post_max_size", '1500M');
        ini_set("set_time_limit", 0);
        ini_set("default_socket_timeout", 0);

        $model = new YearReportStatsADT();

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            /*  $ff = $db->createCommand("SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')) ")->execute();
              $results = $db->createCommand("SELECT t.name as tname,t.id as tid,  d.name  as dname,d.id as did,yr.year,yr.month, SUM(yr.count) as count
              FROM tbl_year_report_stats yr
              INNER JOIN tbl_route ic on yr.source= ic.source and yr.destination = ic.destination
              inner join tbl_ic t on yr.source= t.id
              inner join tbl_ic d on yr.destination= d.id
              WHERE year ='$model->year'
              GROUP by  yr.month,t.name, d.name
              ORDER BY `yr`.`month`")->queryAll(); */

            if ($model->source == '%' && $model->destination == '%' && $model->vehicle_category == '%') {
                //  print_r('fd1');die;
                $sql_main = "CALL Rpt_ADT2_All_Ic('" . $model->year . "')";
                $results = $db->createCommand($sql_main)->queryAll();
                //$routes = Route::find()->all();
            } elseif ($model->source == '%' && $model->destination == '%' && $model->vehicle_category != '%') {
                //  print_r('fd2');die;
                $sql_main = "CALL Rpt_ADT2_Cat('" . $model->year . "','" . $model->vehicle_category . "')";
                $results = $db->createCommand($sql_main)->queryAll();
                // $routes = Route::find()->all();
            } elseif ($model->source !== '%' && $model->destination !== '%' && $model->vehicle_category == '%') {

                // print_r('combination3');die;
                $sql_main = "CALL Rpt_ADT2_from_to_all('" . $model->year . "','" . $model->source . "','" . $model->destination . "')";
                $results = $db->createCommand($sql_main)->queryAll();
                // $routes = Route::find()->all();
            } else {
                // print_r('fd3');die;
                $sql_main = "CALL Rpt_ADT2('" . $model->year . "','" . $model->vehicle_category . "','" . $model->source . "','" . $model->destination . "')";
                $results = $db->createCommand($sql_main)->queryAll();

                //   $sql_main_routes = "CALL Rpt_ADT2_routes('" . $model->source . "','" . $model->destination . "')";
                //  $routes   = $db->createCommand($sql_main_routes)->queryAll();
            }





            $months = $db->createCommand("SELECT yr.year,yr.month FROM tbl_year_report_stats yr WHERE year ='$model->year' GROUP by yr.year,yr.month ORDER BY `yr`.`month`
                                            ")->queryAll();

            //   $routes = Route::find()->all();

            return $this->render('averageDailyTrafficReport2/averageDailyTrafficReport', [
                        'model' => $model,
                        'results' => $results,
                        'months' => $months,
                        'routes' => $routes
            ]);
        } else {
            //$categorie = $db->createCommand("SELECT id ,name FROM tbl_vehicle_category")->queryAll();
            return $this->render('averageDailyTrafficReport2/averageDailyTrafficReport', ['model' => $model]);
        }
    }

    public function actionAverageDailyTrafficReportExcel2() {
        //  print_r("rrr");
        //  die;
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        return $this->render('averageDailyTrafficReport2/averageDailyTrafficReportExcel', [
                    'results' => $results,
                    'model' => $model,
                    'months' => $months,
                    'routes' => $routes,
        ]);
    }

    public function actionAverageDailyTrafficReportPdf2() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('averageDailyTrafficReport2/averageDailyTrafficReportPDF', [
                    'results' => $results,
                    'model' => $model,
                    'months' => $months,
                    'routes' => $routes,
        ]));
        $mpdf->Output('Yearly  Report ' . $model->year . '-' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

//ADT 3

    public function actionAverageDailyTrafficReport3() {

        $model = new YearReportStats();

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            $ff = $db->createCommand("SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')) ")->execute();
            $results = $db->createCommand("SELECT
            t.name as tname,
            t.id as tid,
            d.name  as dname,
            d.id as did,yr.year,
            yr.month,
            yr.vehicle_category,
            IFNULL(SUM(case when v.id = 1 THEN count END),0) cat1,
            IFNULL(SUM(case when v.id = 2 THEN count END),0) cat2,
            IFNULL(SUM(case when v.id = 3 THEN count END),0) cat3,
            IFNULL(SUM(case when v.id = 4 THEN count END),0) cat4,
            IFNULL(SUM(case when v.id = 20 THEN count END),0) s,
            IFNULL(SUM(case when v.id = 21 THEN count END),0) ps,
            IFNULL(SUM(case when v.id = 22 THEN count END),0) pms,
            IFNULL(SUM(case when v.id = 30 THEN count END),0) CatAmbulance,
            IFNULL(SUM(case when v.id = 99 THEN count END),0) CatNotAssigned

            FROM tbl_year_report_stats yr
            INNER JOIN tbl_route ic on yr.source= ic.source and yr.destination = ic.destination
            inner join tbl_ic t on yr.source= t.id
            inner join tbl_ic d on yr.destination= d.id
            inner join tbl_vehicle_category v ON yr.vehicle_category =  v.id

            WHERE year ='$model->year' AND month = '$model->month'
            GROUP by  yr.month,t.name, d.name
            ORDER BY `yr`.`month`")->queryAll();

            // $months = $db->createCommand("SELECT yr.year,yr.month FROM tbl_year_report_stats yr WHERE year ='$model->year' GROUP by yr.year,yr.month ORDER BY `yr`.`month`")->queryAll();
            //  $categorie = $db->createCommand("SELECT id as vehicle_category,name FROM tbl_vehicle_category")->queryAll();
            //  $routes = Route::find()->all();
            // $routes =  $db->createCommand("SELECT t.name as tname, t.id as source, d.name as dname, d.id as destination FROM tbl_year_report_stats yr inner join tbl_ic t on yr.source= t.id inner join tbl_ic d on yr.destination= d.id WHERE year ='2020' GROUP by t.name, d.name ORDER BY `yr`.`month`")->queryAll();

            return $this->render('averageDailyTrafficReport3/averageDailyTrafficReport', [
                        'model' => $model,
                        'results' => $results,
                        'months' => $months,
                        'routes' => $routes,
                        'categorie' => $categorie,
            ]);
        } else {
            return $this->render('averageDailyTrafficReport3/averageDailyTrafficReport', ['model' => $model]);
        }
    }

    public function actionAverageDailyTrafficReport3OLD() {

        $model = new YearReportStats();

        $db = new yii\db\Connection(Yii::$app->db);

        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());
            $i = 0;
            $results = [];

            $ff = $db->createCommand("SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')) ")->execute();
            $results = $db->createCommand("SELECT t.name as tname,t.id as tid,  d.name  as dname,d.id as did,yr.year,yr.month,yr.vehicle_category, SUM(yr.count) as count
        FROM tbl_year_report_stats yr
        INNER JOIN tbl_route ic on yr.source= ic.source and yr.destination = ic.destination
        inner join tbl_ic t on yr.source= t.id
        inner join tbl_ic d on yr.destination= d.id
        WHERE year ='$model->year'
        GROUP by  yr.month,yr.vehicle_category,t.name, d.name
ORDER BY `yr`.`month`")->queryAll();

            $months = $db->createCommand("SELECT yr.year,yr.month FROM tbl_year_report_stats yr WHERE year ='$model->year' GROUP by yr.year,yr.month ORDER BY `yr`.`month`
")->queryAll();

            $categorie = $db->createCommand("SELECT id as vehicle_category,name FROM tbl_vehicle_category

")->queryAll();

// $categorie = $db->createCommand("SELECT yr.vehicle_category,v.name FROM tbl_year_report_stats yr inner join tbl_vehicle_category v
            // on yr.vehicle_category= v.id
            // WHERE year ='$model->year' GROUP by yr.vehicle_category ORDER BY yr.vehicle_category
            // ")->queryAll();

            $routes = Route::find()->all();

            return $this->render('averageDailyTrafficReport3/averageDailyTrafficReport', [
                        'model' => $model,
                        'results' => $results,
                        'months' => $months,
                        'routes' => $routes,
                        'categorie' => $categorie,
            ]);
        } else {
            return $this->render('averageDailyTrafficReport3/averageDailyTrafficReport', ['model' => $model]);
        }
    }

    public function actionAverageDailyTrafficReportExcel3() {

        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);
        $categorie = json::decode($_POST['categorie']);

        return $this->render('averageDailyTrafficReport3/averageDailyTrafficReportExcel', [
                    'results' => $results,
                    'model' => $model,
                    'months' => $months,
                    'routes' => $routes,
                    'categorie' => $categorie,
        ]);
    }

    public function actionAverageDailyTrafficReportPdf3() {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);
        $months = json::decode($_POST['months']);
        $routes = json::decode($_POST['routes']);
        $categorie = json::decode($_POST['categorie']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('averageDailyTrafficReport3/averageDailyTrafficReportPDF', [
                    'results' => $results,
                    'model' => $model,
                    'months' => $months,
                    'routes' => $routes,
                    'categorie' => $categorie,
        ]));
        $mpdf->Output('Yearly  Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    public function actionTowingCharge() {
        // Create a new instance of the TowingCharge model
        $model = new TowingCharge;
        $db = new yii\db\Connection(Yii::$app->db); // Get database connection

        // Check if there's a POST request
        if (Yii::$app->request->post()) {
            $model->load(Yii::$app->request->post());

            // Check if 'ic' is 'Any' or specific region code
            if ($model->ic == 'Any') {
                // print_r('dd');die;
                // If 'ic' is 'Any', call the stored procedure for all interchanges (RptTowingChargeAny)
                $sql_main = "CALL RptTowingChargeAny('" . $model->year . "', '" . $model->month . "')";
                $temp = $db->createCommand($sql_main)->queryAll();
            } else {
                // If 'ic' is not 'Any', call the stored procedure for a specific region (RptTowingCharge)
                $sql_main = "CALL RptTowingCharge('" . $model->year . "', '" . $model->month . "','" . $model->ic . "')";
                $temp = $db->createCommand($sql_main)->queryAll();
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);

            // Render the towing charge report view with the model data and query results
            return $this->render('towingCharge/towingCharge', ['model' => $model, 'results' => $temp, 'icOptions' => $icOptions,]);
        } else {
            // If no POST request, render the form to generate the report
            return $this->render('towingCharge/towingCharge', ['model' => $model, 'icOptions' => [],]);
        }
    }

    public function actionTowingChargeExcel()
    {
        // Decode the POST data containing the results and model information
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel view, passing the results and model to it
        return $this->render('towingCharge/towingChargeExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }

    public function actionTowingChargePdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf(['format' => 'A4']);
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the PDF and pass the results and model to the view
        $mpdf->WriteHTML($this->renderPartial('towingCharge/towingChargePdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        // Output the generated PDF, with a filename that includes the current date and time
        $mpdf->Output('Towing Charge Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

    public function actionUserDetailsReport() {
        $model = new UserDetails();

        if (Yii::$app->request->isPost) {

            $model->load(Yii::$app->request->post());

            $query = "SELECT DISTINCT 
                        U.username AS UserName, 
                        U.superadmin AS SuperAdmin, 
                        D.name AS Designation, 
                        AI.description AS Role,
                        r.name AS Expressway,
                        ic.name AS Interchange,
                        ic.id AS icId
                    FROM user U
                    LEFT JOIN tbl_designation D ON D.id = U.designation_id
                    LEFT JOIN (
                        SELECT ra.user_id, ra.region_id 
                        FROM tbl_region_admin ra 
                        WHERE ra.status = 1
                        UNION ALL
                        SELECT rm.user_id, rm.region_id 
                        FROM tbl_region_manager rm 
                        WHERE rm.status = 1
                    ) AS region_roles ON U.id = region_roles.user_id
                    LEFT JOIN tbl_region r ON r.id = region_roles.region_id
                    LEFT JOIN (
                        SELECT im.user_id, im.ic_id 
                        FROM tbl_ic_manager im 
                        WHERE im.status = 1
                        UNION ALL
                        SELECT ht.user_id, ht.ic_id 
                        FROM tbl_ic_head_tellers ht 
                        WHERE ht.status = 1
                        UNION ALL
                        SELECT htw.user_id, htw.ic_id 
                        FROM tbl_ic_head_tellers_weekend htw 
                        WHERE htw.status = 1
                        UNION ALL
                        SELECT iu.user_id, iu.ic_id 
                        FROM tbl_ic_users iu 
                        WHERE iu.status = 1
                    ) AS ic_roles ON U.id = ic_roles.user_id
                    LEFT JOIN tbl_ic ic ON ic.id = ic_roles.ic_id
                    LEFT JOIN auth_assignment AA ON AA.user_id = U.id
                    LEFT JOIN auth_item AI ON AI.name = AA.item_name
                    WHERE U.id > 0";

                  $params = [];

                    if ($model->region != 'Any' and $model->ic == 'Any') {
                       
                                               
               
                    $ics = Ic::find()->select('id')->where(['region_id'=>$model->region])->all();

                    $ar = [];
                    foreach ($ics as $ic) {
                        array_push($ar, $ic->id);
                    }
                    
                    if (!empty($ar)) {

                        $placeholders = [];
                    }
                        foreach ($ar as $key => $value) {
                            $placeholder = ":ric" . $key;
                            $placeholders[] = $placeholder;
                            $params[$placeholder] = $value;         
                            }

                        $query .= " AND (r.id = :region OR ic.id IN(" . implode(',', $placeholders) . "))";
                        $params[':region'] = $model->region;
                        
                    }

                    if ($model->ic != 'Any') {
                        $query .= " AND ic.id = :ic";
                        $params[':ic'] = $model->ic;
                    }

                    if ($model->designation != 'Any') {
                        $query .= " AND U.designation_id = :designation";
                        $params[':designation'] = $model->designation;
                    }

                    if ($model->status != 'Any') {
                        $query .= " AND U.status = :status";
                        $params[':status'] = $model->status;
                    }

                    if ($model->role != 'Any') {
                        
                        $query .= " AND AI.name = :role_id";
                        $params[':role_id'] = $model->role;
                    }

            $results = Yii::$app->db->createCommand($query, $params)->queryAll();
//            $command = Yii::$app->db->createCommand($query, $params);
//            $results = $command->queryAll();        
//            print_r($command->getRawSql());die;
            return $this->render('userDetailsReport/userDetailsDataReport', [
                        'model' => $model,
                        'results' => $results,
            ]);
        } else {
            return $this->render('userDetailsReport/userDetailsReport', [
                        'model' => $model,
            ]);
        }
    }

    public function actionUserDetailsReportExcel()
    {
        // Decode the POSTed data to get the results and model data
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel report view and pass the decoded results and model to the view
        return $this->render('userDetailsReport/userDetailsReportExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }

    public function actionUserDetailsReportPdf()  
    {   
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial HTML content and pass the results and model to the view for rendering
        $mpdf->WriteHTML($this->renderPartial('userDetailsReport/userDetailsReportPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        // Output the generated PDF with a specific filename and force download ('D' stands for Download)
        $mpdf->Output('User Details Report.pdf', 'D');
        exit();
    }

    public function actionNfcCardReport()
    {
        // Create a new instance of the NfcCardDetails model to hold filter criteria for the report
        $model = new NfcCardDetails();
        
        // Check if the request is a POST request (when the user submits the form)
        if (Yii::$app->request->isPost) {
            $model->load(Yii::$app->request->post());   
            
            // The SQL query to retrieve the NFC card report data
            $query = "
            SELECT NFC.uid AS User_ID, NFC.serial AS Card_Serial, NFCA.vehicle_no AS Allocation,IC.name AS Interchange,R.name AS Expressway,NFCA.remarks AS Remarks, D.name AS Last_Updated_By
                        FROM tbl_nfc_card NFC
                        LEFT JOIN tbl_nfc_allocation NFCA ON NFCA.nfc_card_id = NFC.id
                        LEFT JOIN user U ON NFC.created_by = U.id
                        LEFT JOIN tbl_designation D ON U.designation_id = D.id
                        LEFT JOIN tbl_ic IC ON IC.id = NFCA.ic_id
                        LEFT JOIN tbl_region R ON R.id = IC.region_id
            
        ";

        $params = [];

        // If a specific region is selected, add a filter condition for the region
        if ($model->region != 'Any') {
            $query .= " WHERE R.id = :region";
            $params[':region'] = $model->region;
        }

        // If a specific interchange (IC) is selected, add a filter condition for the interchange
        if ($model->ic != 'Any') {
            $query .= " AND IC.id = :ic";
            $params[':ic'] = $model->ic;
        }

        /*if ($model->serial != 'All') {
            $query .= " AND NFC.serial = :serial";
            $params[':serial'] = $model->serial;
        }*/


        /*if ($model->vehicle_no != 'All') {
            $query .= " AND NFCA.vehicle_no = :vehicle_no";
            $params[':vehicle_no'] = $model->vehicle_no;
        }*/
            
        $results = Yii::$app->db->createCommand($query, $params)->queryAll();

        // Preload IC options for the selected region
        $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
            
            
            // Render the view with the report data (model and results)
            return $this->render('nfcCardReport/nfcCardReport', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions,]);
        } else {
            // Render the initial view when no form is submitted
            return $this->render('nfcCardReport/nfcCardReport', ['model' => $model, 'icOptions' => [],]);
        }
    }

    public function actionNfcCardReportExcel()
    {
        // Decode the JSON-encoded results and model data sent via POST request
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel view for the NFC card report with the results and model data
        return $this->render('nfcCardReport/nfcCardReportExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }

    public function actionNfcCardReportPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the HTML content for the NFC card report PDF
        // The view `nfcCardReport/nfcCardReportPdf` will be used, and the results and model are passed to it
        $mpdf->WriteHTML($this->renderPartial('nfcCardReport/nfcCardReportPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        // Output the generated PDF with the filename 'Nfc Card Report.pdf'
        $mpdf->Output('Nfc Card Report.pdf', 'D');
        exit();
    }

    public function actionIncompleteSessionsReport()
    {
    // Initialize a new instance of IncompleteSessions model for handling report filtering         
    $model = new IncompleteSessions();

    // Check if the request is a POST request
    if (Yii::$app->request->isPost) {
        $model->load(Yii::$app->request->post());   

        // Define the SQL query to fetch data for incomplete login/logout sessions
        $query = "
            SELECT 
    U.username AS tellerID, 
    LLS.login_time AS sessionIn, 
    LLS.logout_time AS sessionOut, 
    LLS.status, 
    SF.shift_name AS traffic, 
    LLS.ticket_count AS amount 
FROM tbl_login_logout_session LLS 
INNER JOIN tbl_shift SF ON SF.id = LLS.shift_id
INNER JOIN tbl_booth B ON B.id = LLS.booth_id
INNER JOIN tbl_ic IC ON IC.id = B.ic_id
INNER JOIN tbl_region R ON R.id = IC.region_id
INNER JOIN user U ON U.id = LLS.user_id
WHERE LLS.id NOT IN 
    (SELECT tbl_cash_collect.actual_session_id FROM tbl_cash_collect WHERE tbl_cash_collect.status=1) 
    AND B.booth_type=2 
    AND LLS.confirmed_status=0 
    AND LLS.login_time >= :startDate 
    AND LLS.login_time <= :endDate

        ";
        // Set parameters for the query based on model input
        $params = [
            ':startDate' => $model->startDate,  // Start date for session filter
            ':endDate' => $model->endDate,      // End date for session filter
        ];

        // Apply additional filters based on the model input (region and ic)
        if ($model->region != 'Any') {
            $query .= " AND R.id = :region";    // Filter by region if specified
            $params[':region'] = $model->region;
        }

        if ($model->ic != 'Any') {
            $query .= " AND IC.id = :ic";       // Filter by IC if specified
            $params[':ic'] = $model->ic;
        }
        // Execute the query and fetch results
        $results = Yii::$app->db->createCommand($query)
            ->bindValues($params)
            ->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
           
            // Render the report view with the model and results
            return $this->render('incompleteSessionsReport/incompleteSessionsReport', ['model' => $model, 'results' => $results, 'icOptions' => $icOptions,]);
        } else {
            // Render the initial report form if no POST data is provided (when the page loads first time)
            return $this->render('incompleteSessionsReport/incompleteSessionsReport', ['model' => $model, 'icOptions' => [],]);
        }

        
    }

    public function actionIncompleteSessionsReportExcel()
    {
        // Decode the JSON data passed via POST for the results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel view and pass the decoded results and model to it for display
        return $this->render('incompleteSessionsReport/incompleteSessionsReportExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }

    public function actionIncompleteSessionsReportPdf()
    {
    // Increase the memory limit to handle large reports and set backtrack limit for regular expressions   
    ini_set('memory_limit', '1024M'); // Increase memory limit to 1GB
    ini_set('pcre.backtrack_limit', '5000000'); // Set a higher backtrack limit to prevent regex errors with large content

    $results = json::decode($_POST['results']);
    $model = json::decode($_POST['model']);

    $mpdf = new \Mpdf\Mpdf();
    $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');

    // Open output buffering to capture the content from the rendered partial view
    ob_start();
    echo $this->renderPartial('incompleteSessionsReport/incompleteSessionsReportPdf', [
        'results' => $results,
        'model' => $model,
    ]);
    $htmlContent = ob_get_clean(); // Capture the HTML content generated by the view

    // Split the generated HTML content into chunks of 50000 characters each to avoid memory overflows or timeouts
    $htmlChunks = str_split($htmlContent, 50000);

    // Write each chunk of HTML to the PDF document
    foreach ($htmlChunks as $chunk) {
        $mpdf->WriteHTML($chunk); // Add the chunk of HTML to the PDF
    }

    $mpdf->Output('Incomplete Sessions Report.pdf', 'D');
    exit();
    }

    public function actionCashResetReport()
    {
     // Initialize a new instance of the CashReset model    
    $model = new CashReset();
    $results = [];// Placeholder for query results

    // Check if the request is a POST request
    if (Yii::$app->request->isPost) {
        // Load data from the POST request into the model
        $model->load(Yii::$app->request->post());

        // Define the SQL query to fetch cash reset report data
        $query = "
            SELECT 
                U.username AS teller, 
                CC.last_reset_at, 
                D1.name AS last_reset_by,
                SUM(CC.total_cash_amount + COALESCE(CC.total_qr_amount, 0)) AS Amount_Before_Reset,
                SUM(EX.amount) AS Amount_After_Reset, 
                CC.comment, 
                D2.name AS created_by 
            FROM tbl_cash_collect CC 
            INNER JOIN tbl_login_logout_session LS ON LS.id = CC.actual_session_id
            INNER JOIN tbl_exit_ticket EX ON EX.shift_id = CC.shift_id
            INNER JOIN tbl_booth B ON B.id = LS.booth_id
            INNER JOIN tbl_ic IC ON IC.id = B.ic_id
            INNER JOIN tbl_region R ON R.id = IC.region_id
            INNER JOIN user U ON U.id = LS.user_id
            INNER JOIN user U1 ON U1.id = CC.last_reset_by
            LEFT JOIN tbl_designation D1 ON D1.id = U1.designation_id
            INNER JOIN user U2 ON U2.id = CC.created_by
            LEFT JOIN tbl_designation D2 ON D2.id = U2.designation_id
            WHERE CC.status = 0 AND CC.last_reset_at >= :startDate AND CC.last_reset_at <= :endDate
            GROUP BY 
            U.username, 
            CC.last_reset_at, 
            D1.name,
            CC.status, 
            CC.comment, 
            D2.name;
        ";
        // Define the parameters for the query based on user input
        $params = [
            ':startDate' => $model->startDate,// Start date filter
            ':endDate' => $model->endDate,    // End date filter
        ];
        // Apply region filter if specified
        if ($model->region != 'Any') {
            $query .= " AND R.id = :region";
            $params[':region'] = $model->region;
        }
        // Apply IC (Interchange) filter if specified
        if ($model->ic != 'Any') {
            $query .= " AND IC.id = :ic";
            $params[':ic'] = $model->ic;
        }

        //$query .= " GROUP BY CC.last_reset_at";
        // Execute the query with the defined parameters and fetch results
        $results = Yii::$app->db->createCommand($query)
            ->bindValues($params)
            ->queryAll();

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
    }
    // Render the cash reset report view with the model and results
    return $this->render('cashResetReport/cashResetReport', [
        'model' => $model, 
        'results' => $results, 
        'icOptions' => $icOptions,
    ]);
    
    }

    public function actionCashResetReportExcel()
    {
        // Decode the JSON data from the POST request for the results and model
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the 'cashResetReportExcel' view with the provided results and model data
        return $this->render('cashResetReport/cashResetReportExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }

    public function actionCashResetReportPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
         // Write the content of the PDF by rendering the 'cashResetReportPdf' partial view
        $mpdf->WriteHTML($this->renderPartial('cashResetReport/cashResetReportPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        // Output the PDF file to download with a specified filename
        $mpdf->Output('Cash Reset Report.pdf', 'D');
        exit();
    }

    public function actionIncompleteTicketReport()
    {
        // Create a new instance of the IncompleteTicket model
        $model = new IncompleteTicket();

        if (Yii::$app->request->isPost) {
            $model->load(Yii::$app->request->post());

            $query = "";// Initialize query string
            $params = [
                ':start_date' => $model->start_date,// Start date parameter for query
                ':end_date' => $model->end_date,    // End date parameter for query
            ];

            // Determine if the query should use archived tables based on the start date
                if ($model->start_date < self::BACKUP_DATE) {

                    if ($model->type == 'entrance') {
                        // Query for incomplete entrance tickets using archived tables
                        $query = "
                            SELECT EN1.serial_no AS entrance_serial, EN1.entrance_time, IC.name AS ic, B.name AS booth, VC.name AS vc, U.username AS teller
                            FROM tbl_entrance_ticket_ar EN1
                            LEFT JOIN tbl_exit_ticket_ar EX ON EN1.serial_no = EX.entrance_barcode
                            LEFT JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            LEFT JOIN tbl_region R ON R.id = IC.region_id
                            LEFT JOIN tbl_booth B ON B.id = EN1.booth_id
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            LEFT JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= :start_date AND EN1.entrance_time <= :end_date 
                            AND EX.entrance_barcode IS NULL  
                        ";
                        // Add region filter if specified
                        if ($model->region != 'Any') {
                            $query .= " AND R.id = :region";
                            $params[':region'] = $model->region;
                        }
                        // Add IC filter if specified
                        if ($model->ic != 'Any') {
                            $query .= " AND EN1.entrance_ic = :ic";
                            $params[':ic'] = $model->ic;
                        }
                    } else {
                        // Query for incomplete exit tickets using archived tables
                        $query = "
                            SELECT ET.entrance_serial, ET.entrance_time, ET.exit_serial, ET.exit_time, ET.amount, IC.name AS ic, B.name AS booth, VC.name AS vc, U.username AS teller
                            FROM tbl_exit_ticket_ar ET
                            LEFT JOIN tbl_entrance_ticket_ar EN1 ON EN1.serial_no = ET.entrance_barcode
                            LEFT JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            LEFT JOIN tbl_region R ON R.id = IC.region_id
                            LEFT JOIN tbl_booth B ON B.id = ET.booth_id
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            LEFT JOIN user U ON U.id = ET.teller_id
                            WHERE EN1.serial_no IS NULL AND ET.exit_time >= :start_date AND ET.exit_time <= :end_date AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'
                        ";
            
                        if ($model->region != 'Any') {
                            $query .= " AND R.id = :region";
                            $params[':region'] = $model->region;
                        }
            
                        if ($model->ic != 'Any') {
                            $query .= " AND ET.exit_ic = :ic";
                            $params[':ic'] = $model->ic;
                        }
                    }
            
                    $results = Yii::$app->db->createCommand($query)
                        ->bindValues($params)
                        ->queryAll();

                        //end backup
                } else {
                    // Similar logic as above, but using non-archived tables
                    if ($model->type == 'entrance') {
                        // Query for incomplete entrance tickets
                        $query = "
                            SELECT EN1.serial_no AS entrance_serial, EN1.entrance_time, IC.name AS ic, B.name AS booth, VC.name AS vc, U.username AS teller
                            FROM tbl_entrance_ticket EN1
                            LEFT JOIN tbl_exit_ticket EX ON EN1.serial_no = EX.entrance_barcode
                            LEFT JOIN tbl_ic IC ON IC.id = EN1.entrance_ic
                            LEFT JOIN tbl_region R ON R.id = IC.region_id
                            LEFT JOIN tbl_booth B ON B.id = EN1.booth_id
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = EN1.vehicle_category
                            LEFT JOIN user U ON U.id = EN1.teller_id
                            WHERE EN1.entrance_time >= :start_date AND EN1.entrance_time <= :end_date 
                            AND EX.entrance_barcode IS NULL  
                        ";
            
                        if ($model->region != 'Any') {
                            $query .= " AND R.id = :region";
                            $params[':region'] = $model->region;
                        }
            
                        if ($model->ic != 'Any') {
                            $query .= " AND EN1.entrance_ic = :ic";
                            $params[':ic'] = $model->ic;
                        }
                    } else {
                        // Query for incomplete exit tickets
                        $query = "
                            SELECT ET.entrance_serial, ET.entrance_time, ET.exit_serial, ET.exit_time, ET.amount, IC.name AS ic, B.name AS booth, VC.name AS vc, U.username AS teller
                            FROM tbl_exit_ticket ET
                            LEFT JOIN tbl_entrance_ticket EN1 ON EN1.serial_no = ET.entrance_barcode
                            LEFT JOIN tbl_ic IC ON IC.id = ET.exit_ic
                            LEFT JOIN tbl_region R ON R.id = IC.region_id
                            LEFT JOIN tbl_booth B ON B.id = ET.booth_id
                            LEFT JOIN tbl_vehicle_category VC ON VC.id = ET.vehicle_category
                            LEFT JOIN user U ON U.id = ET.teller_id
                            WHERE EN1.serial_no IS NULL AND ET.exit_time >= :start_date AND ET.exit_time <= :end_date AND ET.ticket_type_status_id = 1 AND ET.entrance_barcode NOT LIKE '%000000' AND ET.entrance_barcode NOT LIKE 'MANUAL INPUT'
                        ";
            
                        if ($model->region != 'Any') {
                            $query .= " AND R.id = :region";
                            $params[':region'] = $model->region;
                        }
            
                        if ($model->ic != 'Any') {
                            $query .= " AND ET.exit_ic = :ic";
                            $params[':ic'] = $model->ic;
                        }
                    }
            
                    $results = Yii::$app->db->createCommand($query)
                        ->bindValues($params)
                        ->queryAll();

                }
            
                // Render the view with the query results
                return $this->render('incompleteTicketReport/incompleteTicketReportData', ['model' => $model, 'results' => $results]);
            } else {
                return $this->render('incompleteTicketReport/incompleteTicketReport', ['model' => $model]);
            }
    }


    public function actionIncompleteTicketReportExcel()
    {
        // Decode the JSON-encoded results and model data from the POST request
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        // Render the Excel view for the incomplete ticket report
        return $this->render('incompleteTicketReport/incompleteTicketReportExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }

    public function actionIncompleteTicketReportPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Write the HTML content to the PDF
        $mpdf->WriteHTML($this->renderPartial('incompleteTicketReport/incompleteTicketReportPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        // Output the PDF with the filename "Incomplete Ticket Report.pdf"
        // The 'D' parameter forces the download of the file
        $mpdf->Output('Incomplete Ticket Report.pdf', 'D');
        exit();
    }


    public function actionIcList($region_id)
    {
        $ics = Ic::getListByRegion($region_id);
        foreach ($ics as $key => $value) {
            echo "<option value='$key'>$value</option>";
        }
    }


    public function actionDuplicateTicketReport()
    {
        // Initialize a new DuplicateTicket model
        $model = new DuplicateTicket();
        $results = [];
        $totalDuplicateCount = 0;

        // Initialize results array and duplicate count
        if (Yii::$app->request->isPost) {
            // Load data from the POST request into the model
            $model->load(Yii::$app->request->post());

            // Check if the start date is before the backup cutoff date
            if ($model->date_from < self::BACKUP_DATE) {

                // Query to fetch duplicate tickets data from the backup table
                $query = "
            WITH DuplicateTickets AS (
                SELECT 
                    EX1.entrance_serial,
                    COUNT(EX1.id) AS serialCount
                FROM 
                    tbl_exit_ticket_ar EX1
                WHERE 
                    EX1.exit_time <= NOW() + INTERVAL 2 HOUR 
                    AND DATE(EX1.exit_time) = CURRENT_DATE
                GROUP BY 
                    EX1.entrance_serial
                HAVING 
                    COUNT(EX1.id) > 1
            ),
            FirstTicketCounts AS (
                SELECT 
                    EX2.entrance_serial,
                    COUNT(EX2.id) AS firstTicketCount
                FROM 
                    tbl_exit_ticket_ar EX2
                WHERE 
                    EX2.id IN (
                        SELECT MIN(EX3.id)
                        FROM tbl_exit_ticket_ar EX3
                        WHERE EX3.exit_time <= NOW() + INTERVAL 2 HOUR 
                        AND DATE(EX3.exit_time) = CURRENT_DATE
                        GROUP BY EX3.entrance_serial
                    )
                GROUP BY 
                    EX2.entrance_serial
            ),
            TicketCount AS (
                SELECT 
                    (SUM(DT.serialCount) - COALESCE(SUM(FTC.firstTicketCount), 0)) AS tCount
                FROM 
                    DuplicateTickets DT
                LEFT JOIN 
                    FirstTicketCounts FTC ON DT.entrance_serial = FTC.entrance_serial
            )
            SELECT 
                EX.entrance_serial, 
                IC1.name AS entrance_ic, 
                EX.entrance_time, 
                EX.exit_serial, 
                IC2.name AS exit_ic, 
                EX.exit_time, 
                VC.name AS vehicle_category, 
                U.username AS teller, 
                EX.amount,
                (SELECT tCount FROM TicketCount) AS total_count
            FROM 
                tbl_exit_ticket_ar EX
            INNER JOIN 
                tbl_ic IC1 ON IC1.id = EX.entrance_ic
            INNER JOIN 
                tbl_ic IC2 ON IC2.id = EX.exit_ic
            INNER JOIN 
                tbl_region R ON R.id = IC1.region_id
            INNER JOIN 
                tbl_vehicle_category VC ON VC.id = EX.vehicle_category
            INNER JOIN 
                user U ON U.id = EX.teller_id
            WHERE 
                EX.entrance_time >= :date_from 
                AND EX.entrance_time <= :date_to
        ";
        // Set query parameters for filtering
        $params = [
            ':date_from' => $model->date_from,
            ':date_to' => $model->date_to,
        ];
        // Apply region filter if not "Any"
        if ($model->region != 'Any') {
            $query .= " AND R.id = :region";
            $params[':region'] = $model->region;
        }
        // Apply IC filter if not "Any"
        if ($model->ic != 'Any') {
            $query .= " AND EX.entrance_ic = :ic";
            $params[':ic'] = $model->ic;
        }
        // Execute the query and fetch results
        $results = Yii::$app->db->createCommand($query)
            ->bindValues($params)
            ->queryAll();
        // Calculate total duplicate count
        $totalDuplicateCount = count($results);

        // End of backup data query processing

            } else {

                // Similar logic for querying non-backup data table
                $query = "
            WITH DuplicateTickets AS (
                SELECT 
                    EX1.entrance_serial,
                    COUNT(EX1.id) AS serialCount
                FROM 
                    tbl_exit_ticket EX1
                WHERE 
                    EX1.exit_time <= NOW() + INTERVAL 2 HOUR 
                    AND DATE(EX1.exit_time) = CURRENT_DATE
                GROUP BY 
                    EX1.entrance_serial
                HAVING 
                    COUNT(EX1.id) > 1
            ),
            FirstTicketCounts AS (
                SELECT 
                    EX2.entrance_serial,
                    COUNT(EX2.id) AS firstTicketCount
                FROM 
                    tbl_exit_ticket EX2
                WHERE 
                    EX2.id IN (
                        SELECT MIN(EX3.id)
                        FROM tbl_exit_ticket EX3
                        WHERE EX3.exit_time <= NOW() + INTERVAL 2 HOUR 
                        AND DATE(EX3.exit_time) = CURRENT_DATE
                        GROUP BY EX3.entrance_serial
                    )
                GROUP BY 
                    EX2.entrance_serial
            ),
            TicketCount AS (
                SELECT 
                    (SUM(DT.serialCount) - COALESCE(SUM(FTC.firstTicketCount), 0)) AS tCount
                FROM 
                    DuplicateTickets DT
                LEFT JOIN 
                    FirstTicketCounts FTC ON DT.entrance_serial = FTC.entrance_serial
            )
            SELECT 
                EX.entrance_serial, 
                IC1.name AS entrance_ic, 
                EX.entrance_time, 
                EX.exit_serial, 
                IC2.name AS exit_ic, 
                EX.exit_time, 
                VC.name AS vehicle_category, 
                U.username AS teller, 
                EX.amount,
                (SELECT tCount FROM TicketCount) AS total_count
            FROM 
                tbl_exit_ticket EX
            INNER JOIN 
                tbl_ic IC1 ON IC1.id = EX.entrance_ic
            INNER JOIN 
                tbl_ic IC2 ON IC2.id = EX.exit_ic
            INNER JOIN 
                tbl_region R ON R.id = IC1.region_id
            INNER JOIN 
                tbl_vehicle_category VC ON VC.id = EX.vehicle_category
            INNER JOIN 
                user U ON U.id = EX.teller_id
            WHERE 
                EX.entrance_time >= :date_from 
                AND EX.entrance_time <= :date_to
        ";

        $params = [
            ':date_from' => $model->date_from,
            ':date_to' => $model->date_to,
        ];

        if ($model->region != 'Any') {
            $query .= " AND R.id = :region";
            $params[':region'] = $model->region;
        }

        if ($model->ic != 'Any') {
            $query .= " AND EX.entrance_ic = :ic";
            $params[':ic'] = $model->ic;
        }

        $results = Yii::$app->db->createCommand($query)
            ->bindValues($params)
            ->queryAll();

        $totalDuplicateCount = count($results);
            }

            // Preload IC options for the selected region
            $icOptions = $model->region === 'Any' ? IC::getIcListAll() : IC::getICList($model->region);
            
        }
            // Render the results view with the model and results
            return $this->render('duplicateTicketReport/duplicateTicketReport', [
                'model' => $model, 
                'results' => $results,
                'icOptions' => $icOptions,
                'totalDuplicateCount' => $totalDuplicateCount]);
        
        }

    public function actionDuplicateTicketReportExcel()
    {
        $model = json::decode($_POST['model']);
        $results = json::decode($_POST['results']);
        // Decode the total duplicate count from the POST request
        $totalDuplicateCount = json::decode($_POST['totalDuplicateCount']);
        
        // Render the Excel report view with the decoded data
        return $this->render('duplicateTicketReport/duplicateTicketReportExcel', [
            'results' => $results,
            'model' => $model,
            'totalDuplicateCount' => $totalDuplicateCount,
        ]);
    }

    public function actionDuplicateTicketReportPdf()
    {
        $model = json::decode($_POST['model']);
        $results = json::decode($_POST['results']);
        // Decode the total duplicate count from the POST request
        $totalDuplicateCount = json::decode($_POST['totalDuplicateCount']);
        

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        // Render the partial view for the PDF content and pass the necessary data
        $mpdf->WriteHTML($this->renderPartial('duplicateTicketReport/duplicateTicketReportPdf', [
            'results' => $results,
            'model' => $model,
            'totalDuplicateCount' => $totalDuplicateCount,

        ]));
        $mpdf->Output('Duplicate Ticket Report.pdf', 'D');
        exit();
    }
    
    
    public function actionInactiveIcExitTicketReport()
    {
        // Instantiate a new InactiveIcExitTicket model
        $model = new InactiveIcExitTicket(); 
        //$db = new yii\db\Connection(Yii::$app->db);
        // Check if the request is a POST request
        if (Yii::$app->request->isPost) {
            // Load POST data into the model
            $model->load(Yii::$app->request->post()); 
            
            // Determine whether to use the backup table or the main table based on the start date
            if ($model->startDate < self::BACKUP_DATE) {

            // Query for fetching data from the backup table (tbl_exit_ticket_ar)
                $query = "
            SELECT 
                EX.entrance_time,
                EX.exit_time, 
                VC.name AS vehicle_category, 
                B.name AS booth_id, 
                IC1.name AS entrance_ic, 
                IC2.name AS exit_ic,
                U.username AS teller_id, 
                EX.amount, 
                SH.shift_name AS shift_id
            FROM tbl_exit_ticket_ar EX 
            INNER JOIN tbl_ic IC1 ON IC1.id = EX.entrance_ic
            INNER JOIN tbl_ic IC2 ON IC2.id = EX.exit_ic
            INNER JOIN tbl_booth B ON B.id = EX.booth_id
            INNER JOIN tbl_region R ON R.id = IC1.region_id
            INNER JOIN tbl_vehicle_category VC ON VC.id = EX.vehicle_category
            INNER JOIN tbl_shift SH ON SH.id = EX.shift_id
            INNER JOIN user U ON U.id = EX.teller_id
            WHERE IC1.status = 0 AND EX.created_on >= :startDate AND EX.created_on <= :endDate
        ";

        // Define query parameters for filtering by date range
        $params = [
            ':startDate' => $model->startDate,
            ':endDate' => $model->endDate,
        ];

        // Add region filter if a specific region is selected
        if ($model->region != 'Any') {
            $query .= " AND R.id = :region";
            $params[':region'] = $model->region;
        }

        // Add IC filter if a specific IC is selected
        if ($model->ic != 'Any') {
            $query .= " AND EX.entrance_ic = :ic";
            $params[':ic'] = $model->ic;
        }

        // Execute the query and fetch results
        $results = Yii::$app->db->createCommand($query)
            ->bindValues($params)
            ->queryAll();

            //end backup

            } else {

                // Query for fetching data from the main table (tbl_exit_ticket)
                $query = "
            SELECT 
                EX.entrance_time,
                EX.exit_time, 
                VC.name AS vehicle_category, 
                B.name AS booth_id, 
                IC1.name AS entrance_ic, 
                IC2.name AS exit_ic,
                U.username AS teller_id, 
                EX.amount, 
                SH.shift_name AS shift_id
            FROM tbl_exit_ticket EX 
            INNER JOIN tbl_ic IC1 ON IC1.id = EX.entrance_ic
            INNER JOIN tbl_ic IC2 ON IC2.id = EX.exit_ic
            INNER JOIN tbl_booth B ON B.id = EX.booth_id
            INNER JOIN tbl_region R ON R.id = IC1.region_id
            INNER JOIN tbl_vehicle_category VC ON VC.id = EX.vehicle_category
            INNER JOIN tbl_shift SH ON SH.id = EX.shift_id
            INNER JOIN user U ON U.id = EX.teller_id
            WHERE IC1.status = 0 AND EX.created_on >= :startDate AND EX.created_on <= :endDate
        ";

        // Define query parameters for filtering by date range
        $params = [
            ':startDate' => $model->startDate,
            ':endDate' => $model->endDate,
        ];

        // Add region filter if a specific region is selected
        if ($model->region != 'Any') {
            $query .= " AND R.id = :region";
            $params[':region'] = $model->region;
        }

        // Add IC filter if a specific IC is selected
        if ($model->ic != 'Any') {
            $query .= " AND EX.entrance_ic = :ic";
            $params[':ic'] = $model->ic;
        }

         // Execute the query and fetch results
        $results = Yii::$app->db->createCommand($query)
            ->bindValues($params)
            ->queryAll();

            }

            // Render the results view with the model and query results
            return $this->render('inactiveIcExitTicketReport/inactiveIcExitTicketReportResults', ['model' => $model, 'results' => $results]);
        } else {
            // Render the input form view if the request is not a POST request
            return $this->render('inactiveIcExitTicketReport/inactiveIcExitTicketReport', ['model' => $model]);
        }  
    }

    public function actionInactiveIcExitTicketReportPdf()
    {
        // Decode the results and model data from the POST request
        $results = json::decode($_POST['results']); 
        $model = json::decode($_POST['model']);     

        // Initialize the mPDF object for PDF generation
        $mpdf = new \Mpdf\Mpdf();

        // Set the footer of the PDF with the username and current timestamp
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');

        // Generate the PDF content by rendering a partial view and passing the results and model data
        $mpdf->WriteHTML($this->renderPartial('inactiveIcExitTicketReport/inactiveIcExitTicketReportPdf', [
            'results' => $results, 
            'model' => $model,     
        ]));

        // Output the generated PDF as a downloadable file with a specified filename
        $mpdf->Output('Inactive Ic Exit Ticket Report.pdf', 'D');

        // Terminate the script to prevent further execution
        exit();
    }

    
    
    public function actionQrPaymentReport()
    {
        // Instantiate a new CashReset model
        $model = new CashReset();
        $results = [];// Initialize an array to store query results

        // Check if the request is a POST request
        if (Yii::$app->request->isPost) {
            // Load the POST data into the model
            $model->load(Yii::$app->request->post());

            // Define the base query for fetching QR payment report data
            $query = "
                SELECT 
                    U.username AS teller,
                    COALESCE(CC.total_qr_amount, 0.00) AS qr_payment,
                    SH.shift_name AS shift,
                    CC.created_on AS created_on,
                    D.name AS created_by 
                FROM tbl_cash_collect CC 
                INNER JOIN tbl_login_logout_session LS ON LS.id = CC.actual_session_id
                INNER JOIN tbl_booth B ON B.id = LS.booth_id
                INNER JOIN tbl_ic IC ON IC.id = B.ic_id
                INNER JOIN tbl_region R ON R.id = IC.region_id
                INNER JOIN user U ON U.id = LS.user_id
                INNER JOIN user U1 ON U1.id = CC.created_by
                LEFT JOIN tbl_designation D ON D.id = U1.designation_id
                INNER JOIN tbl_shift SH ON SH.id = CC.shift_id
                WHERE CC.created_on >= :startDate AND CC.created_on <= :endDate
            ";

            // Define query parameters for start and end dates
            $params = [
                ':startDate' => $model->startDate,
                ':endDate' => $model->endDate,
            ];

            // If a specific region is selected, add a region filter to the query
            if ($model->region != 'Any') {
                $query .= " AND R.id = :region";
                $params[':region'] = $model->region;
            }

            // If a specific IC is selected, add an IC filter to the query
            if ($model->ic != 'Any') {
                $query .= " AND IC.id = :ic";
                $params[':ic'] = $model->ic;
            }

            // Execute the query with the specified parameters and fetch all results
            $results = Yii::$app->db->createCommand($query)
                ->bindValues($params)// Bind parameters to prevent SQL injection
                ->queryAll();

            // Render the results view with the model and query results
            return $this->render('qrPaymentReport/qrPaymentResult', [
                'model' => $model,
                'results' => $results
            ]);
        } else {
            // Render the input form view if the request is not a POST request
            return $this->render('qrPaymentReport/qrPayment', [
                'model' => $model
            ]);
        }
  
    }

    public function actionQrPaymentReportExcel()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        return $this->render('qrPaymentReport/qrPaymentExcel', [
            'results' => $results,
            'model' => $model,
        ]);
    }
    public function actionQrPaymentReportPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf();
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('qrPaymentReport/qrPaymentPdf', [
            'results' => $results,
            'model' => $model,

        ]));
        $mpdf->Output('QR Payment Report.pdf', 'D');
        exit();
    
    }

    public function actionAuditReport() 
    {
        // Instantiate a new AuditReport model
        $model = new AuditReport;

        // Create a new database connection using the default Yii application configuration
        $db = new yii\db\Connection(Yii::$app->db);

        // Check if the request contains POST data
        if (Yii::$app->request->post()) {
            // Load the POST data into the model
            $model->load(Yii::$app->request->post());

            // Generate an array of dates between the specified start and end dates
            $all_dates = Yii::$app->Dates->getDatesFromRange($model->startDate, $model->endDate);
            $temp = []; // Initialize an array to store the results

            // Check if the start date is earlier than the backup reference date
            if ($model->startDate < self::BACKUP_DATE) {
                // Loop through all the dates in the range and call the backup stored procedure
                foreach ($all_dates as $date) {
                    // Call the backup stored procedure for the current date
                    $sql_main = "CALL Rpt_AuditReport_Backup('" . $date . "')";
                    $res = $db->createCommand($sql_main)->queryOne(); // Execute the query and fetch the result
                    array_push($temp, $res); // Add the result to the temp array
                }
            } else {
                // Loop through all the dates in the range and call the regular stored procedure
                foreach ($all_dates as $date) {
                    // Call the regular stored procedure for the current date
                    $sql_main = "CALL Rpt_AuditReport('" . $date . "')";
                    $res = $db->createCommand($sql_main)->queryOne(); 
                    array_push($temp, $res);
                }
            }

            // Render the audit report view and pass the model and results to the view
            return $this->render('auditReport/auditReport', ['model' => $model, 'results' => $temp]);
        } else {
            // Render the audit report view with the model only if no POST data is provided
            return $this->render('auditReport/auditReport', ['model' => $model]);
        }
    }

        
        
    public function actionAuditReportPdf()
    {
        $results = json::decode($_POST['results']);
        $model = json::decode($_POST['model']);

        $mpdf = new \Mpdf\Mpdf(['orientation' => 'L']);
        $mpdf->setFooter('Report generated by ' . Yii::$app->getUser()->username . '<br> on ' . date('Y-m-d H:i:s') . ' || Page {PAGENO} of {nb}');
        $mpdf->WriteHTML($this->renderPartial('auditReport/auditReportPdf', [
                    'results' => $results,
                    'model' => $model,
        ]));
        $mpdf->Output('Audit Report ' . date('Y-m-d H:i:s') . '.pdf', 'D');
        exit();
    }

}
